<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package BrowserCRM
 * @access private
 */

//default login form settings; 

//this form shouldn't be accessed directly but called by the Authentication system
if (!(strpos($_SERVER['PHP_SELF'],'login.inc.php') === false )) {  //MCR 20051125 / 20060109
	header('Location: ./');
	exit();
}

//default login form settings for when there is no config file - eg a new installation 
//once installation is complete, these settings are overridden by the file config.inc.php
$config = array(
	'login' => array()
);
$config['login']['skin'] = 'aero';
$config['login']['lang'] = 'en';
$config['login']['advanced'] = false;

//this page may be called from a lower level dir; locate top level
//MCR 20060428 $prepend_path = './';

$prepend_path = '';
// Phil 20061122 External web forms need to supply the bcrm_pub_root path
if (isset($bcrm_pub_root)) {
	$prepend_path = substr($bcrm_pub_root, 0, (strlen($bcrm_pub_root) - 4));
}

$i = 0; $max = 4;
while (!file_exists($prepend_path . 'prepend.inc')) {
	if ($i > $max) {
	// error
	}
	$prepend_path = '../' . $prepend_path;
	$i++;
}

require_once($prepend_path . 'prepend.inc');

//this form shouldn't be accessed directly but called by the Authentication system
if (!(strpos($_SERVER['PHP_SELF'],'login.inc.php') === false )) {  //MCR 20051125 / 20060109
	header('Location: index.php');
	exit();
}


// Phil 20060418 - Call authentication service to determine if 'Remember Me' functionality is enabled
$remember_me_enabled = false;
$username_value_str = false;
if (is_object($SERVICES->authentication)) {
	// The variable $remember_me_enabled is used elsewhere in this script
	$remember_me_enabled = $SERVICES->authentication->isRememberMeEnabled();
	// Phil 20060418 This functionality handled elsewhere
	// $has_remember_me_cookie = $SERVICES->authentication->hasRememberMeCookie();
	if ($remember_me_username = $SERVICES->authentication->getRememberMeCookie()) {
		$remember_me_username = substr($remember_me_username, (strpos($remember_me_username, '~#~') + strlen('~#~')));
		$username_value_str = ' value="' . $remember_me_username . '" ';
	}
	// if ($remember_me_enabled && $has_remember_me_cookie) {
		// $SERVICES->authentication->login(array());
	// } 
}
	
//SERVICES may not yet be initialized 
global $BCRM_DOCUMENT_ROOT;

include($BCRM_DOCUMENT_ROOT . '/config.inc.php');

//get language file
include($BCRM_DOCUMENT_ROOT . '/lang/' . $config['login']['lang'] . '/Login.inc');
include($BCRM_DOCUMENT_ROOT . '/lang/' . $config['login']['lang'] . '/_Global.inc');
$start_file = $BCRM_DOCUMENT_ROOT . '/licence/txt/licence.txt';

$websubdir = $config['site']['websubdir'];
$websubdir = trim($websubdir, '/');
if ($websubdir) {
	$websubdir = '/' . $websubdir;
}

//temp til update new v5 config?
// $config['login']['skin'] = 'aero';

// Make sure we use a v5 skin
if (
	!@file_exists($BCRM_DOCUMENT_ROOT . '/skins/' . $config['login']['skin'] . '/') 
	|| !@is_dir($BCRM_DOCUMENT_ROOT . '/skins/' . $config['login']['skin'] . '/') 
) {
	$config['login']['skin'] = 'aero';
}

$base_skin_web_path = $websubdir . '/skins/_base/';
$skin_web_path = $websubdir . '/skins/' . $config['login']['skin'] . '/';
$web_path = $websubdir . '/';

$charset = ( (isset($config['charset']) && $config['charset']) ? $config['charset'] : 'iso-8859-1');
@ini_set('default_charset', $charset);

$content = '';
$content .= '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>' . $L['ApplicationTitle'] . '</title>
	<meta http-equiv="Content-Type" content="text/html; charset=' . $charset . '">
	<link rel="Shortcut Icon" href="' . $skin_web_path . 'favicon.ico" />
	<link href="' . $base_skin_web_path . 'css/login.css" rel="stylesheet" type="text/css">
	<link href="' . $skin_web_path . 'css/login.css" rel="stylesheet" type="text/css">
	<script language="JavaScript" type="text/javascript" src="' . $web_path . 'external/jquery/jquery.js"></script>
	<script language="JavaScript" type="text/javascript" src="' . $web_path . 'js/functions.js"></script>
</head>


<body>

<div id="login">
	<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
    	<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc">
		
		<table border="0" cellpadding="0" cellspacing="0" id="mainTbl">
		  <tr>
			<td>
				<a href="http://www.browsercrm.com" target="_blank"><img src="' . $skin_web_path . 'img/logo.png" title="BrowserCRM" id="mainLogo" border="0"></a>
			</td>
		  </tr>
		  <tr>
		  	<td class="">
				<div align="center" id="title"><h2>' . $L['loginPleaseLogIn'] . '</h2></div>

';

$browser_messages = '';
$browser = $_SERVER['HTTP_USER_AGENT'];

if ((!strpos($browser, 'Opera') === false) ) {
	//$browser_messages .= '<p>Your browser is detected as Opera. As Opera is not fully standards compliant, BrowserCRM will not display correctly. We recommend using Firefox or Internet Explorer with BrowserCRM.</p>';
} else
if ((!strpos($browser, 'MSIE 5.0') === false) ||
	(!strpos($browser, 'MSIE 5.5') === false) ||
	(!strpos($browser, 'MSIE 5.1') === false) ||
	(!strpos($browser, 'MSIE 4') === false) 	
	) {
	$browser_messages .= '<p>Your browser is detected as ' . $browser . '. BrowserCRM will not work correctly with this browser. Please use a modern browser.</p>';
}

if ($browser_messages) {
	$content .= '
			<table border=0 cellpadding=0 cellspacing=0 class="messageTbl" align="center">
			<tr><td valign="top" align="left">' . $browser_messages . '<br>
			</td></tr></table>
	';
}

echo $content;
$content = '';

/**
 * Login page needs a form with elements "login[username]" and "login[password]".
 *
 * Additionally the login page should attempt to mimic the previous page (if the user
 * has been asked to log in halfway through an interaction.
 **/

global $SCRIPT_FILENAME, $PHP_SELF, $HOST, $HTTP_HOST, $BCRM_DOCUMENT_ROOT;

//MCR 20060110
// re historical note: query_string will not contain the ?logout var. 
// This is effectively removed by a header() call in prepend.inc
$form_address = (isset($_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : '');
// Phil 20061110 Dont replace index, this causes problem with some (windows based) servers
//$form_address = str_replace('/index.php', '/', $form_address);  //show clean url; just dir
$query_str = (isset($_SERVER['QUERY_STRING']) ? $_SERVER['QUERY_STRING'] : ''); // Phil 20050315
$form_address .= ($query_str ? '?' . $query_str : '');

$content .= '<form name="login" method="post" action="' . $form_address . '">';

// Phil 20050315
function printFormArray($array, $parent = '') {
	$content = '';
	if (is_array($array)) {
		foreach ($array as $k => $v) { // Phil 20050315
			if ($k != 'submit') {
				if ($parent) {
					$k = $parent . '[' . $k . ']';
				}
				if (is_array($v)) {
					// $v = printFormArray($v, $k);
					$content .= printFormArray($v, $k);
				} else {
					// make $k and $v quote safe:
					$k = str_replace( '\\\'', '\'', addslashes( $k ) );
					$v = str_replace( '\\\'', '\'', addslashes( $v ) );
					$content .= '<input type="hidden" name="' . $k . '" value="' . $v . '">';
				}
			}
		}
	}
	return $content;
}

$content .= printFormArray($_POST);
// print '<div>form:</div>'; print '<pre>' . strip_tags(printFormArray($_POST)) . '</pre>'; print '<hr>'; print_r($_POST); print '<hr>';

/*20060104
$filename = $BCRM_DOCUMENT_ROOT . '/lang/tips.txt';
$fd = @fopen ($filename, "r");
$contents = @fread ($fd, filesize ($filename));
@fclose ($fd);
$tips = explode('*', $contents);
srand((double)microtime()*1000000);
$k = rand(1, (sizeof($tips)-1) );
*/
//<tr><td>&nbsp;</td></tr>

$content .=  '<input type="hidden" name="login[host]" value="1">
	<div class="">
	<table border="0" align="center" cellpadding="0" cellspacing="0" class="loginTbl">
';

global $auth_message;
if (isset($auth_message) && $auth_message) {
	$content .=  '<tr><td colspan="2" align="center" class="authMessage"><strong>' . $auth_message . '</strong></td></tr>';
}

$content .=  '
	<tr>
	<th>' . $L['loginUserName'] . '</th>
	<td>
		<input id="startField" type="text" name="login[username]" ' . $username_value_str . '>
	</td>
	</tr>
	<tr>
	<th>' . $L['loginPassword'] . '</th>
	<td>
		<input type="password" name="login[password]">
	</td>
	</tr>
	<tr>
	<td>&nbsp;</td><td class="commands">
	<a href="javascript:showHideTbody(\'optional\', \'optParam\', \'\', \'\');"><span id="opt-param">' . $L['loginAdvanced'] . '</span></a>
	</td>
	</tr>
	<tbody id="optional" style="display:none;">
	';
	if ($remember_me_enabled) {
		$content .= '
		<tr>
		<th>' . $L['loginRememberMe'] . '</th>
		<td>
			<input type="checkbox" name="login[remember_me]" value="1">
		</td>
		</tr>
		';
	}
	$content .= '
	<tr>
	<th>&nbsp;' . $L['loginSelectSkin'] . '</th>
	<td>
		<select name="login[skin]" id="skin-select">
			<option value=""></option>
			<option value="aero">Aero</option>
			<option value="plain">Pale</option>
			<option value="justblue">Just Blue</option>
			<option value="vista">Vista</option>
		</select>
	</td>
	</tr>
	
	<tr>
	<th>' . $L['loginRebuildCache'] . '</th>
	<td>
		<input type="checkbox" name="login[rebuild_cache]" value="1">
	</td>
	</tr>
	
	
	</tbody>

	<tr>
	<th>&nbsp;</th>
	<td>
		<input type="submit" name="Submit" value="&nbsp;&nbsp;&nbsp;' . $L['loginLogin'] . '&nbsp;&nbsp;&nbsp;">
	</td>
	</tr>
	';
	
	if ($remember_me_enabled && strlen($username_value_str)) {
		$content .= '
		<tr>
		<th>&nbsp;</th>
		<td>
			<a href="?forget=1">' . $L['loginSignOutCompletely'] . '</a>
		</td>
		</tr>
		';
	}
	
	
$content .= '
		</table>
		</div>
		';
// Phil 20060228 Temporarily removed (until implemented)
//$content .= '<span class="commands"';  // align=center>

// if (($_GET['form'] == 'std') || (!$config['login']['advanced'] && (!$_GET['form'] == 'adv'))) { 
	// $content .= '
	// <a href="./?form=adv">' . $L['loginAdvanced'] . '...</a>
	// ';
// } else {
	// //need explicit login=std to override config setting as above
	// $content .= '
	// <a href="./?form=std">' . $L['loginStandard'] . '...</a>
	// ';
// }
//$content .= '</span>';

$content .= '
</form>

<script type="text/javascript">
$(document).ready(function() {
	$(\'#startField\').focus();
});
</script>
';




// Phil 20060228 Temporarily added '1' to if block condition (until advanced login is implemented)
if (1 || ($_GET['form'] == 'std') || (!$config['login']['advanced'] && (!$_GET['form'] == 'adv'))) { 
	//std
} else {  
	//advanced
	$content .= '
	<table border="0" align="center" cellpadding="0" cellspacing="0">
		<tr>
		 <td>' . $L['loginSettings'] . ':</td>
		</tr>
		<tr> 
		 <td>
		  <input type="checkbox" name="login[disable_email_check]" value="1"> ' . $L['loginDontCheckEmail'] . '<br>
		 </td>
		</tr>
		
		<tr>
		 <td>' . $L['loginDeviceType'] . ':</td>
		</tr>
		<tr> 
		 <td>
		
		  <input name="login[display_setting]" type="radio" value="radiobutton" onClick="chgDisp(0,0,0,\'0\');" checked>
		  ' . $L['loginDeviceDesktop'] . '<br>
		  <input type="radio" name="login[display_setting]" value="radiobutton" onClick="chgDisp(1,0,1,\'640\');">
		  ' . $L['loginDevice640'] . '<br> 
		  <input type="radio" name="login[display_setting]" value="radiobutton" onClick="chgDisp(1,1,1,\'240\');">
		  ' . $L['loginDeviceWindows240'] . '<br>
		  <input type="radio" name="login[display_setting]" value="radiobutton" onClick="chgDisp(1,1,1,\'176\');">
		  ' . $L['loginDeviceNokiaSeries60'] . '<br>

		  <ul class="boxed">
		  ' . $L['loginScreenWidth']  . ' <select name="login[width_limit]" id="widthSet" >
			<option value="0" selected>' . $L['loginWidthDesktop'] . '</option>
			<option value="640">640 px</option>
			<option value="240">240 px</option>
			<option value="176">176 px</option>
		   </select><br><br>
		  
		    <input name="login[no_images]" type="checkbox" id="img" value="checkbox">
		  ' . $L['loginNoImages'] . '<br> 
		   <input name="login[text_only]" type="checkbox" id="txt" value="checkbox">
		  ' . $L['loginTextOnly'] . '<br> 
		   <input name="login[page_framed]" type="checkbox" b" id="frmd" value="checkbox">
		  ' . $L['loginNoFrames'] . '<br> <br>
		  
		  </ul>
		 </td>
		</tr>
	</table>';
}	
	
/*
$content .= '
	<tr>
	<td valign="top">
	&nbsp;<br>
	&nbsp;<br>
';
*/

//initialise vars
$edition = ''; 
$uc  = '';
$in  = '';
$v  = '';

$edition = 's';
$start_token = '------ LICENCE FILE DATA -------';
$end_token =   '--------------------------------';  //32


//it is a violation of the terms of the licence agreement to alter or modify the 
//licence id and user count reporting

$database = $config['database']['dbname'];
$table = 'System__users';

$db = '';
$db = @mysql_connect($config['database']['host'], $config['database']['username'], $config['database']['password']); 

@mysql_select_db($database, $db);

//this overwrites $config with the Admin module config
include($BCRM_DOCUMENT_ROOT . '/modules/Admin/module.config');

$gh = $config['admin']['systemusernames'];
if (is_array($gh) && sizeof($gh)) {
	$where = ' WHERE username NOT IN("' . implode('","', $gh) .'") ';
} else {
	$where = 'WHERE 1';
}

$query = 'SELECT count(*) as total FROM ' . $table . $where;
if ($result = mysql_query($query, $db)) {
	while($record = mysql_fetch_array($result)) {
		$uc = $record['total'];	
	}
}

$query = 'SELECT count(*) as total FROM ' . $table . ' ' . $where .' AND last_login <> 0';
if ($result = mysql_query($query, $db)) {
	while($record = mysql_fetch_array($result)) {
		$in = $record['total'];	
	}
}


$database = $config['database']['dbname'];
$table = 'Logger__usage';
$users_table = 'System__users';

// $query = "SELECT count(distinct user_id) as total FROM " . $table . " where timestamp > '" . mktime (0,0,0,date("m"),date("d")-21,date("Y")) . "'";
// 
// if ($result = mysql_query($query, $db)) {
	// while($record = mysql_fetch_array($result)) {
		// $old_uil = $record['total'];	
	// }
// }

$query = "SELECT count(*) as total FROM " . $users_table . " where last_login > '" . mktime (0,0,0,date("m"),date("d")-21,date("Y")) . "'";

if ($result = mysql_query($query, $db)) {
	while($record = mysql_fetch_array($result)) {
		$uil = $record['total'];	
	}
}

$query = 'SELECT count(distinct session_id) as total FROM ' . $table . " where timestamp > '" . mktime (0,0,0,date("m"),date("d")-21,date("Y")) . "'";
if ($result = mysql_query($query, $db)) {
	while($record = mysql_fetch_array($result)) {
		$sil = $record['total'];	
	}
}

if (is_file($start_file)) {
	$fh = fopen($start_file, 'r');
	$start_body = fread($fh, 8192);
	
	$start_body = base64_decode(base64_decode(str_replace(array("\r\n", "\n", "\r", $end_token), '', substr($start_body, strpos($start_body, $start_token) + strlen($start_token)))));
	foreach(explode(',', $start_body) as $k => $v) {
		$v = explode('=', $v);
		$start_properties[trim($v[0])] = trim($v[1]);
	}
}

$dir_inst = @filectime($config['files']['dir']);

if (isset($_GET['skip_newsfeed']) && $_GET['skip_newsfeed']) {
	$skip_newsfeed = $_GET['skip_newsfeed'];	
} else if (isset($config['login']['skip_newsfeed'])) {
	//this config param is an option, although it is not in the default config file
	$skip_newsfeed = $config['login']['skip_newsfeed'];
}

//this overwrites $config with the Front module config
include($BCRM_DOCUMENT_ROOT . '/modules/Front/module.config');

$v = $config['app']['version'];
$l = '17de344cb9c7cabb4aae3f7e85f5d612';

$http_referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
$http_host = (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '');
$lic_id = ( (isset($start_properties) && isset($start_properties['lic_id']) && $start_properties['lic_id']) ? $start_properties['lic_id'] : $l);

$report = base64_encode('e=' . $edition . '&l=' . $lic_id . '&uc=' . $uc . '&in=' . $in . '&v=' . $v . '&nm=' . $http_host . '&uil=' . $uil . '&sil=' . $sil . '&dir_inst=' . $dir_inst . '&rfr=' . $http_referer . '&nt=php' . phpversion());
$get = 'lang=' . $config['login']['lang'] . '&r=' . $report;
//echo base64_decode($report);
//echo $get;

//no longer need ssl path option as above because not using iframe
$pointer = 'http://news5.browsercrm.com/?' . $get;

//for testing old links
// $pointer = 'http://www.browsercrm.com/newspage.php?' . $get;
// $pointer = 'https://www.browsercrm.com/ssl_web/newspage.php?' . $get;

function getDataFromUrlWithCurl($url, $timeout = 10, $show_errors = false) { 
	$ch = curl_init();
	$agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)";
	curl_setopt($ch, CURLOPT_USERAGENT, $agent);

	curl_setopt ($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); // so it will return data into a variable instead of printing out
	curl_setopt($ch,CURLOPT_TIMEOUT,$timeout); // give it a time in seconds to reply
	curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false); //dont validate SSL cert
	$result = curl_exec($ch);

	//echo 'curl: ' . $result;
	if (curl_error($ch)) {
		if ($show_errors) {
			echo curl_error($ch);
		}
		$result = '';
	} else {
		$info = curl_getinfo($ch);
		
		if (empty($info['http_code'])) {
			//echo("No HTTP code was returned");
		} else {
			if ($info['http_code'] >= 400) {
				//http or server error
				//echo 'httpd code: ' .$info['http_code'];
				//dont show error message
				$result = '';
			}
		}

	}
	curl_close($ch); // close cURL handler
		
	//avoid showing '1' which can be returned by blank page
	if ($result == '1') {
		$result = '';
	}
	return $result;
}


if (isset($skip_newsfeed) && $skip_newsfeed) {
	
	$content .= '';
	
} else {
	$content .= '<div align="center">';
	
	if (function_exists('curl_exec')) {
		$news_content = getDataFromUrlWithCurl($pointer . '&iframe=no', 3); //timeout 3 secs;
		if ($news_content) {
			$content .= '&nbsp;<br />';
			$content .= $news_content;
			$content .= '&nbsp;<br />';
		}
	} else {
		
	//MCR removed iframe option
	// if curl didn't find it, don't want to load a blank iframe
		// $content .= '<iframe  id="newsFrame" frameborder="no" width="100%" src="' . $pointer . '"  scrolling="no"></iframe>';
		// Phil - added timeout and stream_* calls
		$timeout = 10;
		$old_dst = @ini_set('default_socket_timeout', $timeout); // PHP >= 4.3.0
		if ($fp = @fopen($pointer, 'r')) {
			@stream_set_timeout($fp, $timeout);
			@stream_set_blocking($fp, 0);
			$news_content = @fread($fp, 8192);
			if ($news_content) {
				$content .= '&nbsp;<br />';
				$content .= $news_content;
				$content .= '&nbsp;<br />';
			}
		}
		
	}
	$content .= '</div>';
	
}


//' &nbsp; ' . $L['labelLicence'] . ': ' . $licence . '
$content .= '
		<div align="center" id="footer">' . $L['labelVersion'] . ': ' . $v . '<br>
		<a href="http://www.browsercrm.com" target="_blank">http://www.browsercrm.com</a></div>
		
			</td>
		 </tr>
		</table>
		</div></div></div>
	<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
</div>

<!-- load ext files here, so the browser can cache them for login; not css as it will override any existing console -->
<script language="JavaScript" type="text/javascript" src="' . $web_path . 'external/ext/adapter/ext/ext-base.js"></script>
<script language="JavaScript" type="text/javascript" src="' . $web_path . 'external/ext/ext-all.js"></script>

</body>
</html>';

echo $content;

?>
