<?php
require_once("../../prepend.inc");
/**
 * Edit data options.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

global $SERVICES;
$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$add =& $SERVICES->getService('DataDefinition', '', 'AdminDataDefinition');

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('Admin');

$SERVICES->getService('Config');

$output =& $SERVICES->getService('Output');

function getFormFields($item) {
	global $L, $add, $SERVICES;
	 
	if (isset($item['field_table']) && $item['field_table']) {
		$module_name = substr($item['field_table'], 0, strpos($item['field_table'], '__'));
		// print '<div>table: ' .$item['field_table'] . ' module: ' . $module_name . '</div>';
		if ($module_name) {
			$lang =& $SERVICES->getService('Language');
			$lang->getLanguage($module_name);
		}
	}
	
	$basic_dropdown = $add->getBooleanDropdownValues();
	$validation_dropdown = $add->getFieldTypeDropdownValues();
	$method_dropdown = array('include' => $L['adminDataOptionsIncludeLabel'], 'exclude' => $L['adminDataOptionsExcludeLabel']);
	// $available_fields = array_flip($add->db->getColumns($item['field_table'])); // Phil - replaced with below - for foreign fields
	// $available_fields = array_flip($add->getFieldNames($item['field_table']));// $add->db->getColumns($item['field_table']);
	// foreach ($available_fields as $k => $v) {
		// $available_fields[$k] = $k;
	// }
	// Phil 20070427 Display label and field key in multi select
	$available_fields_arr = $add->getFieldNames($item['field_table'], true, false, true);
	// print_r($available_fields); exit();
	$available_fields = array();
	foreach ($available_fields_arr as $k => $v) {
		$available_fields[$v['field_key']] = $v['label'] . ( ($v['field_key'] && $v['label']) ? " - " : '') . $v['field_key'];
	}
	// print '<p>fields:'; print_r($available_fields); print '</p>';
	
	$fields = array();
	$fields['id']                  = array('label'=>'', 'field_key'=>'id', 'type'=>'hidden');
	$fields['field_table']         = array('label'=>$L['adminCustomFieldsTableName'], 'field_key'=>'field_table', 'type'=>'hidden', 'text'=>$item['field_table']);
	$fields['type']                = array('label'=>$L['adminCustomFieldsType'], 'field_key'=>'type', 'type'=>'hidden', 'text'=>$item['type']);
	$fields['method']              = array('label'=>$L['adminDataOptionsMethodLabel'], 'field_key'=>'method', 'type'=>'dropdown', 'dropdown_values'=>$method_dropdown);
	$fields['values']              = array('label'=>$L['adminDataOptionsValuesLabel'], 'field_key'=>'values', 'type'=>'multi_select', 'dropdown_values' => $available_fields, 'csv'=>1);
	$fields['exclude_hidden']      = array('label'=>$L['adminDataOptionsExcludeHidden'], 'field_key'=>'exclude_hidden', 'type'=>'dropdown', 'notnull'=>1, 'dropdown_values'=>$basic_dropdown);
	$fields['exclude_calculated']  = array('label'=>$L['adminDataOptionsExcludeCalculated'], 'field_key'=>'exclude_calculated', 'type'=>'dropdown', 'notnull'=>1, 'dropdown_values'=>$basic_dropdown);
	$fields['dropdown_values']     = array('label'=>$L['adminDataOptionsDropdownValues'], 'field_key'=>'dropdown_values', 'type'=>'dropdown', 'notnull'=>1, 'dropdown_values'=>$basic_dropdown);
	// $fields['search_title']        = array('label'=>$L['adminDataOptionsSearchTitle'], 'field_key'=>'search_title',  'type'=>'dropdown', 'dropdown_values' => $available_fields, 'csv'=>1); // Moved to Data Def Fields as 'Display Name field'
	// Could add other options to available_fields, eg time() etc. Also, only show integer or date fields
	//$fields['event_date']          = array('label'=>$L['adminDataOptionsEventDate'], 'field_key'=>'event_date',  'type'=>'dropdown', 'dropdown_values' => $available_fields); // Deprecated v4
	$fields['no_trim']             = array('label'=>$L['adminDataOptionsNoTrim'], 'field_key'=>'no_trim', 'type'=>'dropdown', 'notnull'=>1, 'dropdown_values'=>$basic_dropdown);
	
	foreach ($fields as $k => $v) {
		$fields[$k]['value'] = $item[$v['field_key']];	
	}
	
	return $fields;
}


function doSubmit() {
	global $SERVICES, $PHP_SELF, $L, $mod, $output, $add;
	
	$item = $_POST['item'];
	$delete = (isset($_GET['delete']) && $_GET['delete'] ? $_GET['delete'] : false);
	$restore = (isset($_GET['restore']) && $_GET['restore'] ? $_GET['restore'] : false);
	// print_r($item); print_r($_GET); print_r($_POST); exit();
	
	if (isset($_POST['submit']) && $_POST['submit']) {
		//server-side data validation goes here
		$fields = getFormFields($item);	//get field definitions
		$output->validateFields($item, $fields, $error_msg); //validate $item based on the definitions in $fields; $item values will get updated
		
		if (is_array($error_msg)) {		//if server-side validation errors, return to form
			main( $item['id'], $item, $error_msg);
			exit();
		}
		//any other processing before posting to database
		$field_table = $item['field_table'];
		
		if ($add->setDataOptions($item)) {
			// print '<p>field_table: ' . $field_table . '</p>';
			doRedirect($field_table);
			exit();
		} else {
			// print '<p>setItem returned false</p>';
			$content = $output->getBeginTable();
			$content .= $output->getTextRow($L['adminDataOptionsCannotSetDataOptions']);
			$content .= $output->getTextRow('<a href="' . $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link')  . '">' . $L['Back'] . '</a>');
			$content = $output->getEndTable();
			quickPage($content);
			exit();
		}

	} else if (!empty($delete) && $delete) {
		
		if ($add->deleteDataOption($delete)) { // deleted item
			doRedirect();
		} else {
			$content = $output->getBeginTable();
			$content .= $output->getTextRow($L['adminDataOptionsCannotDeleteDataOptions']);
			$content .= $output->getTextRow('<a href="' . $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link')  . '">' . $L['Back'] . '</a>');
			$content = $output->getEndTable();
			quickPage($content);
			exit();
		}
		
	} else if (!empty($restore) && $restore) {
		
		if ($add->restoreDataOption($restore)) { // deleted item
			doRedirect();
		} else {
			$content = $output->getBeginTable();
			$content .= $output->getTextRow($L['adminDataOptionsCannotRestoreDataOptions']);
			$content .= $output->getTextRow('<a href="' . $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link')  . '">' . $L['Back'] . '</a>');
			$content = $output->getEndTable();
			quickPage($content);
			exit();
		}
		
	}
	
} //doSubmit

function doRedirect($table = '') {
	global $SERVICES;
	
	$extra = '';
	if (!empty($table)) {
		$extra = '?table=' . $table;	
	}
	
	header('Location: ' .  $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link') . $extra);
	exit();
	
}

function main($id = '', $item = '', $error_msg = '') {
	global $SERVICES, $output, $L, $id, $type, $table, $add, $PHP_SELF;
	
	$index_link = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link');
	
	if (!$item) {
		if (!empty($id)) {
			// $add->printDebug('Field edit, main, calling AdminDataDefinition::getField(' . $id . ')');
			$item = $add->getOption($id);
		} else {
			if (empty($table) || empty($type)) {
				doRedirect();
			}
			
			$item = $add->getOptionByType($type, $table);
			
			if (!is_array($item)) {
				// 'New' field
				$item = array(
					'field_table' => $table,
					'type' => $type, 
					'exclude_calculated' => 1, 
					'dropdown_values' => 1
				);
			}
		}
	}
	
	$index_label = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.label');
	
	$content = '';
	$content .= $output->getBeginTable('viewTbl');
	
	$title_menu = array(
		$output->getLinkHref(
			array(
				'href' => $index_link, 
				'text' => ($L[$index_label] ? $L[$index_label] : $index_label), 
			)
		)
	);
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu($title_menu);
	$output->toolbar_link_mode = false;
	
	// $content .= $output->getTitleRow($L['adminCustomFieldsFieldEditLabel'] . ': ' . $item['field_table'] . ' ' . $item['field_key'], $menu);
	$title_text = $L['adminCustomFieldsFieldEditLabel'] . ': ' . $item['field_table'] . ' ' . $item['field_key'];
	
	$content .= $output->getBeginForm($PHP_SELF);
	$content .= $output->getBeginNestedEditTable();
	
	foreach (getFormFields($item) as $k => $v) {
		$content .= $output->getHtmlFieldRow($v, $error_msg[$v['field_key']]);
	}
	
	$content .= $output->getSubmitRow();
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndForm();
	$content .= $output->getEndTable();
	
	
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	// $window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

if (isset($_POST['submit']) || isset($_GET['delete'])|| isset($_GET['restore'])) {
	doSubmit();
}

main();
?>