<?php
require_once("../../prepend.inc");
/**
 * Data options list view.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict('Admin');

$SERVICES->getService('Language');
$mod = $SERVICES->language->getLanguage('Admin');

$output =& $SERVICES->getService('Output');

$add =& $SERVICES->getService('DataDefinition', '', 'AdminDataDefinition');

function main() {
	global $SERVICES, $output, $L, $PHP_SELF, $add, $table;
	
	// set the paging limits
	$total_count = $add->countAllOptions($table);
	$limit = $output->setPagingLimits('frontDefaultListSize', $total_count);
	
	$title_menu = array();
	
	// Set the default order by field
	if (!isset($_GET['sort'])) {
		// Phil 20070427 - When viewing a particular table, sort by type. 
		// Otherwise sort by table.
		if (!isset($table) || !$table) {
			$sort = array(
				'field' => 'field_table',
				'order' => 'asc'
			);
		} else {
			$sort = array(
				'field' => 'type',
				'order' => 'asc'
			);
		}
		
	} else {
		$sort = $_GET['sort'];
	}
	
	$items = $add->getAllOptions($table, $limit, $sort);
	
	$content = '';
	$content .= $output->getBeginTable('bodyTbl');	
	
	if (!empty($table)) { // Remove the 'table' filter ('All')
		$title_menu[] = $output->getLinkHref(
			array(
				'href' => $PHP_SELF,
				'text' => 'ListAll'
			)
		);
	}
	
	$title_menu[] =  $output->getLinkHref( // 'New' link
		array(
			'href' => $SERVICES->config->lookup('modules.Admin.module_edit.data_options_create.link') . $output->updateQueryString(array()),
			'text' => $L['LinkNew']
		)
	);
	
	// $content .= $output->getTitleRow($L['adminDataOptionsIndexLabel'], $title_menu);	
	$content .= $output->getTextRow($L['adminDataOptionsIndexDescription']);
	$content .= $output->getFieldSpacerRow();
	
	$content .= $output->getBeginNestedListTable();
	
	$headers = array(
		'field_table' => array('label'=>$L['adminCustomFieldsTableName']),
		'type'        => array('label'=>$L['adminCustomFieldsFieldType']), 
		'method'      => array('label'=>$L['adminDataOptionsMethodLabel']),
		'values'      => array('label'=>$L['adminDataOptionsValuesLabel']),
		'edit'        => array('label'=>'&nbsp;'),
		'delete'      => array('label'=>'&nbsp;')
	);
	$content .= $output->getHeaderRow($headers, $sort);
	
	$SERVICES->getService('Config');
	$edit_url = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_edit.link');
	
	foreach ($items as $k => $v) {
		$row = array();
		$row['field_table'] = $v['field_table'];
		$row['type'] = $v['type'];
		$row['method'] = $v['method'];
		$row['values'] = str_replace(',', '<br>', $v['values']);
		
		// $row['edit'] = $output->getLinkEdit($edit_url . '?id=' . $v['id']);
		$row['edit'] = $output->getLinkEdit($edit_url . $output->updateQueryString(array('id' => $v['id'])));
		
		if (isset($v['active']) && $v['active']) {
			// $row['delete'] = $output->getLinkDelete($edit_url . '?delete=' . $v['id']);
			$row['delete'] = $output->getLinkDelete($edit_url . $output->updateQueryString(array('delete' => $v['id'])));
		} else {
			$row['delete'] = $output->getLinkHref(
				array(
					// 'href' => $edit_url . '?restore=' . $v['id'],
					'href' => $edit_url . $output->updateQueryString(array('restore' => $v['id'])),
					'text' => $L['LinkRestore']
				)
			);
		}
		$content .= $output->getTableRow($row);
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getPagingRow();
	$content .= $output->getEndTable();
	
	// --
	if (!empty($table)) { // Link to the 'table edit' page (for this table)
		$table_edit_url = $SERVICES->config->lookup('modules.Admin.module_edit.table_edit.link') . $output->updateQueryString(array('table'=>$table));
		$table_edit_link = $output->getLinkHref(
			array(
				'href' => $table_edit_url,
				'text' => 'adminCustomFieldsTableEditLabel'
			)
		);
		$title_menu[] = $table_edit_link;
	}
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu((array)$title_menu);
	$output->toolbar_link_mode = false;
	// --
	
	$title_text = $L['adminDataOptionsIndexLabel'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	// if (!empty($table)) { 
		// $window_layout .= $output->getMenuRow(array($table_edit_link));
	// }
	// $window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

main();
?>