<?php
require_once("../../prepend.inc");
/**
 * Select a module to edit custom fields for.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict('Admin');

$SERVICES->getService('Modules');
$mod =& $SERVICES->modules->getModule('Admin');

$output =& $SERVICES->getService('Output');

function doSelect() {
	global $SERVICES, $ua, $USER, $output, $L, $module;
	if (!empty($module)) {
		header('Location: ' . $SERVICES->config->lookup('modules.Admin.module_edit.table_select.link') . '?module=' . $module);
		exit();
	}
}

function main() {
	global $SERVICES, $ua, $USER, $output, $L, $module, $PHP_SELF;
	if (isset($module)) {
		doSelect();
	}
	$modules = $SERVICES->modules->getModules();
	// This is temporary, until we deal with legacy code in certain modules
	// Also, some modules dont lend themselves to custom fields without writting custom code to utilise them
	$unsupported_modules = array(
		// Text Data definitions
		'Calendar', 
		'Documents', 
		'Memo', 
		
		// Not a good idea to edit these
		'ContactImport',
		
		// Old / unsupported modules
		'CRM',
		'AccountingCashbook',
		'AccountingSettings',
		'AccountingProducts',
		'CustomTracking',
		'CustomBBS', 
		'Conference', 
		'InetLink', 
		'Import', 
		'OrgChart', 
		'RuleSet', 
		'Template', 
		'DiscussBugs',
		'Intranet', 
		'InetLink', 
		'Files', 
		
		//'Mail', 
		//'MailMerge', 
		//'Forum', 
	);
	
	$system_modules = array(
		'UserAdmin',
		'Admin',
		'AdminRoot',
		'AdminTools', 
		'AdminWebsite',
		'AdminLicences',
		'Front', 
		'Search',
		'Import', 
		'Export', 
		'Logger'
	);
	
	foreach ($modules as $k => $v) {
		if (!$ua->adminAccess($USER['user_id'], $v) ) {
 			bcrm_unset($modules, $k);	
		} else if (in_array($v, $system_modules)) {
			bcrm_unset($modules, $k);
		}
	}
	
	$content = '';
	$content .= $output->getBeginTable('viewTbl');	
	// $content .= $output->getTitleRow($L['adminModuleEditIndexLabel']);	
	$content .= $output->getTextRow($L['adminCustomFieldsIndexDescription']);
	$content .= $output->getBeginNestedViewTable();
	
	foreach ($modules as $k => $v) {
		if (in_array($v, $unsupported_modules)) { // This is temporary, until we deal with legacy code in certain modules
			$edit_link = '--';
		} else {
			$edit_link = '<a href="' . $PHP_SELF . '?module=' . $v .'">' . $L['LinkEdit'] . '</a>';
		}
		$content .= $output->getTableRow(array($v, $edit_link));	
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndTable();	
	
	$title = $L['adminModuleEditIndexLabel'];
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

main();
?>
