<?php
/**
 * The data definition for the item table
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

includeWebMAT('dropdown.inc');
 
global $SERVICES;
global $USER;
$SERVICES->getService('Preferences');
$db =& $SERVICES->getService('Database');
$ua =& $SERVICES->getService('Authentication');

$result = $db->quickGetAllRows('creator_id, access, selected',  'Calendar__access', 'user_id=' . $USER['id'] . ' AND access>0', 'creator_id');

$user_list[$USER['username']] = $USER['id'];

if ($result) {
	// $all_users = $ua->users->getUsersList(false, false, true, true); // Phil 20070130 Show deleted users and resources
	$all_users = $ua->users->getAllUsersList();  // Phil 20070130 incl deleted users and resources
	foreach ($result as $key => $item) {
		$user_list[$all_users[$item['creator_id']]] = $item['creator_id'];
	}
}

ksort($user_list);
reset($user_list);
$user_list = array_flip($user_list);
$user_list_size = 10;

if (count($user_list) < 10) {
	$user_list_size = count($user_list);
}

$data_definition = array (
	'fields' => array(
		'id' => array('label'=>'', 'field_key'=>'id', 'type'=>'hidden'),
		'creator_id' => array('label'=>'', 'field_key'=>'creator_id', 'type'=>'hidden'),
		'user_id' => array('label'=>'', 'field_key'=>'user_id', 'type'=>'hidden'),
		'access' => array('label'=>'', 'field_key'=>'access', 'type'=>'hidden'),
		'selected' => array ('label' =>'View Users', 'field_key' => 'selected',  'type'=>'multi_select',  'dropdown_values' => $user_list, 'notnull' =>1,  'size' =>$user_list_size)
	),
	'data_options' => array(
		'access_list' => array(
			'method' => 'exclude',
			'values' => array('id'),
			'options' => array('exclude_hidden' => 0, 'dropdown_values' => 1)
		),
		
		'access_edit' => array(
			'method' => 'include',
			'values' => array('id', 'creator_id', 'user_id', 'access', 'selected'),
			'options' => array('exclude_hidden' => 0, 'dropdown_values' => 1)
		)
	)
	
);

?>