<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

class CalendarAccessWebMATList extends WebMATList {
	
	function getNewLink($contact_id = '') {
		return false;
	}
	
	function useFilters() {
		$this->no_filters = true;
		return false;
	}
	
	function showSearchFilterForm() {
		return false;
	}
	
	function getUsersList($incl_deleted = true, $incl_resources = true) {
		// Phil 20060814
		global $USER, $ua;
		return $ua->users->getUsersList(false, false, $incl_deleted, $incl_resources);
	}
	
	
	function authenticateUser() {
		// print '<div>authenticateUser</div>';
		global $USER, $ua;
		if ($ua->adminAccess($user, $this->module_name)) {
			return $this->getUsersList();
		} else {
			return array( $USER['id'] => $USER['username']);
		}
		
	}

	function getDataContent() {
		global $USER, $SERVICES, $ua, $L;
		$SERVICES->getService('DateLib');
		$table_labels = array();
		
		$table_labels = $this->dd->getDataDictionary();
		$table_labels = $this->excludeCalculated($table_labels);
		
		// $table_labels = $this->headerRowSpacer($table_labels);
		$table_labels = $this->getSubTableHeader($table_labels, false);
		$all_users = $this->getUsersList();
		
		$set_users = $this->authenticateUser();
						
		$this->processPermission();				
		
		$table_content .= $this->output->getBeginRow();
		
		$table_content .= $this->output->getBeginCell(1, '', 'th');
		$table_content .= $L['Username'] . ' &nbsp;';
		$table_content .= $this->output->getEndCell('th');
		
		foreach ($set_users as $creator_id => $creator_name) {
			$table_content .= $this->output->getBeginCell();
			$table_content .= "$creator_name";
			$table_content .= $this->output->getEndCell();
		}
		$table_content .= $this->output->getEndRow();
		
		
		foreach ($all_users as $user_id => $username) {
			$table_content .= $this->output->getBeginRow();
				$table_content .= $this->output->getBeginCell();
				$table_content .="$username";
				$table_content .= $this->output->getEndCell();
			foreach ($set_users as $creator_id => $creator_name) {
				if ($username != $creator_name) {
					$item = $this->getPermission($creator_id, $user_id);
					$access = $item['access'];
					$links = $this->getCustomLink(1, $creator_id, $user_id, $access);
					$table_content .= $this->output->getBeginCell();
					$table_content .=$links['N'] . ' ' . $links['V'] . ' ' . $links['E'] . ' ' . $links['F']; 
					$table_content .= $this->output->getEndCell();
				} else {
					$table_content .= $this->output->getBeginCell();
					$table_content .= $this->output->getEndCell();
				}
			}
			$this->output->addTagContent('lTextCell', 'nowrap', '');
			$table_content .= $this->output->getBeginCell(1, 'lTextCell');
			
			// if (count($set_users) == 1) {
			// 	$table_content .=	'Access to ' . $USER['username'] . " for $username";
			// } else {
			$table_content .=	$L['calendarAccessToAllFor'] . " $username";
			// }
			$table_content .= $this->output->getEndCell();
			$this->output->resetTagContent('lTextCell');
			
			$links = $this->getCustomLink(2, '', $user_id, $access);
			$this->output->addTagContent('lTextCell', 'nowrap', '');
			$table_content .= $this->output->getBeginCell(1, 'lTextCell');
			$table_content .= $links['N'] . ' ' . $links['V'] . ' ' . $links['E'] . ' ' . $links['F'];
			$table_content .= $this->output->getEndCell();
			$this->output->resetTagContent('lTextCell');
			
			$table_content .= $this->output->getEndRow();
		}
		if (count($set_users) !=1) {
			$table_content .= $this->output->getBeginRow();
			$table_content .= $this->output->getBeginCell();
			$table_content .= $this->output->getEndCell();
			
			
			foreach ($all_users as $creator_id => $creator_name) {
				$table_content .= $this->output->getBeginCell();
				$table_content .= $L['calendarPermissionsFor'] . ' ' . $creator_name;
				$table_content .= $this->output->getEndCell();
			}
		
			$table_content .= $this->output->getEndRow();
		
			
			$table_content .= $this->output->getBeginRow();
			$table_content .= $this->output->getBeginCell();
			$table_content .= $this->output->getEndCell();
			
			foreach ($all_users as $creator_id => $creator_name) {
				$links = $this->getCustomLink(3, $creator_id, '', $access);
				$table_content .= $this->output->getBeginCell();
				$table_content .= $links['N'] . '<br>	' . $links['V'] . '<br>' . $links['E'] . '<br>' . $links['F'];
				$table_content .= $this->output->getEndCell();
			}
			
			$table_content .= $this->output->getBeginCell();
			$table_content .= $L['calendarSetAllPermissions'];
			$table_content .= $this->output->getEndCell();
			$links = $this->getCustomLink(4);
			
			$table_content .= $this->output->getBeginCell();
			$table_content .= $links['N'] . ' ' . $links['V'] . ' ' . $links['E'] . ' ' . $links['F'];
			$table_content .= $this->output->getEndCell();
			
			$table_content .= $this->output->getEndRow();
		}
		
		return $table_content;
	}
	
	function getPermission($creator_id, $user_id) {
	
		$item = $this->db_functions->getItems('', '', "creator_id = $creator_id AND user_id = $user_id");
		if ($item){
		    return current($item);
		}	else {
		    return 0;	
		}
		
	}
	
	function setPermission($creator_id, $user_id, $access) {
		$item = $this->getPermission($creator_id, $user_id);
		if (!$item) {
			$item = array();
		}
		$item['creator_id'] = $creator_id;
		$item['user_id'] = $user_id;
		$item['access'] = $access;
		// $item['selected'] = 0; // Phil 20061013 dont set this here (it may already be selected)
		$this->db_functions->setItem($item);
	}
	
	function setAccessAllPermissionFor($user_id, $access) {
		global $ua;
		$set_users = $this->authenticateUser();
		foreach ($set_users as $creator_id => $creator_name)	{
			if ($user_id != $creator_id) {
				$this->setPermission($creator_id, $user_id, $access);
			}
		}
	}
	
	function setCalendarPermissionFor($creator_id, $access) {
		$all_users = $this->getUsersList();
		foreach ($all_users as $user_id => $username)	{
			if ($user_id != $creator_id) {
				$this->setPermission($creator_id, $user_id, $access);
			}
		}
	}
	
	function setAllPermission($access) {
		$all_users = $this->getUsersList();
		foreach ($all_users as $user_id => $username)	{
			foreach ($all_users as $creator_id => $creator_name)	{
				if ($user_id != $creator_id) {
					$this->setPermission($creator_id, $user_id, $access);
				}
			}
		}
	}
	
	function getCustomLink($mode, $creator_id = 0, $user_id = 0, $access = 0) {
		global $L, $ua;
		$all_users = $this->getUsersList();
		
		switch ($mode) {
			case 1:
				$link_href = $this->getFileSetHref('setPermission');
				$link_href = str_replace('%creator_id%', $creator_id, $link_href);
				$link_href = str_replace('%user_id%', $user_id, $link_href);
				
				$links = array(
					'N' =>$access ==0? $L['calendarShortLabelNone'] : $this->output->getLinkHref( array('href' =>str_replace('%access%', 0, $link_href), 'text' => $L['calendarShortLabelNone'], 'title' => $all_users[$creator_id]  . ' ' . $L['calendarNoAccessTo'] . ' '  .  $all_users[$user_id])), 
					'V'	=>$access ==1? $L['calendarShortLabelView'] : $this->output->getLinkHref( array('href' =>str_replace('%access%', 1, $link_href), 'text' => $L['calendarShortLabelView'], 'title' => $all_users[$creator_id]  . ' ' . $L['calendarCanView'] . ' '  .  $all_users[$user_id])),
					'E' =>$access ==2? $L['calendarShortLabelEdit'] : $this->output->getLinkHref( array('href' =>str_replace('%access%', 2, $link_href), 'text' => $L['calendarShortLabelEdit'], 'title' => $all_users[$creator_id]  . ' ' . $L['calendarCanEdit'] . ' '  .  $all_users[$user_id])),
					'F' =>$access ==3? $L['calendarShortLabelFull'] : $this->output->getLinkHref( array('href' =>str_replace('%access%', 3, $link_href), 'text' => $L['calendarShortLabelFull'], 'title' => $all_users[$creator_id]  . ' ' . $L['calendarFullAccessTo'] . ' '  .  $all_users[$user_id]))
				);
				return $links;
			case 2:
				$link_href = $this->getFileSetHref('setAccessAllPermissionFor');
				$link_href = str_replace('%user_id%', $user_id, $link_href);
				$none_link_href = str_replace('%access%', 0, $link_href);
				$view_link_href = str_replace('%access%', 1, $link_href);
				$edit_link_href=  str_replace('%access%', 2, $link_href);
				$full_link_href=  str_replace('%access%', 3, $link_href);
				
				$links = array(
					'N' =>$this->output->getLinkHref( array('href' => $none_link_href , 'text' => $L['calendarPermissionsNone'])), 
					'V'	=>$this->output->getLinkHref( array('href' => $view_link_href , 'text' => $L['calendarPermissionsCanView'])),
					'E' =>$this->output->getLinkHref( array('href' => $edit_link_href , 'text' => $L['calendarPermissionsCanEdit'])),
					'F' =>$this->output->getLinkHref( array('href' => $full_link_href , 'text' => $L['calendarPermissionsFullAccess']))
				);
				return $links;
			
			case 3:
				$link_href = $this->getFileSetHref('setCalendarPermissionFor');
				$link_href = str_replace('%creator_id%', $creator_id, $link_href);
				$none_link_href = str_replace('%access%', 0, $link_href);
				$view_link_href = str_replace('%access%', 1, $link_href);
				$edit_link_href=  str_replace('%access%', 2, $link_href);
				$full_link_href=  str_replace('%access%', 3, $link_href);
				
				$links = array(
					'N' =>$this->output->getLinkHref( array('href' => $none_link_href , 'text' => $L['calendarPermissionsNone'])), 
					'V'	=>$this->output->getLinkHref( array('href' => $view_link_href , 'text' => $L['calendarPermissionsViewable'])),
					'E' =>$this->output->getLinkHref( array('href' => $edit_link_href , 'text' => $L['calendarPermissionsEditable'])),
					'F' =>$this->output->getLinkHref( array('href' => $full_link_href , 'text' => $L['calendarPermissionsFullAccess']))
				);
				return $links;
			
			case 4:
				$link_href = $this->getFileSetHref('setAllPermission');
				$none_link_href = str_replace('%access%', 0, $link_href);
				$view_link_href = str_replace('%access%', 1, $link_href);
				$edit_link_href=  str_replace('%access%', 2, $link_href);
				$full_link_href=  str_replace('%access%', 3, $link_href);
				
				$links = array(
					'N' => $this->output->getLinkHref( array('href' => $none_link_href , 'text' => $L['calendarPermissionsNone'])), 
					'V'	=> $this->output->getLinkHref( array('href' => $view_link_href , 'text' => $L['calendarPermissionsViewable'])),
					'E' =>$this->output->getLinkHref( array('href' => $edit_link_href , 'text' => $L['calendarPermissionsEditable'])),
					'F' =>$this->output->getLinkHref( array('href' => $full_link_href , 'text' => $L['calendarPermissionsFullAccess']))
				);
				return $links;
		}
	}
	
	function processPermission() {
		if ($this->form_values['mode']) {
			switch($this ->form_values['mode']) {
				case 1:
					$this->setPermission($this->form_values['creator_id'], $this->form_values['user_id'], $this->form_values['access']);
					break;
				case 2:
					$this->setAccessAllPermissionFor($this->form_values['user_id'], $this->form_values['access']);
					break;
				case 3:
					$this->setCalendarPermissionFor($this->form_values['creator_id'], $this->form_values['access']);
					break;
				case 4:
					$this->setAllPermission($this->form_values['access']);
					break;
			}
			
		}	
	}
	
}
?>