<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */

/**
 * @package Calendar
 */
class CalendarItemWebMATView extends WebMATView {
	
		
	var $container_name = 'item-container-wide';

	/**
	 * Role key
	 * @var $role_attendee
	 * @access private
	 */
	var $role_no_need_to_attend = 'NoNeedToAttend';
	
	/**
	 * Calculates a calculated value
	 *
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues(& $dd_item, $item) {
		global $L;
		$EventInformation =& $this->getEventInformation($item);
		
		if (!is_object($EventInformation)){
			return;
		}
		
		$EventInformation->db_functions->setMasterIds($item['id']);
		if ($item['is_cancelled']) {
			$dd_item['event_information']['value'] = $L['calendarAppointmentCancel'];
		} else {
			$dd_item['event_information']['value'] = $L['calendarAppointmentCancel'] = '';
			
			// Phil 20060505 Removed label and put user statuses in own table
			$dd_item['event_information']['label'] = '&nbsp;';
			$dd_item['event_information']['value'] .= 
			'&nbsp;</td></tr></table>
			' . $this->output->getBeginTable('bodyTbl') . 
			$EventInformation->getDataContent() . 
			'' . $this->output->getEndTable() . 
			'' . $this->output->getBeginTable('mainTbl')
			;
			
		}
	}
	
	function &getEventInformation($item) {
		$db_functions =& $this->mod->getDatabaseTable('item_user');
		$db_functions->setUnSeenFields($item['id']);
		if (!$this->EventInformation) {
			$this->EventInformation = new CalendarDetailWebMATList('Calendar', 'list', $_POST, $_GET, 'item_user');
		}
		
		return $this->EventInformation;
	}
	
}

includeWebMAT('list.inc');
/**
 * @package Calendar
 */
class CalendarDetailWebMATList extends WebMATList {
	
	/** 
	 * @access private
	 */
	var $user_ids = false;
	
	/**
	 * Role key
	 * @var $role_no_need_to_attend
	 * @access private
	 */
	var $role_no_need_to_attend = 'NoNeedToAttend';
	
	/**
	 * @author Phil Calder
	 */
	function init($module, $data_option, $post = false, $get = false, $table_name = false, $language_overwrite = false) {
		parent::init($module, $data_option, $post, $get, $table_name, $language_overwrite);
		$this->setUserIds();
	}
	
	/**
	 * Disabled in the list - available from the edit page
	 * @return false
	 * @author Phil Calder
	 */
	function getViewLink($id = false) {
		return false;
	}
	
	function getEditLink($id = false) {
		global $L;
		$link_href = $this->getFileSetHref('status_edit');
		$item = $this->db_functions->getItem($id);
		// no edit link if the appoint is not assigned to the user
		if ($item['role_id'] == $this->role_no_need_to_attend) {
			return;
		}
		
		return $this->output->getLinkHref( array('href' => $link_href, 'text' => $L['LinkEdit']));
	}
	 
	/**
	 * Disabled
	 * 
	 * @author Phil Calder
	 */
	function showCheckBoxMenuRow() {
		return false; 
	}
	// function useFilters() {
		// return false; 
	// }
	
	/**
	 * Disabled Config js, calls parent
	 *
	 * @author Phil Calder
	 */
	function getSubTableHeader($cells, $sort) {
		$this->output->req_config_js = false;
		// print '<div>cells and sort:</div>'; print_r($cells); print '<hr>'; print_r($sort); print '<hr>';
		return parent::getSubTableHeader($cells, $sort);
	}
	
	/**
	 * @author Phil Calder
	 */
	function setUserIds() {
		global $SERVICES;
		if (is_object($users = $SERVICES->getService('Users'))) {
			$this->user_ids = $users->getUserIds(false, true); // Include deleted users
		}
	}
	
	/**
	 * @author Phil Calder
	 */
	function getUserIds() {
		return (array)$this->user_ids;
	}
	
	/**
	 * builds a table row
	 *
	 * @param array $item the items array
	 * @param array $alert_ids an array of alert ids
	 * @return string returns a table row with data.
	 * @author Phil Calder
	 */
	function buildListTable($item, $alert_ids = false, $style = false) {
		if (is_array($item) && isset($item['user_id'])) {
			$user_ids = $this->getUserIds();
			// if (!in_array($item['user_id'], $this->getUserIds())) {
			// Phil 20060524 Using variable
			if (!in_array($item['user_id'], $user_ids)) {
				// print '<div>' . $item['user_id'] . ' NOT in:</div>'; print_r($this->getUserIds()); print '<hr>';
				return false;
			}
		}
		return parent::buildListTable($item, $alert_ids, $style);
	}
		
}

?>