<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */
 
/**
 * @package Calendar
 * @author Phil Calder
 */
class CalendarStatusWebMATAdminDropdown extends WebMATAdminDropdown {
	
	/**
	 * Overridden to remove the delete link
	 * 
	 * @param array $row_array The current row (to add links to)
	 * @param integer $id The item id
	 * @return array The current row with links appended to it
	 * @author Phil Calder
	 */
	function getItemLinks($row_array, $id) {
		$row_array = parent::getItemLinks($row_array, $id);
		if (is_array($row_array) && isset($row_array['delete'])) {
			bcrm_unset($row_array, 'delete');
		}
		return $row_array;
	}
	
	/**
	 * Disabled
	 * 
	 * @return boolean false
	 * @author Phil Calder
	 */
	function getNewMenuContent() {
		return false;
	}
}
?>