<?php
require_once("../../prepend.inc");
/**
 * The main display page
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

//print '<div>GET:</div>'; print_r($_GET); print '<hr>';

// Look for 'type'
// 0 - list
// 1 - day view
// 2 - week view
// 3 - month view
// 4 - year view
// default: user pref (fallback - list)

// Look for 'date'
// Look for 'view_users'

class CalendarViewManager {
	
	var $form_values;
	var $view_type;
	function CalendarViewManager() {
		$get = (isset($_GET) ? $_GET : array());
		$post = (isset($_POST) ? $_POST : array());
		$this->form_values = bcrm_array_merge($post, $get);
		// print_r($this->form_values); print '<hr>';
		$this->init();
	}
	
	function init() {
		$this->setViewType();
	}
	
	function setViewType() {
		if (isset($this->form_values['contact_id']) && $this->form_values['contact_id']) {
			$this->view_type = $this->form_values['type'] = 0; 
		} else if (isset($this->form_values['type'])) {
			$this->view_type = (int)$this->form_values['type'];
		} else {
			global $SERVICES;
			$prefs =& $SERVICES->getService('Preferences');
			$default_view = $prefs->getUserPref('calendarDefaultViewType');
			$this->view_type = $this->form_values['type'] = ($default_view ? $default_view : 0);
		}
	}
	
	function getViewType() {
		return $this->view_type;
	}
	
	function main() {
		// print '<div>view type: ' .$this->getViewType() . '</div>';
		$view_type = $this->getViewType();
		$piece_identifier = false;
		switch ($view_type) {
		case 1:
		case 2:
			$piece_identifier = 'main';
			break;
		case 3:
		case 4:
			$piece_identifier = 'year';
			break;
		default:
			$piece_identifier = false;
			break;
		}
		// print '<div>piece_identifier: ' .$piece_identifier . '</div>';
		
		$calendarList = getWebMATObject(
			'WebMATList', 
			'Calendar', 
			array(
				'post' => (array)$this->form_values,
				'piece_identifier' => $piece_identifier
			)
		); 
		
		if (is_object($calendarList)) {
			// print '<div>' . get_class($calendarList) . '</div>';
			
			// -----
			global $L;
	
			$link = array('href' => $calendarList->getFileSetHref('share_setting'),'text' => $L['calendarUserShareSetting']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' => $calendarList->getFileSetHref('select_users_to_view'),'text' => $L['calendarViewUsers']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' => $calendarList->getFileSetHref('display_by_day'),'text' => $L['calendarLinkDay']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' => $calendarList->getFileSetHref('display_by_week'),'text' => $L['calendarLinkWeek']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' => $calendarList->getFileSetHref('display_by_month'),'text' => $L['calendarLinkMonth']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' => $calendarList->getFileSetHref('display_by_year'),'text' => $L['calendarLinkYear']);
			$calendarList->addSecondMenuLinks($link);
			
			$link = array('href' =>$calendarList->getFileSetHref('list'), 'text' => $L['calendarLinkViewAll']);
			$link = str_replace('%contact_id%', '', $link);
			$calendarList->addSecondMenuLinks($link);
			// -----
			
			
			$calendarList->main();
		} else {
			global $L;
			quickPage($L['msgUnknownError']);
		}
	}
}

$calendar_view_manager = new CalendarViewManager();
$calendar_view_manager->main();

?>