<?php
/**
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Contact
 */

/** 
 * @package Contact
 * @author Phil Calder
 */
class ContactDuplicatesWebMATContactView extends WebMATContactView {
	
	function main($return_string = true) {
		// print '<div>checking duplicates for ' . $this->getContactId() . '</div>';
		global $L;
		$this->setTitleText($L['contactContactDuplicates']);
		// $this->output =& $this->getOutput();
		if (! ($this->item_count = $this->countItems())) {
			// print '<div>no duplicates found for ' . $this->getContactId() . '</div>';
			return '';
		}
		
		$content = '';
		
		$content .= $this->output->getBeginTable('pieceTable'); // - header
		// $content .= $this->getHeaderRow();
		
		// foreach ($this->items as $k => $v) {
			// // print '<div>k=' . $k . '</div>'; print_r($v); print '<br>--------------<hr>';
			// $content .= $this->buildListTable($v);
		// }
		$content .= $this->getDataContent();
		$content .= $this->output->getEndTable();
		
		// if ($return_string) {
		return $content;
		// }
		
	}
	
	/**
	 * @return integer 0
	 */
	function countAlerts() {
		return 0;
	}
	
	/**
	 * @return integer The number of duplicates
	 */
	function countItems() {
		$item_count = $this->getDuplicates(true);
		return (int)$item_count;
		// if (is_array($items) && ($item_count = count($items))) {
			// return (int)$item_count;
		// }
		// return false;
	}
	
	function getItems($order_by = false, $limit = false, $where = false, $return_result = false, $simple_query = false) {
		// print '<div>getItems limit: ' . $limit . '</div>' ; print '<hr>';
		$items = $this->getDuplicates(false);
		$max_limit = false;
		if (is_string($limit)) {
			$max_limit = (int)trim(substr($limit, strpos($limit, ',')+1));
		}
		if (!$max_limit) {
			$max_limit = 20;
		}
		// print '<div>max_limit: [' . $max_limit . ']</div>';
		if ($max_limit && is_array($items)) {
			return array_slice($items, 0, $max_limit);
		}
		return $items;
	}
	
	function getDuplicates($count_only = false) {
		// print '<div>getDuplicates count_only: ' . ($count_only ? 'yes' : 'no') . ' ' . $count_only . '</div>';
		if (isset($this->items) && is_array($this->items) && sizeof($this->items)) {
			if ($count_only === true) {
				return sizeof($this->items);
			}
			return $this->items;
		}
		
		// global $SERVICES;
		// $SERVICES->getService('Modules');
		// $contact =& $SERVICES->modules->getModule('Contact');
		// $this->items = $contact->hasDuplicates($this->getContactId());
		// print '<div>mod class: ' .get_class($this->mod). '</div>';
		$this->items = $this->mod->hasDuplicates($this->getContactId());
		// print_r($this->items); print '<hr>';
		if (is_array($this->items) && $count_only) {
			return sizeof($this->items);
		}
		return $this->items;
	}
	
	function setPieceFilter() {
	}
	
	function getEditLink() {
		return '';	
	}
	
	function getAllLink() {
		return '';	
	}
	
	function getNewLink() {
		return '';	
	}
	
	function getViewLink($id = '') {
		return '';
	}
	
	function useFilters() {
		return false;
	}
	
	/**
	 * Whether to show list page 'links' (edit link and menus for each item)
	 *
	 * @return boolean false. Overridden to disable.
	 * @author Phil Calder
	 */
	function showListLinks() {
		return true;
	}
	
	/**
	 * Whether to show list page 'flags' (unseen, edited, alerts)
	 *
	 * @return boolean false. Overridden to disable.
	 * @author Phil Calder
	 */
	function showListFlags() {
		return false;
	}
	
	/**
	 * Specify whether to use an iterator for getItems, or process and return the entire items array
	 *
	 * Added 200512xx. Extend this method for modules which rely on bulk processing 
	 * of items in the {@link afterGetItems} method
	 *
	 * @return boolean true or false (default is true)
	 * @author Phil Calder
	 */
	function useGetItemsIterator() {
		return false;
	}
	
	/**
	 * Adds the contact field to the data definition (if applicable)
	 *
	 * Only for modules which have a contact field and when contact company depth is on
	 * @author Phil Calder
	 */
	function addContactField() {
		return false;
	}
	
	/**
	 * @deprecated
	 */
	function getItemCounts() {
		return '';
	}
	
}
?>