<?php
/**
 * A collection of classes extended from WebMATDatabaseTable
 * 
 * You need an extended class for each table in you module not including the 
 * dropdown tables.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package ContactImport
 */

/**
 * This class handles the database functions for the item table
 * 
 * This module is an extend verison of WebMATDatabaseTable with the table_name 
 * set and the alert_where set.
 * @package ContactImport
 */
class itemContactImportDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for itemContactImportDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function itemContactImportDatabaseTable($module_name, $data_definition) {
		$this->table_name = 'item';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}
}

class fieldMappingContactImportDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for itemContactImportDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function fieldMappingContactImportDatabaseTable($module_name, $data_definition) {
		$this->table_name = 'ContactImport__field_mapping';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}
}

?>