<?php
/**
 * Import module classes.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Import
 * @author Phil Calder
 */
class Fields {
	
	var $fields = '';
	var $data_option = 'import';
	var $table_suffix = 'item';
	
	function getField($id) {
		// print '<p>id = ' . $id . '</p>';
		$fields = $this->getFields();
		if (array_key_exists($id, $fields)) {
			return $fields[$id];
		}
		return false;
	}
	
	function getFields() {
		// print '<p>Fields::getFields</p>';
		if (is_array($this->fields)) {
			return $this->fields;
		}
		
		// print_r(array_keys($modules)); print '<hr>';
		// print_r(array_keys($db_functions)); print '<hr>';
		// print_r(array_keys($fields)); print '<hr>';
		// print_r(array_keys($options)); print '<hr>';
		// print_r($fields); print '<hr>';
		// print_r($options); print '<hr>';
		// sprint_r($data_definitions); print '<hr>';
		//print_r($dictionaries); print '<hr>';
		
		$data_dictionaries = $this->getImportModuleDataDictionaries();
		$this->fields = array();
		foreach ($data_dictionaries as $k => $v) {
			foreach ($v->data_dictionary as $vv) {
				$vv['field_table'] = $k . '__' . $this->table_suffix;
				$vv['id'] = $k . '__' . $this->table_suffix . '.' . $vv['field_key'];
				$vv['size'] = ''; // need to get default size for 'type'
				$this->fields[$vv['id']] = $vv; 
				// print '<div>vv id: ' .$vv['id'] . '</div>';
			}
		}
		// print '<p>-----</p>'; print_r($this->fields); print '<p>+++++</p>';
		return $this->fields;
	}

	function getFieldDropdownValues() {
		$fields = $this->getFields();
		// print_r($fields);
		$dropdown_values = array();
		foreach ($fields as $k => $v) {
			// print '<div>k=' . $k . '</div>'; print_r($v); print '<hr>';	
			$dropdown_values[$k] = substr($k, 0, strpos($k, '__')) . ' - ' . $v['label'];
		}
		return $dropdown_values;
	}
	
	function getImportModuleDataDictionaries() {
		// Define a default ordering
		// Which modules are actually included is determined by getImportModules 
		// and the presence of an 'import' data option.
		// The 'import' data option ($this->data_option) determines which fields are available for each module
		$import_modules = array (
			'Contact',
			'Company',
			'Person',
			'Accounts', // Phil 20060817
			'AddressEmail', 
			'AddressPhone', 
			'AddressFax', // Phil added 20051011
			'AddressPostal', 
			'AddressPhysical',  //MCR 20060710 
			'AddressURL', 
			'Note'
		);
		
		$import_modules = bcrm_array_merge($import_modules, $this->getImportModules());
		// print_r($import_modules);
		
		global $SERVICES;
		$SERVICES->getService('Modules');
		// $dd = $SERVICES->getService('DataDefinition');
		$modules = $db_functions = $fields = $options = $data_dictionaries = $data_definitions = array();
		$this->import_data_dictionaries = array();
		
		foreach ($import_modules as $v) {
			// print '<p>module: ' . $v . '</p>';
			if ( ($modules[$v] =& $SERVICES->modules->getModule($v)) && (is_object($modules[$v]) && method_exists($modules[$v], 'getDatabaseTable')) ) {
				$db_functions[$v] =& $modules[$v]->getDatabaseTable($this->table_suffix);
				if (is_object($db_functions[$v])) {
					// $fields[$v] = $db_functions[$v]->getDataDefinitionFields();
					// $options[$v] = $db_functions[$v]->getDataDefinitionOptions($this->data_option); // Should have custom data option here - not list
					
					if ($db_functions[$v]->dataDefinitionOptionExists($this->data_option)) {
						// print_r($db_functions[$v]->getDataDefinition()); print '<hr>';
						$data_dictionaries[$v] = new WebMATDataDictionary($db_functions[$v]->getDataDefinition(), $this->data_option);
					}
					if (!is_object($data_dictionaries[$v])) {
						bcrm_unset($data_dictionaries, $v);
					}
					// $dictionaries[$v] = $data_definitions[$v]->getDataDictionary();
				} else {
					bcrm_unset($db_functions, $v);
				}
			}
		}
		$this->import_data_dictionaries = $data_dictionaries;
		// print_r($this->import_data_dictionaries);print '<hr>';
		return $this->import_data_dictionaries;
	}
	
	function getImportModules() {
		if (isset($this->import_modules) && is_array($this->import_modules)) {
			return $this->import_modules;
		}
		global $SERVICES;
		$SERVICES->getService('Modules');
		$this->import_modules = $SERVICES->modules->getModules();
		foreach ($this->import_modules as $k => $v) {
			// TODO: use config lookups to exclude/include modules
			if ( ($v == 'AccountingCashbook') || ($v == 'ContactImport')) {
				bcrm_unset($this->import_modules, $k);
			}
		}
		return $this->import_modules;
	}
}
?>