<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package ContactImport
 * @author Phil Calder
 */
 
/**
 * The edit class
 * 
 * @package ContactImport
 * @author Phil Calder
 */
class ContactImportItemWebMATList extends WebMATList {
	
	/**
	 * Adds (optional) import help link
	 *
	 * @return the value you want to add to the description row
	 * @access private
	 */
	//function addToDescription() {
	//function getSummaryContent() {
	function getEndMainContent() {
		
		$content = parent::getEndMainContent();
		
		global $SERVICES;
		//$content = '';
		if (!$SERVICES->isLicenceFileExisting()) {
			$url = $SERVICES->getNewsURL('index', 'io', 'import');
			//$description = '<div><br><a href="http://redirect.browsercrm.com/setup_offer.php" title="" target="_blank"><img src="http://www.browsercrm.com/images/bcrm/appbutton_expressinstall.gif" border="0" width="290" height="82" alt=""></a></div>';
			if (strlen($url)) {
				// print $url . '<hr>';
				$description = $SERVICES->getDataFromUrl($url . '&iframe=no', 3);
				// print $description . '<hr>';
				if (strlen($description)) {
					$padding = true;
					//$content = $this->output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
					$content .= '<div style="width:100%; text-align:center;">' . $description . '</div>';
					//$content .= '</td>' . $this->output->getEndRow(true);
				}
			}
		}
		return $content;
	}
	
	/**
	 * @access private
	 */
	var $load_file_link = 'load_file';
	
	function getLoadLink() {
		global $L;
		$link_href = $this->getFileSetHref($this->load_file_link);
		return $this->output->getLinkEdit($link_href, $L['contactImportLoadFileLink']);
	}
	
	/**
	 * Adds the 'Load' link to the list view
	 */
	function editTableLinks(& $links, $id, $item) {
		global $L;
		// $links['load'] = $this->getLoadLink();
		 $links[$this->load_file_link] = $this->getLoadLink();
	}
	
	/**
	 * Default link is 'Load'
	 */
	function getListTableLinks($item, $identifier, $default = 'edit') {
		$default = $this->load_file_link;
		return parent::getListTableLinks($item, $identifier, $default);
	}
	
}
?>