<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Export
 */

// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences

global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("Export");
$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'exportListSize', '10' );
*/


//
$options = array(
	'' => '', 
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['exportindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[exportindexListSize]", 
		'value' => getPref('exportindexListSize'), 
		'size' => 32, 
		'label' => $L['exportListSize']
	)
);
//

// Make a File Type Selector:
$file_type = array(
		'' => '',
                '1' => 'CSV',
                '2' => 'CSV For Excel',
                //'3' => 'XML'
);

$prefs_items['exportFileType'] = dropDown(
	array(
		'type' => $file_type, 
		'name' => "data[exportFileType]", 
		'value' => getPref('exportFileType'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportFileType'] . ''
	)
);

// Make a field separator Selector:
$field_separator = array(
		'' => '',
                '1' => ',',
                '2' => ';',
                '3' => '[tab]',
                '4' => '|',
                '5' => '[Space]'
);

$prefs_items['exportFieldSeparator'] = dropDown(
	array(
		'type' => $field_separator, 
		'name' => "data[exportFieldSeparator]", 
		'value' => getPref('exportFieldSeparator'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportFieldSeparatorCharacter'] . ''
	)
);


// Make a field enclosed Selector:
$field_enclosed = array(
		'1' => '',
		'2' => '\'',
                '3' => '"',
                '4' => '`'
);

$prefs_items['exportFieldEnclosed'] = dropDown(
	array(
		'type' => $field_enclosed, 
		'name' => "data[exportFieldEnclosed]", 
		'value' => getPref('exportFieldEnclosed'), 
		'size' => 32, 
		'label' => '' .$L['exportDefaultExportFieldEnclosedByCharacter'] . ''
	)
);

// Make a field escaped Selector:
$field_escaped = array(
		'' => '',
                '1' => '\\',
                '2' => '\''
);

$prefs_items['exportFieldEscaped'] = dropDown(
	array(
		'type' => $field_escaped, 
		'name' => "data[exportFieldEscaped]", 
		'value' => getPref('exportFieldEscaped'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportFieldEscapedByCharacter'] . ''
	)
);


// Make a line terminator Selector:
$line_terminator = array(
		'' => '',
                '1' => '\\r\\n (Windows)',
                '2' => '\\n (Unix)',
                '3' => '\\r (Mac)'
);

$prefs_items['exportLineTerminator'] = dropDown(
	array(
		'type' => $line_terminator, 
		'name' => "data[exportLineTerminator]", 
		'value' => getPref('exportLineTerminator'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportLineTerminatorCharacter'] . ''
	)
);

// Make a Excel Version Selector:
$excel_version = array(
		'' => '',
                '1' => 'Windows',
                '2' => 'MAC or Excel 2003'
);

$prefs_items['exportExcelVersion'] = dropDown(
	array(
		'type' => $excel_version, 
		'name' => "data[exportExcelVersion]", 
		'value' => getPref('exportExcelVersion'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportExcelVersion'] . ''
	)
);

// Make a Replace NULL By Selector:
$replace_null_by = array(
		'' => '',
                '1' => '[ Do Not Replace]',
                '2' => 'NULL'
);

$prefs_items['exportReplaceNullBy'] = dropDown(
	array(
		'type' => $replace_null_by, 
		'name' => "data[exportReplaceNullBy]", 
		'value' => getPref('exportReplaceNullBy'), 
		'size' => 32, 
		'label' => '' . $L['exportDefaultExportReplaceNullBy'] . ''
	)
);

//add export rows array to global prefs_rows array
$pref_rows['Export'] = $prefs_items; 

?>