<?php
/**
 * A collection of classes extended from WebMATDatabaseTable
 * 
 * You need an extended class for each table in you module not including the 
 * dropdown tables.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Export
 */

/**
 * This class handles the database functions for the item table
 * 
 * This module is an extend verison of WebMATDatabaseTable with the table_name 
 * set and the alert_where set.
 * 
 */
class itemExportDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for itemExportDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function itemExportDatabaseTable($module_name, $data_definition) {
		global $USER, $SERVICES;
		$this->table_name = 'item';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}

	/**
         * Set the data definition array
         *
         * Sets default value for lock permissions based on user preference
         *
         * @param array $data_definition An array containing the data definition (fields and opt
ions)
         */
	// Bosco 20051208 | Added User Preference
        function setDataDefinition($data_definition){
                global $SERVICES,$L;
                $SERVICES->getService('Language');
                $SERVICES->getService('Preferences');

                $this->mod =& $SERVICES->modules->getModule('Export');

                if (is_array($data_definition['fields'])) { // Phil - it should be, but better to check
                        foreach($data_definition['fields'] as $k => $v){
                                switch ($v['field_key']){
                                        case 'field_enclosed_by':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportFieldEnclosed');
                                        break;
                                        case 'fields_terminated_by':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportFieldSeparator');
                                        break;
                                        case 'field_escaped_by':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportFieldEscaped');
                                        break;
                                        case 'terminate_line_by':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportLineTerminator');
                                        break;
                                        case 'file_type':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportFileType');
                                        break;
                                        case 'excel_version':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportExcelVersion');
                                        break;
                                        case 'replace_null_by':
                                                $data_definition['fields'][$k]['default_value'] = $SERVICES->preferences->getUserPref('exportReplaceNullBy');
                                        break;
                                }
                        }
                }
                parent::setDataDefinition($data_definition);
	}
}
?>