<?php
require_once("../../prepend.inc");
/**
 * Used to edit the default menu layout
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Front
 */

global $SERVICES;
$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict('Admin'); //halt page execution for users who do not have Admin access for the Admin module

includeModule('Front', 'inc/dashboard_layout.inc');        

// hardcode the dropdown config name
$_GET['dropdown_config'] = 'system_dashboard_dropdown';

$_GET['user_id'] = 0;

/**
 * Used to edit the default menu layout
 * 
 * @package Front
 * @author Phil Calder
 */
class DefaultDashboardWebMATAdminDropdown extends DashboardWebMATAdminDropdown {
	
	function DefaultDashboardWebMATAdminDropdown($post, $get, $mini_data_definition = false) {
		parent::DashboardWebMATAdminDropdown($post, $get, $mini_data_definition);
		$this->new_menu_links[] = $this->getResetAllLink();
	}
	
	function beforeDBWrite(& $item) {
		$item['user_id'] = 0;
	}
	
	function getItemsFor($user_id = '') {
		return parent::getItemsFor('default');
	}
	
	function setFixedUserId() {
		$this->user_id_fixed = true;
	}
	
	function userIdIsFixed() {
		return $this->user_id_fixed;
	}
	
	function getResetAllLink() {
		global $L;
		return $this->output->getLinkConfirm(
			'../Front/admin_dashboard_default_layout.php?reset=1',
			$L['frontResetAllUsersMenu'], 
			$L['frontResetAllUsersMenuAreYouSure'], 
			$this->toolbar_link_mode // whether to display as part of the toolbar
		);
	}
	
	function resetForAll() {
		// print '<p>resetForAll</p>';
		global $SERVICES, $USER;
		$ua =& $SERVICES->getService('Authentication');
		if ($ua->adminAccess($USER['user_id'], 'UserAdmin')) {
			// print '<p>reseting</p>';
			$db =& $SERVICES->getService('Database');
			$db->delete(
				'System__dashboard_dropdown', 
				'user_id > 0'
			);
			if ($db->hasError()) {
				$db->printError();	
			}
			$pref_value = $this->getPrefDisplayOtherAlerts();
			$this->setPrefDisplayOtherAlerts($pref_value, true); // Set company pref and override for all users
		}
	}	
	
	/**
	 * Gets the 'Company' preference
	 */
	function getPrefDisplayOtherAlerts() {
		global $SERVICES;
		$prefs =& $SERVICES->getService('Preferences');
		return $prefs->getCompanyPref('frontMenuDisplayOtherAlerts');
	}
	
	/**
	 * Sets the 'Company' preference
	 *
	 * @param boolean $value Whether to show alerts in the Menu for modules not in the users menu setup
	 */
	function setPrefDisplayOtherAlerts($value, $override = false) {
		global $SERVICES;
		$prefs =& $SERVICES->getService('Preferences');
		$value = ($value ? '1' : '0');
		$override = ($override ? '1' : '0');
		return $prefs->setCompanyPref('frontMenuDisplayOtherAlerts', $value, $override);
	}
}

$admin_dropdown = new DefaultDashboardWebMATAdminDropdown($_POST, $_GET);
global $USER;
$admin_dropdown->setFixedUserId();
$admin_dropdown->setUserId();

if (isset($_POST['submit']) || isset($_GET['delete']) || isset($_GET['show_other_alerts']) ) {
	$admin_dropdown->doSubmit();
}
//show the edit page if an id has been supplied
// CUSTOM: run the reset code if reset=1
if (isset($_GET['id'])) {
	$admin_dropdown->edit( $_GET['id'] );
} else if (isset($_GET['reset']) && $_GET['reset']) {
	$admin_dropdown->resetForAll();
	header('Location: ../Front/admin_dashboard_default_layout.php');
	exit();
}

$admin_dropdown->main(); //calls the main function
?>