<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Front
 */
 
/**
 * Desktop display manager
 *
 * @package Front
 * @author Phil Calder
 */
class FrontDesktopWebMATView extends WebMATView {
	
	/**
	 * Default constructor.
	 */
	function FrontDesktopWebMATView() {
		$this->init();
	}

	/**
	 * Initialize this class. Is a stripped version of WebMAT
	 */
	function init() {
		global $SERVICES;
		$this->error = array();
		$this->db =& $SERVICES->getService('Database');
		$SERVICES->getService('Config');
		$this->config =& $SERVICES->config->getModuleConfig('Front');
		$this->output =& $SERVICES->getService('Output');
		$this->result = array();
		$this->module_name = 'Front';
		$this->module_name_lower = 'front';
	}
	
	/**
	 * @author Phil Calder
	 */
	function getDescriptionContent() {
		return false;
	}
	
	/**
	 * Builds content for the page description row
	 *
	 * Description can be 'description' key in the langauge overwrite array,
	 * or 'modulenameDisplayDescription' language key
	 * @return string the description row content
	 */
	function getWelcomeContent() {
		global $L, $SERVICES;
		$content = '';
		$description = '';
		$users =& $SERVICES->getService('Users');
		if ($users->getShowWelcomePage()) {  //old name for Getting Started links
			$description = $this->getGettingStartedContent();
			// if ($description) {
				// $padding = true;
				// $content = $this->output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
				// $content .= $description;
				// $content .= '</td>' . $this->output->getEndRow(true);
			// }
		}
		$content = $description;
		// // Phil 20061024
		// $padding = true;
		// $content .= $this->output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
		// $content .= $this->getFilterTypeLinks();
		// $content .= '</td>' . $this->output->getEndRow(true);
		
		return $content;
	}

	/**
	 * Builds content for the page description row
	 *
	 * Description can be 'description' key in the langauge overwrite array,
	 * or 'modulenameDisplayDescription' language key
	 * @return string the description row content
	 */
	function getGettingStartedContent() {
		global $SERVICES, $L, $USER, $PHP_SELF, $welcome_value;
		$ua =& $SERVICES->getService('Authentication');
		$lang =& $SERVICES->getService('Language');
		$lang->getLanguage('Front');
		$lang->getLanguage('Admin');
		$lang->getLanguage('Contact');
		
		// Phil 20070821
		$default_href_settings = ' target="contentframe" onClick="parent.window.Layout.focusContentPanel()" ';
		
		$form .= '
		<div class="sidebar sidebar_welcome"style="padding:10px">
		
		<form name="welcome_form" action="modules/Front/getting_started.php" method="POST">';
		
		if ( $ua->adminAccess( $USER['user_id'], 'UserAdmin') ) {	
			$lang->getLanguage('UserAdmin');
			$lang->getLanguage('ContactImport');
			// Administrator specific messages/links
			$form .= '
				<h3>' . $L['frontGettingStartedAdministrator'] . '</h3>
					<div style="padding:6px;">
					';
		
					$has_license = false;
					if ($SERVICES->isLicenceFileExisting()) {
						if (!$SERVICES->isExpired()) {
							$has_license = true;
						}
					}

					if (!$has_license)
					{
						$form .= '
						<table cellpadding="2" cellspacing=2 border=0><tr>
						<td><img src="' . $this->output->getSkinWebPath() .'/img/license.png" width="16" height="16" hspace="3"></td>
						<td valign="middle"><a href="javascript:top.Layout.showLicence();" title="' . $L['frontInstallLicense'] . '" target="contentframe">' . $L['frontInstallLicense'] . '</a></td>
						</tr></table>
						';
					} //<td valign="middle"><a href="licence/index.php?framed=1" title="' . $L['frontInstallLicense'] . '" target="contentframe">' . $L['frontInstallLicense'] . '</a></td>
						
						
						$form .= '
						<table cellpadding="2" cellspacing=2 border=0><tr>
						<td><img src="' . $this->output->getSkinWebPath() .'/img/settings.png" width="16" height="16" hspace="3"></td>
						<td valign="middle"><a href="modules/Front/modules.php" title="' . $L['LinkSettings'] . '" ' . $default_href_settings .'>' . $L['LinkSettings'] . '</a></td>
						</tr></table>
						
						<table cellpadding="2" cellspacing=2 border=0><tr>
						<td><img src="' . $this->output->getSkinWebPath() .'/img/user_add.png" width="16" height="16" hspace="3"></td>
						<td valign="middle"><a href="modules/UserAdmin/new_user.php" title="' . $L['LinkSettings'] . ' | ' . $L['useradminAdminCreateNewUser'] . '" ' . $default_href_settings .'>' . $L['useradminAdminCreateNewUser'] . '</a></td>
						</tr></table>
						
						<table cellpadding="2" cellspacing=2 border=0><tr>
						<td><img src="' . $this->output->getSkinWebPath() .'/img/import.png" width="16" height="16" hspace="3"></td>
						<td valign="middle"><a href="modules/ContactImport/index.php" title="' . $L['LinkSettings'] . ' | ' . $L['contactImportModuleLabel'] . '" ' . $default_href_settings .'>' . $L['contactImportModuleLabel'] . '</a></td>
						</tr></table>
						
						<table cellpadding="2" cellspacing=2 border=0><tr>
						<td><img src="' . $this->output->getSkinWebPath() .'/img/settings.png" width="16" height="16" hspace="3"></td>
						<td valign="middle"><a href="modules/UserAdmin/preferences.php" title="' . $L['LinkSettings'] . ' | ' . $L['useradminAdminSetCompanyPreferences'] . '" target="contentframe" ' . $default_href_settings .'>' . $L['useradminAdminSetCompanyPreferences'] . '</a></td>
						</tr></table>
						
					</div>
					
					<div style="padding:4px;"></div>
			';
			
			$front =& $SERVICES->modules->getModule('Front');
			if (empty($arr)) {
				$arr = '';
			}
			$arr .= $front->getBadPasswordsWarning('array');
		}
		$form .= '
					<div style="padding:4px;"></div>
					<h3>' . $L['frontGettingStartedAllUsers'] . '</h3>
					<div style="padding:6px;">
		
					
		';
			
		if ($USER['contact_id']) {
			$form .= '<p><a href="modules/Contact/contact_view.php?id='.$USER['contact_id'].'" ' . $default_href_settings .'>' . $L['frontUpdateYourOwnContactRecord'] . '</a><br>';
		}
		
		$form .='
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/password.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Front/password.php" title="' . $L['LinkSettings'] . ' | ' . $L['frontChangePassword'] . '" ' . $default_href_settings .'>' . $L['frontChangePassword'] . '</a></td>
					</tr></table>
					
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/settings.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Front/preferences.php" title="' . $L['LinkSettings'] . ' | ' . $L['frontSetUserPreferences'] . '" ' . $default_href_settings . '>' . $L['frontSetUserPreferences'] . '</a></td>
					</tr></table>
					
		';
		
		if ($ua->adminAccess($USER['user_id'],'Mail')) {
			$lang->getLanguage('Mail');
			$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/mail_account_in.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Mail/pop_account_edit.php" title="' . $L['LinkSettings'] . ' | ' . $L['mailYourMailAccounts'] . '" ' . $default_href_settings . '>' . $L['frontCreateEmailAccountIn'] . '</a></td>
					</tr></table>
					
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/mail_account_out.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Mail/smtp_account_edit.php" title="' . $L['LinkSettings'] . ' | ' . $L['mailYourMailAccounts'] . '" ' . $default_href_settings . '>' . $L['frontCreateEmailAccountOut'] . '</a></td>
					</tr></table>
			';
		}
		
		//skin selector
		$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/skin.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Front/chooseskin.php" title="' . $L['LinkSettings'] . ' | ' . $L['frontSelectBrowserSkin'] . '" ' . $default_href_settings . '>' . $L['frontSelectBrowserSkin'] . '</a></td>
					</tr></table>
					';
		
		
		/*
		$screen =& $SERVICES->getService('Screen');
		//$mod =& $SERVICES->modules->getModule('Front');
		//$link = $PHP_SELF . '?skin=';
		$skins = $screen->getSkins();
		
		$counter = 0;		
		foreach ($skins as $k => $v) {
				
				if ($counter >=3 ) continue;
				
				$path = $v['dir_name'] . '/';
				
				// Phil 20070301
				$v['name'] = $SERVICES->language->getLanguageText(trim($v['name']), 'Front');
				$v['description'] = $SERVICES->language->getLanguageText(trim($v['description']), 'Front');
				
				$image_content .= '<td style="padding:16px">';
				if (isset($v['screenshot']) && $v['screenshot']) {
					//$content .= '<a target="_top" href="' . $link . urlencode(basename($v['dir_name'])) . '"><img src="' . ($SERVICES->config->lookup('site.websubdir') ? '/' . $SERVICES->config->lookup('site.websubdir') : '' ) . $v['screenshot'] . '" border="0" alt=""></a>';
					$image_content .= '<a href="chooseskin.php"><img src="' . ($SERVICES->config->lookup('site.websubdir') ? '/' . $SERVICES->config->lookup('site.websubdir') : '' ) . $v['screenshot'] . '" border="0" alt="" width="120px" height="80px"></a>';
				} else {
					$image_content .= '&nbsp;';
				}
				$image_content .= '</td>';
				
				$label_content .= '<td valign="top"  style="padding-left:16px; padding-right:16px">';
				//$label_content .= '<a href="chooseskin.php">' . $v['name'] . '</a>';
				$label_content .= $v['name'];
				$label_content .= '</td>';
				
				$counter++;
		}
		
		$content .= '<table border="0">';
		$content .= '<tr>';
		$content .= $image_content;
		$content .= '</tr>';
		$content .= '<tr>';
		$content .= $label_content;
		$content .= '</tr>';
		$content .= '</table>';
		
		$form .= $content;
		*/	
		
		$form .= '</div>
		';
		
		$form .= '
					<div style="padding:4px;"></div>
					<h3>' . $L['frontGettingStartedLinks'] . '</h3>
					<div style="padding:4px;">
					';
		
		//webform
		$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/webform.png" width="16" height="16" hspace="3"></td>
					<td valign="middle">
					<a href="#" onclick="Ext.MessageBox.confirm(\'' . $L['frontExampleWebformDlgTitle'] . '\', \'' . $L['frontExampleWebformDlgExplanation'] . '\', top.Layout.loadWebform);">' . $L['frontExampleWebform'] . '</a>
					</td>
					</tr></table>
					';
					//<a href="javascript:top.Layout.showWebform();" title="' . $L['frontExampleWebform'] . '" target="contentframe">' . $L['frontExampleWebform'] . '</a>
					
		//moduleeditor
		$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/module_editor.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="modules/Admin/admin_module_index.php" title="' . $L['LinkModuleEditor'] . '" ' . $default_href_settings . '>' . $L['LinkModuleEditor'] . '</a></td>
					</tr></table>
					';
					
		//help
		$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/help.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="javascript:top.Layout.showHelp();" title="' . $L['LinkSettings'] . ' | ' . $L['Help'] . '" target="contentframe">' . $L['Help'] . '</a></td>
					</tr></table>
					';
					
		//browsercrm.com
		$form .= '
					<table cellpadding="2" cellspacing=2 border=0><tr>
					<td><img src="' . $this->output->getSkinWebPath() .'/img/web.png" width="16" height="16" hspace="3"></td>
					<td valign="middle"><a href="javascript:top.Layout.showWebsite();" title="browsercrm.com" target="contentframe">' . $L['frontBrowserCRMDotCom'] . '</a></td>
					</tr></table>
					';
					
					
		$form .= '</div>
		';
		
		
		
		
		//always show unchecked; ready to POST to turn off welcome
		// $form .= '<tr><td colspan="2"><br>
		// <input type="hidden" name="welcome_value" value="0"><input name="toggle_welcome" type="checkbox"'.($welcome_value ? '' : '').' onClick="javascript:window.document.forms[\'welcome_form\'].submit();"> ' . $L['frontDoNotShowMeWelcomeScreen'] . '</td></tr>';
		
		// $welcome_value = 0;
		
		if ($welcome_value) {
			$form .= '
			<div style="padding-top:8px;">
				<p><a href="modules/Front/getting_started.php?welcome_value=0" target="contentframe">' . $L['frontDoNotShowMeWelcomeScreen'] . '</a></p>
			</div>
			';
		} else {
			$form .= '
			<div style="padding-top:8px;">
				<p><a href="modules/Front/getting_started.php?welcome_value=1" target="contentframe">' . $L['frontDoShowMeWelcomeScreen'] . '</a></p>
			</div>
			';	
		}
		
		$form .= '
		</form>
		</div>
		';
		
		return $form;
	}

	/**
	 * Build the desktop and display
	 */
	function main () {
		$content = array();
		
		//$content['beginMain']           = $this->getBeginMainContent();
		$content['title']               = $this->getTitleContent();
		//$content['description']         = $this->getDescriptionContent();
		//$content['beginDataCell']       = $this->getBeginDataCell();
		$content['pieces']              = $this->getDesktopPiecesContent();
		//$content['endDataCell']         = $this->getEndDataCell();
		//$content['endMain']             = $this->getEndMainContent();
		return $this->display($content);
	}
	
	function getModules() {
		global $SERVICES, $USER;
		$ua =& $SERVICES->getService('Authentication');
		$desktop_modules = array(
			'Contact',       // Recent
			'Calendar',      // current
			'Tasks',         // Open
			'Opportunities', // sales stage not 0 or 100
			'Mail',          // Inbox Action Required
			'Memo',          // inbox (unseen?)
			'Jobs',          // status: todo
			'Support'        // open
		);
		$users_desktop_modules = array();
		foreach ($desktop_modules as $k => $v) {
			if ($ua->readAccess($USER['user_id'], $v)) {
				$users_desktop_modules[] = $v;
			}
		}
		return $users_desktop_modules;
	}
	
	// TODO: extend to check other modules, eg "[modulename]DesktopFilterType"
	function getFilterType() {
		global $SERVICES;
		$prefs =& $SERVICES->getService('Preferences');
		$pref_name = 'frontDesktopFilterType';
		$pref_value = false;
		if (isset($_GET['piece_filter_type'])) {
			$pref_value = $_GET['piece_filter_type'];
			$prefs->setUserPref($pref_name, $pref_value);
		} else {
			$pref_value = $prefs->getUserPref($pref_name);
		}
		return $pref_value;
	}
	
	function getDesktopPiecesContent() {
		global $L;
		$module_list = $this->getModules();
		$content = $content_other = ''; // build the desktop view content	
		// Build the display content
		$this->output->req_contact_js = true;
		$first = true;
		// initialise tabs string (table)
		$tabs_content = '';
		
		// todo - Phil 20060130 - add a method to Output to load styles (similar to adding js files)
		//$incl_css = '<link rel="stylesheet" type="text/css"  href="' . $this->output->getSkinWebPath() . '/css/contact.css">';
		//$this->output->addToHead($incl_css);
		
		$piece_filter_type = $this->getFilterType(); // 'mine'; // Phil 20061024, TODO: per mod user pref
		// print '<div>piece_filter_type = ' . $piece_filter_type . '</div>';
			
		$first_tab = false;
		$active_tab = false;
		$tabs = array();
		foreach ($module_list as $k => $mod_name) {
			$get_alt_data_option = ( (isset($_GET) && isset($_GET['alt_data_option'])) ? $_GET['alt_data_option'] : false);
			
			$post_args = array('piece_filter_type' => $piece_filter_type);
			$get_args = array('alt_data_option' => $get_alt_data_option);
			
			$mod_desktop_filter = ( (isset($_GET) && isset($_GET[$mod_name . 'DesktopFilter'])) ? $_GET[$mod_name . 'DesktopFilter'] : false);
			if ($mod_desktop_filter !== false) { 
				$get_args[$mod_name . 'DesktopFilter'] = $mod_desktop_filter; // Phil 20070524 
			}
			
			$piece_object = getWebMATObject( 
				'WebMATDesktop', 
				$mod_name, 
				array(
					'data_option' => 'desktop', 
					'post' => $post_args, 
					'get'  => $get_args
				)
			);
			
			// print '<div>piece_object: ' . get_class($piece_object) . ' for module: ' . $mod_name . '</div>';
			if (is_object($piece_object) && isset($piece_object->db_functions)) {
				// print '<div>HAS DB -- piece_object: ' . get_class($piece_object) . ' for module: ' . $mod_name . '</div>';
				$num_mod_found = $piece_object->db_functions->countItems();
				
				$num_mod_alerts_found = 0;
				if ($num_mod_found) {
					$num_mod_alerts_found = $piece_object->db_functions->countAlerts();
				}
				
				$this->num_found += $num_mod_found;
				$piece_identifier = $piece_object->getPieceId();
			
				//simply 1st time through loop
				if (!$first_tab) {
					$first_tab = 'tab' . $piece_identifier;
				}
				
				//first tab with items
				if ((!$active_tab) && $num_mod_found) {
					$active_tab = 'tab' . $piece_identifier;
				}
				
				//tabs array: id, title
				$tabs[] = array(
					'id' => 'tab' . $piece_identifier, 
					'title' => $piece_object->getTitleText() . (($num_mod_found > 0) ? ' ('. $num_mod_found . ')' : ''), 
					// 'disable' => 0, 
					'is_alert' => ((int)$num_mod_alerts_found ? 1 : 0)
				);
				
				
				// Phil - when in print view mode, display a title for each tab
				if ($this->output->isPrintView()) {
					$tabs_content .= '
				<div id="tabTitle' . $piece_identifier . '" class="tab-title">' . $piece_object->getTitleText() . '</div>
				';
				}
				
				
				//### for tabs ###
				$tabs_content .= '
				<div id="tab' . $piece_identifier . '" class="tab-content">
				';
				//
				
				// //for tiles
				// $tabs_content .= '
				// <div id="tab' . $piece_identifier . '" class="desktop-piece x-layout-container">
				 // ';
				
				
				$tabs_content .= $piece_object->main(true);
				
				$tabs_content .= '
				</div>
				';

				unset($piece_object);
				$piece_object = NULL;
			}
		}
		
		$tabs_content = '
		<div id="desktopTabs">
		' . $tabs_content . '
		</div>
		';
		
		//### for tab output ###
		$this->output->initExt();
		$this->output->initTabs('desktopTabs');
		foreach ($tabs as $tab) {
			$this->output->addTab($tab, 'desktopTabs');
		}
		$this->output->setFirstTab($active_tab ? $active_tab : $first_tab, 'desktopTabs');
		//
		
		
		//for tiles
		// $tabs_content .= '
		// <script>
		// 
		// var DesktopPieces = {
			// init : function(){
			// ';
			// foreach ($tabs as $k => $tab) {
				// //$this->output->addTab($tab, 'desktopTabs');
				// $tabs_content .= '
				// var ' . $tab['id'] . ' = new Ext.Resizable(\'' . $tab['id'] . '\', {
						// width: 480,
						// height: 180,
						// minWidth:100,
						// minHeight:50
				// });
				// ';
			// }
		// 
		// 
		// $tabs_content .= '
			// }
		// };
		// 
		// Ext.EventManager.onDocumentReady(DesktopPieces.init, DesktopPieces, true);
		// </script>
		// ';
		
		
		
		return $tabs_content;
	}
	
	function getFilterTypeLinks() {
		global $L;
		$php_self = '';
		$tag_extras = '';
		if ($this->getFilterType() == 'mine') {
			$link_href = $php_self . $this->output->updateQueryString(array('piece_filter_type' => ''));
			$text = $L['LinkAll'];
			$all = $this->output->getLinkHref(
				array(
					'href' => $link_href,
					'text' => $text, 
					'tag_extras' => $tag_extras
				)
			);
			$mine = $L['labelQfilterMine'];
		} else {
			$link_href = $php_self . $this->output->updateQueryString(array('piece_filter_type' => 'mine'));
			$text = $L['labelQfilterMine'];
			$mine = $this->output->getLinkHref(
				array(
					'href' => $link_href,
					'text' => $text, 
					'tag_extras' => $tag_extras
				)
			);
			$all = $L['LinkAll'];
		}
		return '<strong>' . $L['labelSearchFilter'] . ':</strong> ' . $all . ' | ' . $mine;
	}
	
	function getTitleText() {
		global $L;
		return $L['LabelDesktop'];
	}
}
?>