<?php
/**
 * A collection of classes extended from WebMATDatabaseTable
 * 
 * You need an extended class for each table in you module not including the 
 * dropdown tables.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Logger
 */
/**
 * This class handles the database functions for the item table
 * 
 * This module is an extend verison of WebMATDatabaseTable with the table_name 
 * set and the alert_where set.
 * 
 */
class actionsLoggerDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for actionsLoggerDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function actionsLoggerDatabaseTable($module_name, $data_definition) {
		global $USER;
		$this->table_name = 'actions';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}
	
	/**
	 * Adds detail_currency and detail_int1 displays it in the calc field
	 * 
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues(& $dd_item, $item) {
		//$dd_item['calc']['value'] = $dd_item['detail_currency']['value'] + $dd_item['detail_int1']['value']; 
	}

	/**
	 * Overrides the parent method
	 */
	function getFixedWhere($where_array) {
		global $USER;	
		$where_array = $this->arrayMergeReplace($this->fixed_where, $where_array);
		if ($this->getDataOption() == 'list') { 
			// $where_array[] = 'user_id = ' . $USER['user_id'] . ' AND ((`action` in  (1,3,5) and item_id > 0) OR `action` = 2)';
			// Phil 200605 removed user_id from fixed where
			$where_array[] = ' ((`action` in  (1,3,5) and item_id > 0) OR `action` in (0,2))';
		}
		return $where_array;
	}	
	/*
	// Phil 20050714 testing
	function isViewable($id, $item = false) {
		return true;
	}
	// Phil 20050714 testing
	function isEditable($id, $item = false) {
		return true;
	}
	// Phil 20050714 testing
	function isDeleteable($id, $item = false) {
		return true;
	}
	// Phil 20050714 testing
	function isOwner($id, $item = false) {
		return true;
	}
	// Phil 20050714 testing
	function isAdmin($id, $item = false) {
		return true;
	}
	*/
	
}

class errorsLoggerDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for actionsLoggerDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function errorsLoggerDatabaseTable($module_name, $data_definition) {
		global $USER;
		$this->table_name = 'errors';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}
	
	/**
	 * Adds detail_currency and detail_int1 displays it in the calc field
	 * 
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues(& $dd_item, $item) {
		//$dd_item['calc']['value'] = $dd_item['detail_currency']['value'] + $dd_item['detail_int1']['value']; 
	}
}
?>