<?php
/**
 * Mail module POP account view class
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 */

/**
 * Mail POP account view class
 * 
 * @package Mail
 * @author Phil Calder
 *
 */
class MailPop_AccountWebMATView extends WebMATView {
	
	/**
	 * Tests pop account settings if form values flag 'test_account' is set
	 *
	 * Result added to description content via language overwrite array
	 */
	function run() {
		global $L, $SERVICES;
		parent::run();
		$result = false;
		if (isset($this->form_values['test_account']) && $this->form_values['test_account']) {
			$SERVICES->getService('Modules');
			// $acct_id = $_GET['id'];
			$acct_id = $this->form_values['id'];
			if ($acct_id && is_object($mail =& $SERVICES->modules->getModule('Mail'))) {
				if ($mail->checkAccountSettings($acct_id)) {
					// print '<div>success ' . $L['mailPopAccountTestSuccess'] .'</div>';
					$result = $L['mailPopAccountTestSuccess'];
				} else {
					// print '<div>failed</div>';
					$result = $L['mailPopAccountTestFailed'];
				}
			} 
		}
		if ($result) {
			if (!isset($this->language_overwrite) || !is_array($this->language_overwrite)) {
				$this->language_overwrite = array();
			}
			$this->language_overwrite['description'] = $result;
		}
	}
}
?>