<?php
require_once("../../prepend.inc");
/**
 *  Handles the tabluar display of content
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 */

includeWebMAT('process_multi.inc');

class MailProcessMulti extends WebMATProcessMulti {
	
	function doOther() {
		if ($this->method == 'mark_read') {
			$this->markAsRead();
		} else if ($this->method == 'mark_hide') {
			$this->markAsHide();
		} else if ($this->method == 'mark_unhide') {
			$this->markAsUnhide();
		} else if ($this->method == 'mark_required') {
			$this->markAsRequired();
		} else if ($this->method == 'mark_not_required') {
			$this->markAsNotRequired();
		} else if ($this->method == 'mark_checked_in') {
			$this->markAsCheckedIn();
		} else {
			$this->redirectBack();
		}
	}
	
	function markAsRead() {

		foreach ($this->ids as $k => $v) {
			$item = array('id' => $v, 'is_opened' => 1);
			$this->db_functions->setItem($item);
			
			// use the db function since it does the same
			$this->db_functions->setItemSeenStatus($v, 1);
		}
		$this->redirectBack();
	}

	function markAsHide() {

		foreach ($this->ids as $k => $v) {
			// use the db function since it does the same
			$this->db_functions->setItemSeenStatus($v, 3);
		}
		$this->redirectBack();
	}

	function markAsUnhide() {
	
		foreach ($this->ids as $k => $v) {
			// use the db function since it does the same
			$this->db_functions->setItemSeenStatus($v, 1, false);
		}
		$this->redirectBack();
	}

	function markAsRequired() {

		foreach ($this->ids as $k => $v) {
			$item = array('id' => $v, 'action_required' => 1);
			$this->db_functions->setItem($item);
		}
		$this->redirectBack();
	}

	function markAsNotRequired() {

		foreach ($this->ids as $k => $v) {
			$item = array('id' => $v, 'action_required' => 0);
			$this->db_functions->setItem($item);
		}
		$this->redirectBack();
	}
	
	function markAsCheckedIn() {

		foreach ($this->ids as $k => $v) {
			$item = array('id' => $v, 'checked_out' => 0);
			$this->db_functions->setItem($item);
		}
		$this->redirectBack();
	}
}

$process_multi = new MailProcessMulti('Mail', 'mass_list', $_POST, $_GET, 'item');

if (!$_POST['yes'] && !$_POST['no']) {
	$_SESSION['return_page'] = $_SERVER["HTTP_REFERER"];
}
$process_multi->main();
?>
