<?php
require_once("../../prepend.inc");
/**
 * The edit page
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 */

includeWebMAT('edit.inc');

class CustomEdit extends WebMATEdit {

	
	/**
	 * @var integer $form_js_validate sets javascript state for the form
	 * 0 is off
	 * 1 is on (means add js call to form tag AND autogenerate field validation)
	 * 2 is partial on; means just add js call to form tag
	 * @access private
	 */
	var $form_js_validate = 2;
	
	
	function beforeForm(&$id, &$item, &$error_msg) {
		global $SERVICES;
		$item['password'] = base64_decode($item['password']);
		
		
		// Senthil 20050624  Checks the Rich Text Editor content type from user pref. - Begin	
		//$this->setComposeType($item); 
		
		if ($SERVICES->preferences->getUserPref('mailRichTextEditorSwitch') == 1) {
			$this->setupRichTextEditorJavascript(); 
		}
		 // Senthil 20050624  Checks the Rich Text Editor content type from user pref. - End	
		
		// if no 'id', means we're adding, so default the message values
		// to the same as the others
		if (!isset($item['id'])) {
			$item['message_view_group_id'] = $item['view_group_id'];
			$item['message_edit_group_id'] =  $item['edit_group_id'];
			$item['message_owner_group_id'] =  $item['owner_group_id'];
			$item['message_admin_group_id'] =  $item['admin_group_id'];
		}
		
		$this->setupValidateSMTPJavascript();// Saravanakumar 20050625
		
		$this->output->setFormAutoCompleteOff();
	}
	
	function beforeDBWrite(&$item) {
	
		global $USER;
		

		//if its a new record, set the creator id, else unset it
		if (!isset($item['id'])) {
			$item['creator_id'] = $USER['id'];
		}
		
		//base 64 encode the password
		$item['password'] = base64_encode($item['password']);
	}
	
	/**
	* To customize js validateForm() to validate the Host address in SMTP transport and to add trim()
	*
	* @author Senthil 20050625
	*/
	function setupValidateSMTPJavascript() {
		global $L;
		// <script type="text/javascript" src="'. $this->output->getJsWebPath() .'js_functions.js"></script>
		$code = '
		<script type="text/javascript" language="Javascript">
			// Removes leading and ending whitespaces
			function trim (str) {
			  str = ( (this != window) ? this : str);
			  return str.replace(/^\s+/g, \'\').replace(/\s+$/g, \'\');
			}
			function IsEmail(Expression) {
				if (Expression == null)
					return (false);
			
				var supported = 0;
				if (window.RegExp)
				{
					var tempStr = "a";
					var tempReg = new RegExp(tempStr);
					if (tempReg.test(tempStr)) supported = 1;
				}
				if (!supported) 
					return (Expression.indexOf(".") > 2) && (Expression.indexOf("@") > 0);
				var r1 = new RegExp("(@.*@)|(\\.\\.)|(@\\.)|(^\\.)");
				var r2 = new RegExp("^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,3}|[0-9]{1,3})(\\]?)$");
				return (!r1.test(Expression) && r2.test(Expression));
			}
			function validateForm() {
				var message= \'\';
				var account_name = document.forms["mainform"].elements["item[name]"].value;
				var from_name = document.forms["mainform"].elements["item[from_name]"].value;
				var email_address =  document.forms["mainform"].elements["item[email_address]"].value;
				var transport_method = trim(document.forms["mainform"].elements["item[transport_method]"].value);
				var host= document.forms["mainform"].elements["item[host]"].value;
				if (!trim(account_name)) {
					message =  \''. $L['mailSmtpAccountAccountName'] ." ". $L['errEmptyFieldNamed'] .'\' + \'\n\';
				}			
				if (!trim(from_name)) {
					message = message + \''. $L['mailSmtpAccountFromName']." ". $L['errEmptyFieldNamed'] .'\' + \'\n\';
				}	
				if (!trim(email_address)) {
					message = message +  \''. $L['mailSmtpAccountEmailAddress']." ". $L['errEmptyFieldNamed'] .'\' + \'\n\';
				}
				else if (!IsEmail(email_address)) {
					message = message +  \''. $L['errEmail'].'\' + \'\n\';
				}
				if (!transport_method) { 
					message = message +  \''. $L['mailSmtpAccountTransportMethod']." ". $L['errEmptyFieldNamed'] .'\' + \'\n\';
				}
				if (transport_method == \'3\' || transport_method == \'4\') {
					if (!trim(host)) {
						message = message +  \''. $L['mailSmtpAccountHost']." ". $L['errEmptyFieldNamed'] .'\' + \'\n\';
					}
				}										if (message == \'\') {
					return true;
				} else {
					alert(message);
					return false;
				}
			}
		
		</script>';
		$this->output->addToHead($code);
	}

	
	/**
	  This function is not been used  so commented  Senthil.S 20050704  	
	 * Sets up the content for compose mail in Richtext & Plain Text Format, should it be required
	 *
	 * @param array $item
	   
	 // 20050624 Senthil.S :://::  Start   
	function setComposeType(& $item) {
		global $SERVICES;
	
		if (!isset($item['id']) && !isset($this->form_values['hash'])) {

			$default_compose = $SERVICES->preferences->getUserPref('mailBodytype');
		 	$item['compose'] = $default_compose;

			$rich_text_switch = $SERVICES->preferences->getUserPref('mailBodytype');
		$item['compose'] = $default_compose;

		}
		
	}
	*/ 
	function setupRichTextEditorJavascript() {

		$code = '<script type="text/javascript" src="'. $this->output->getJsWebPath() .'rich_text_editor.js"></script>
		
		<script type="text/javascript" language="Javascript">
		// (preferably absolute) URL (including trailing slash) where Xinha is installed
		_editor_url  = "' . $this->output->getJsWebPath() .'RichTextEditor/";
		_editor_lang = "en";      // And the language we need to use in the editor.

		// name of the textarea that will get the editor
		xinha_editors_main = [\'message_signature\'];
		</script>

		<script type="text/javascript" src="' . $this->output->getJsWebPath() .'RichTextEditor/htmlarea.js"></script>
		';
		
		$this->output->addToHead($code);
	}
	
	//  20050624 Senthil .S :://:: End
	
	/* Saravanakumar :: 20050702 
	* Function overrided from webmat_edit.inc to validate Host address
	* on SMTP transport method
	*/
	function run() {
		//Saravanakumar :: To check whether SMTP transport, if so, set notnull = 1 to Host
		if ($this->form_values['item']['transport_method'] == 3 ||
		   $this->form_values['item']['transport_method'] == 4) {
			$this->dd->changeAttributes(array('field_key'=>'host', 'notnull' =>1));
		}
		
		parent::run();
		
	}
	
}

$customEdit = new CustomEdit('Mail', 'edit', $_POST, $_GET, 'smtp_account'); 
$customEdit->run();
$customEdit->main();
?>
