<?php
/**
 * Used to display info from the module in a contact view
 * 
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Memo
 *
 */

class MemoItemWebMATBookmarkDashboard extends WebMATBookmarkDashboard {
	
	/**
	 * Sets the default piece filter
	 * Sent to a group the current user is in; the current user has not seen the memo; is in the inbox
	 */
	function getDefaultPieceFilter() {
		global $USER;
		$this->db_functions->resetDesignTimeFilters();
		$filter_info = array(
			'type' => 'sql',
			'value' => 0,
			'options' => array(
				'0' => array(
					'label' => 'memoInBox',
					'where' => 'Memo__item.creator_id <> \'' . $USER['user_id'] . '\' AND Memo__item_group.group_id	IN (' . $USER['group_string'] . ') AND Memo__item_seen.seen < 3'
				)
			)
		);
		$this->db_functions->setFilter($filter_info);
	}
	
	/** 
	 * Remove certain links
	 *
	 * Dont display an edit link for Memos.
	 * Dont display a Reply link for sent items
	 *
	 * @author Phil Calder
	 */
	function editTableLinks(& $links, $id, $item) {
		print '<p>editTableLinks</p>';
		global $USER;
		if ($id) {	
			$filter_info = $this->getFilterInfo();
			bcrm_unset($links, 'edit');
			 
			if ($item['creator_id'] == $USER['user_id']) {
				$links['memoReply'] = '';
			}
		}
	}
	
}

?>