<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Note
 */


// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences


global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("Note");
$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'noteListSize', '10' );
*/


//
$options = array(
	'' => '', 
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['noteindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[noteindexListSize]", 
		'value' => getPref('noteindexListSize'), 
		'size' => 32, 
		'label' => $L['noteListSize']
	)
);
//

//add note rows array to global prefs_rows array
$pref_rows['Note'] = $prefs_items; 

?>