<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Opportunities
 */


// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences


global $SERVICES, $L;
	
$SERVICES->getService('Modules');

$mod =& $SERVICES->modules->getModule('Opportunities');

$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'templateListSize', '10' );
*/


//
$options1 = array(
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['opportunitiesindexListSize'] = dropDown(
	array(
		'type' => $options1, 
		'name' => "data[opportunitiesindexListSize]", 
		'value' => getPref('opportunitiesindexListSize'), 
		'size' => 32, 
		'label' => $L['opportunitiesListSize']
	)
);
//

//
$options2 = array(
	'10' => '10', 
	'25' => '25', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);
$prefs_items['opportunitiesListDetailLength'] = dropDown(
	array(
		'type' => $options2, 
		'name' => "data[opportunitiesListDetailLength]", 
		'value' => getPref('opportunitiesListDetailLength'), 
		'size' => 32, 
		'label' => $L['opportunitiesListDetailLength']
	)
	);
//

//
$options3 = array(
	'1' => '1', 
	'2' => '2', 
	'5' => '5', 
	'7' => '7', 
	'14' => '14', 
	'21' => '21', 
	'30' => '30', 
	'60' => '60', 
	'90' => '90'
);

$prefs_items['opportunitiesListDateOffset'] = dropDown(
	array(
		'type' => $options3, 
		'name' => "data[opportunitiesListDateOffset]", 
		'value' => getPref('opportunitiesListDateOffset'), 
		'size' => 32, 
		'label' => $L['opportunitiesListDateOffset']
	)
);
//

// default constraint
$constraints = array(
	'0'      => $L['LabelNone'],
	'mine'   => $L['labelQfilterMine'],
	'alert'  => $L['labelQfilterAlert'], 
	'unseen' => $L['labelQfilterUnseen']
);
$prefs_items['opportunitiesDefaultConstraint'] = dropDown(
	array(
		'type' => $constraints, 
		'name' => "data[opportunitiesDefaultConstraint]", 
		'value' => getPref('opportunitiesDefaultConstraint'), 
		'size' => 32, 
		'label' => $L['DefaultConstraint']
	)
);


//add prefs to global prefs_rows array
$pref_rows['Opportunities'] = $prefs_items; 
?>