<?php
/**
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */

/**
 * Opportunities desktop view
 *
 * @package Opportunities
 * @author Phil Calder
 */
class OpportunitiesItemWebMATDesktop extends WebMATDesktop {
	
	/** 
	 * Adds an 'Amount Total' row before the data content
	 */
	function getSummaryContent() {
		$content = '';
		if ($amount_total = $this->getAmountTotal()) {
			$padding = true;
			$content .= $this->output->getBeginRow('') . '<td colspan="2" ' . ($padding ? 'style="padding: 10px"' : '') . '>';
			$content .= $amount_total;
			$content .= '</td>' . $this->output->getEndRow();
		}
		return $content;
	}
	
	/**
	 * Returns an 'Amount Total' label and value
	 */
	function getAmountTotal() {
		$total = false;
		if ($total = $this->db_functions->getAmountTotal()) {
			$tmp_field = array(
				'type' => 'currency',
				'value' => $total
			);
			$total = $this->output->getStringField($tmp_field);
			global $L;
			// $total = '<strong>' . $L['opportunitiesAmountTotal'] . '</strong>: ' . $total;
			$total = $L['opportunitiesAmountTotal'] . ': ' . $total;
		}
		return $total;
	}
}
?>