<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Person
 */

// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences

global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("Person");
$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'personListSize', '10' );
*/


//
$options = array(
	'' => '',  
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['personindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[personindexListSize]", 
		'value' => getPref('personindexListSize'), 
		'size' => 32, 
		'label' => $L['personListSize']
	)
);

$L['personFirstName'] = 'First name';
$L['personMiddleName'] = 'Middle name';
$L['personLastName'] = 'Last name';
$L['personTitle'] = 'Title';
$L['personInitials'] = 'Initials';
$L['personJobTitle'] = 'Job title';

//name format
$name_format = array(
	'' => '',
	'last_name , first_name' => $L['personLastName'] . ', ' . $L['personFirstName'],
	'first_name last_name' => $L['personFirstName'] . ' ' . $L['personLastName'],
	'title first_name last_name' => $L['personTitle'] . ' ' . $L['personFirstName'] . ' ' . $L['personLastName'],
	'first_name last_name , title' => $L['personFirstName'] . ' ' . $L['personLastName'] . ', ' . $L['personTitle'],
	'first_name last_name' => $L['personFirstName'] . ' ' . $L['personLastName'],
	'first_name' =>  $L['personFirstName'], 
	'last_name' =>  $L['personLastName']
);

$prefs_items['personNameFormat'] = dropDown(
	array(
		'type' => $name_format, 
		'name' => "data[personNameFormat]", 
		'value' => getPref('personNameFormat'), 
		'size' => 32, 
		'label' => '' . $L['personNameFormat'] . ''
	)
);

// default constraint
$constraints = array(
	'0'      => $L['LabelNone'],
	'mine'   => $L['labelQfilterMine'],
	// 'alert'  => $L['labelQfilterAlert'], 
	'unseen' => $L['labelQfilterUnseen']
);
$prefs_items['personDefaultConstraint'] = dropDown(
	array(
		'type' => $constraints, 
		'name' => "data[personDefaultConstraint]", 
		'value' => getPref('personDefaultConstraint'), 
		'size' => 32, 
		'label' => $L['DefaultConstraint']
	)
);

//

//add person rows array to global prefs_rows array
$pref_rows['Person'] = $prefs_items; 

?>