<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */
 
/**
 * @package Person
 * @author Phil Calder
 */
class PersonItemWebMATList extends WebMATList {

	/**
	 * Returns new company and new person links
	 */
	function getNewLinks() {
		// Modules can override this method to include more than one new link
		return array(
			'newPerson' => $this->mod->getNewPersonLink(),
			'newCompany' => $this->mod->getNewCompanyLink() 
		);
	}
	
	
	/**
	 * Performs a check to make sure the user has delete rights for this module
	 *
	 * Delete rights are based on a Contact user preference
	 *
	 * @return string the mass delete link
	 */
	function getMassDeleteItem() {
		global $SERVICES;
		$SERVICES->getService('Preferences');
		if (! ($allow_delete = $SERVICES->preferences->getUserPref('crmAllowContactDelete'))) {
			return false;
		}
		
		return parent::getMassDeleteItem();
	}
}

?>