<?php
/**
 * The main class for this module
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Person
 */

includeModule('Person', 'inc/database_tables.inc');

class Person extends WebMATModule {
	function Person() {
		$this->module_name = 'Person';
		$this->WebMATModule();
	}
	
	function getNewCompanyLink() {
		global $SERVICES;
		$SERVICES->getService('Modules');
		if ($contact =& $SERVICES->modules->getModule('Contact')) {
			return $contact->getNewCompanyLink();
		}
		return false;
	}
	
	function getNewPersonLink() {
		global $SERVICES;
		$SERVICES->getService('Modules');
		if ($contact =& $SERVICES->modules->getModule('Contact')) {
			return $contact->getNewPersonLink();
		}
		return false;
	}
	
	function getPersonIdFromContact($contact_id) {
		
		$db_functions =& $this->getDatabaseTable('item');
		$db_functions->resetDesignTimeFilters();
		$db_functions->setDesignTimeFilters(
			array(
				'contact_id'=>$contact_id, 
				'primary_record'=>1
			)
		);
		$item = $db_functions->getItem(false);
		// print_r($item); print '<hr>';
		return $item['id'];
	}
	
	function deletePersonByContactId($contact_id) {
		if ($person_id = $this->getPersonIdFromContact($contact_id)) {
			// print '<div>deletePersonByContactId(' . $contact_id . ') calling deletePerson(' . $person_id . ')</div>';
			$this->deletePerson($person_id);
		} 
	}
	
	function deletePerson($id) {
		if ($db_functions =& $this->getDatabaseTable('item')) {
			$db_functions->deleteItem($id);
		}
		
	}
	
	// function getContactIdFromPerson($person_id) {
		// 
		// $db_functions =& $this->getDatabaseTable('item');
		// $db_functions->setDesignTimeFilters(
			// array(
				// 'id'=>$id, 
				// 'primary_record'=> 1, 
				// 'active' => 1
			// )
		// );
		// $item = $db_functions->getItem(false);
		// 
		// return $item['contact_id'];
	// }
	
	function cleanupData($full_cleanup = false) {
		// print '<div>' . get_class($this) . '::cleanupData full_cleanup: ' . ($full_cleanup ? 'yes' : 'no') . '</div>'; print '<hr>';
		$retval1 = $this->_cleanupDataPersonDisplayName($full_cleanup);
		
		if ($retval1 !== false) {
			return true;
		}
		return false;
	}
	
	/**
	 * Populates Person display_name if empty, from Contact record
	 * @author Phil Calder
	 */
	function _cleanupDataPersonDisplayName($full_cleanup = false) {
		$debug = false;
		
		if ($debug) { print '<p>--- ' . $this->getModuleName() . ' - _cleanupDataPersonDisplayName (full_cleanup: ' . ($full_cleanup ? 'yes' : 'no') . ' ---<br>'; }
		
		// $num_rows = false;
		if ($full_cleanup) {
			$name_where = '';
		} else {
			$name_where = "AND _person.display_name = ''";
		}
		
		$sql = "
		SELECT count(*) 
		FROM Person__item _person 
		LEFT JOIN Contact__item _contact ON _person.contact_id = _contact.id 
		WHERE _person.active=1 AND _person.primary_record = 1 " . $name_where . "
		";
			
		if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
		$result = @mysql_query($sql);
		// print_r(@mysql_error());
		$row = @mysql_fetch_assoc($result);
		if (is_array($row)) {
			$count = current($row);
			if ($debug) { print '<div>count: ' . $count . '</div>'; }
			
			
			if ($count > 0) {
				
				// ------ Person ------------
				if ($debug) { print '<div>--- Person ---</div>'; }
				
				$sql = "
				SELECT 
				_person.id _person_id, 
				_person.display_name _person_display_name, 
				_person.first_name _person_first_name, 
				_person.middle_name _person_middle_name, 
				_person.last_name _person_last_name, 
				_person.title _person_title, 
				_contact.display_name _contact_display_name 
				FROM Person__item _person 
				LEFT JOIN Contact__item _contact  ON _person.contact_id = _contact.id 
				WHERE _person.active=1 AND _person.primary_record = 1 " . $name_where . "
				";
				if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
				
				$result = @mysql_query($sql);
				while ($row = @mysql_fetch_assoc($result)) {
					if ($debug) { print '<div>row</div>'; print_r($row); print '<hr>'; }
					if ($row['_person_id']) {
						$item = array('id' => $row['_person_id'], 'first_name' => $row['_person_first_name'], 'middle_name' => $row['_person_middle_name'], 'last_name' => $row['_person_last_name'], 'title' => $row['_person_title'], );
						if ($display_name = $this->calculateDisplayName($item)) {
							if ($debug) { print '<div>calculated person name: ' . $display_name  . '</div>'; print '<hr>'; }
							$update_sql = "
							UPDATE Person__item SET display_name = '" . $display_name . "' WHERE id = '" . $row['_person_id'] . "'
							";
						} else if ( $row['_contact_display_name']) {
							if ($debug) { print '<div>using contactname: ' . $row['_contact_display_name'] . '</div>'; print '<hr>'; }
							$update_sql = "
							UPDATE Person__item SET display_name = '" . $row['_contact_display_name'] . "' WHERE id = '" . $row['_person_id'] . "'
							";
						}
						if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
						$update_result = @mysql_query($update_sql);
						if ($debug) { print '<div>updated: ' . @mysql_affected_rows() . '</div>'; }
					}
				}
				
			}
			
			if ($debug) { print '<br></p>'; }
			return $count;
			
		}
			
		if ($debug) { print '<br></p>'; }
			
		return;
		
	}
	
	/**
	 * @param array $item - Containing name fileds (eg keys first_name, last_name,...)
	 * @return string The calculated display name based on person name format preference
	 * @author Phil Calder
	 */
	function calculateDisplayName($item) {
		global $SERVICES, $L;
		$SERVICES->getService('Language');
		$SERVICES->language->getLanguage('Person');
		$SERVICES->getService('Preferences');
		
		$name_format_pref = $SERVICES->preferences->getUserPref('personNameFormat', 'last_name , first_name');
		// print '<div>name_format_pref: ' . $name_format_pref . '</div>';
		$field_separator = ' ';
		
		$display_name_fields = explode($field_separator, $name_format_pref);
		// print '<div>display_name_fields:</div>'; print_r($display_name_fields); print '<hr>';
		$db_item = array();
		if ($item['id'] && ($db_functions =& $this->getDatabaseTable('item')) ) {
			$db_item = $db_functions->getItem($item['id']);
			// print '<div>db_item(' . $item['id'] . ')</div>'; print_r($db_item); print '<hr>';
		}
		
		
		$prefix = $this->getModuleName() . '__item.'; // Phil 20051020 Handles foreign field naming, eg $item[module__table.field]
		// $field = (isset($item[$v['field_key']]) ? $item[$v['field_key']] : ($item[$prefix . $v['field_key']])); 
		
		$display_name = '';
		foreach ($display_name_fields as $k => $v) {
			// print '<div>k=' . $k . ', v:</div>'; print_r($v); print '<hr>';
			if ($v == ',') { // Phil 200704, eg "LastName, FirstName"
				$display_name .= $v;
			} else {
				// Phil 20051020 Handles foreign field naming, eg $item[module__table.field]
				$field = (isset($item[$v]) ? $item[$v] : (isset($item[$prefix . $v]) ? ($item[$prefix . $v]) : $db_item[$v]) ); 
				// $display_name .= ((isset($item[$v]) && $item[$v]) ? $field_separator . $item[$v] : (strlen(trim($display_name)) ? ' ' : ''));
				$display_name .= ((isset($field) && $field) ? $field_separator . $field : (strlen(trim($display_name)) ? ' ' : ''));
			}
		}
		
		$display_name = trim($display_name, ' :,.-');
		// print '<div>display_name: ' . $display_name . '</div>'; exit();
		return '' . (strlen($display_name) ? $display_name : $L['personDefaultDisplayName']);	
		
	}
}
?>