<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package SystemBookmarks
 */

// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences

global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("SystemBookmarks");
$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'systemBookmarksListSize', '10' );
*/


//
$options = array(
	'' => '',  
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['systemBookmarksindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[systemBookmarksindexListSize]", 
		'value' => getPref('systemBookmarksindexListSize'), 
		'size' => 32, 
		'label' => $L['systemBookmarksListSize']
	)
);

//
$options = array(
	'' => '', 
	'1' => '1',
	'2' => '2', 
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
);


$prefs_items['systemBookmarksDashboardCount'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[systemBookmarksDashboardCount]", 
		'value' => getPref('systemBookmarksDashboardCount'), 
		'size' => 32, 
		'label' => $L['systemBookmarksDashboardCount']
	)
);
//
$boolean_options = array(
	'' => '',
	'0' => $L['No'],
	'1' => $L['Yes']
);


$prefs_items['systemBookmarksShowInPages'] = dropDown(
	array(
		'type' => $boolean_options, 
		'name' => "data[systemBookmarksShowInPages]", 
		'value' => getPref('systemBookmarksShowInPages'), 
		'size' => 32, 
		'label' => $L['systemBookmarksShowInPages']
	)
);
//

//add systemBookmarks rows array to global prefs_rows array
$pref_rows['SystemBookmarks'] = $prefs_items; 

?>