<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package SystemBookmarks
 */
class SystemBookmarksItemWebMATList extends WebMATList {
	/**
	 * returns the title row array
	 * 
	 * CHANGED to remove the new link
	 *
	 * @param string $contact_id the contact id if required
	 * @return string a string containing the menu items
	 */
	function getTitleRowLinks() {
		$title_links =  parent::getTitleRowLinks();
		bcrm_unset($title_links, 'new');
		return $title_links;
	}
	
	/**
	* New menu row is blank
	*
	* Disables the new menu row. Create a new bookmark using the 'Add Bookmark' link on a list page.
	*
	* @see WebMAT::getAddBookmarkLink
	* @author Malar 20050705
	* @return string, an empty string
	*/     
	function getNewMenuContent() {
		return '';
	}
	
	/**
	* New link is blank
	*
	* Disables the new link in new menu row. Create a new bookmark using the 'Add Bookmark' link on a list page.
	*
	* @see WebMAT::getAddBookmarkLink
	* @author Malar 20050705
	* @return string, an empty string
	*/      
	function getNewLink() {
		return '';
	}
	
	/**
	 * show either subscribe or unsubscribe link 
	 * @author Syed
	 */
	function getTableLinks($item) {
		
		$links = parent::getTableLinks($item);
		bcrm_unset($links, 'list');
		bcrm_unset($links, 'duplicate');
		if ($item['subscribed']) {
			bcrm_unset($links, 'systemBookmarksSubscribe');
		} else {
			bcrm_unset($links, 'systemBookmarksUnsubscribe');
		}
		return $links;
	}
	
	/**
	 * adds the either subscribe or unsubscribe or both to the items
	 * @author Syed
	 */
	function getCheckboxMenuExtraItems() {
		global $L;
		$filters = $this->filters->getFilterInfo();
		if (($filters['value'] == 'bookmarkUnsubscribed') || ($filters['value'] == 'none')) {
			$this->addCheckboxMenuExtraItems(array('mark_unsubscribe' => $L['MarkAsUnsubscribe']));
		} 
		if (($filters['value'] == 'bookmarkSubscribed') || ($filters['value'] == 'none')) {
			$this->addCheckboxMenuExtraItems(array('mark_subscribe' => $L['MarkAsSubscribe']));
		}
		return parent::getCheckboxMenuExtraItems();
	}
	
	/**
	 * Disabled
	 *
	 * This class displays the bookmark list anyway, no need to duplicate
	 *
	 * @author Phil Calder
	 */
	function getBookmarksContent() {
		return '';
	}
}
?>