<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package SystemBookmarks
 */

/**
 * @author Phil Calder
 */
class SystemBookmarksItemWebMATView extends WebMATView {
	
	
	/**
	 * since view also doubles as the subscribe/unsubscribe vessel, 
	 * we need to override if we're simply subscribing or unsubscribing, 
	 * we don't want to do anything other than just that.
	 *
	 * @param $item array that contains the item's info.
	 * @author Phil Calder
	 */
	function markAsSeen($item) {
		
		if ($this->form_values['subscribe'] || $this->form_values['unsubscribe']) {
			
			$seen_item = array();
			$seen_item['subscribed'] = ($this->form_values['subscribe'] ? '1' : '0');
			
			parent::markAsSeen($item, $seen_item);
			
		} else {
		
			parent::markAsSeen($item);
		
		}
		
		if ($this->form_values['subscribe'] || $this->form_values['unsubscribe']) {
			$this->redirectBack();
			exit();
		}
	}
	
	/**
	 * Disables the new link
	 *
	 * @author Phil Calder
	 * @return boolean false
	 */      
	function getNewLink() {
		return false;
	}
	
	/**
	 * Disables the Add Bookmark link
	 *
	 * @author Phil Calder
	 * @return string 'off'
	 */
	function getAddBookmarkLink() {
		return 'off';
	}
}
?>