<?php
/**
 * The edit class
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Tasks
 */

class TasksItemWebMATEdit extends WebMATEdit{
	
	function editTableLinks(& $links, $id, $item) {
		global $USER;
		// Bosco 20060327 | Remove 'Close' link for new item
		if (!$this->db_functions->isClosed($id)) {
			bcrm_unset($links, 'tasksClose');
		}
		// Phil 20070817 as of v5 tasks can be deleted
		// bcrm_unset($links, 'delete');
	}
		
	/**
	 * any processing required before adding to the form is created
	 */
	function beforeForm(&$id, &$item, &$error_msg) {
		global $SERVICES;
		// print '<div>beforeForm, id=' . $id . '</div>'; print_r($item); print '<hr>';
		
		// see also database_tables object: setDataDefinition
		/*
		foreach ($this->dd->data_dictionary as $k => $v) {
			if ( ($this->form_values['priority'] == 1) || ($item['priority_id'] == 1) ) {
				if ($v['field_key'] == 'task_datetime') {
					// print '<div>edit unsetting task_datetime</div>';
					bcrm_unset($this->dd->data_dictionary, $k);
				}
			} else {
				if ($v['field_key'] == 'priority_id') {
					// print '<div>edit unsetting priority_id</div>';
					bcrm_unset($this->dd->data_dictionary, $k);
				}
			}
		}
		*/
	}
	
	function closeTask($id) {
		if ($this->db_functions->isEditable($id)) {
			$this->db_functions->setItem( array('id'=>$id,'is_closed'=> 1));
			$this->redirectToList();
		} else {
			$this->redirectToList();
		}
	}
	
	function getNewLinks() {
		global $L;
		$priority_link = false;
		if ($new_link = $this->getNewLink()) {
		
			$contact_id = $this->getContactId();
			$priority_link_href = str_replace(
				'%id%', 
				'', 
				(str_replace('%contact_id%', $contact_id ,$this->getFileSetHref('priority')))
			);
			$priority_link = array(
				'href' => $priority_link_href,
				'text' => $L['tasksLinkPriorityNew'],
				'icon' => 'add.png',
				'title' => $L['tasksLinkPriorityNew']
			);
		}
		
		return array(
			'new'   => $new_link, 
			'priority' => $priority_link
		);
	}
}
?>