<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Template
 */


// use this file to set up Company / User Preferences which are configured from Admin
// this file is included by 
// Front/preferences.php for User Preferences
// and 
// UserAdmin/preferences.php for Company Preferences


global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("Template");
$prefs_items = array();

//When adding a new pref, you MUST insert the key and default value into the System.prefs_key table
//eg
/*
INSERT INTO `prefs_key` ( `id` , `pref_key` , `default_value` ) 
VALUES ( '', 'templateListSize', '10' );
*/


//
$options = array(
	'' => '', 
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['templateindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[templateindexListSize]", 
		'value' => getPref('templateindexListSize'), 
		'size' => 32, 
		'label' => $L['templateListSize']
	)
);

$prefs_items['templateDashboardListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[templateDashboardListSize]", 
		'value' => getPref('templateDashboardListSize'), 
		'size' => 32, 
		'label' => $L['templateDashboardListSize']
	)
);

$content_display_options = array(
	'0' => $L['PrefsHideContent'],
	'1' => $L['PrefsShowContent'],
	'2' => $L['PrefsNoContent']
);

$prefs_items['templateDashboardContentDisplay'] = dropDown(
	array(
		'type' => $content_display_options, 
		'name' => "data[templateDashboardContentDisplay]", 
		'value' => getPref('templateDashboardContentDisplay'), 
		'size' => 32, 
		'label' => $L['templateDashboardContentDisplay']
	)
);

//add template rows array to global prefs_rows array
$pref_rows['Template'] = $prefs_items; 

?>