<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */

/**
 * UserAdmin module class file.
 * 
 * This class added 20040810 by Phil
 * Note: This is not a standard module, in most cases use the Authentication service.
 * Methods in this class for emailing user info to a user.
 *
 * @author Phil Calder
 * @package UserAdmin
 */
class UserAdmin {
	
	/**
	 * @access private
	 */
	var $db;
	
	function UserAdmin() {
		global $SERVICES;
		$this->db =& $SERVICES->getService('Database');
	}
	
	function setEmailDefaults($item) {
		$fields = array();
		$fields['sender'] = $item['sender'];
		$fields['subject'] = $item['subject'];
		$fields['body'] = $item['body'];
		$fields['url'] = $item['url'];
		
		return $this->db->update('System__mail_template', $fields);
	}
	
	function getEmailDefaults() {
		$data = $this->db->quickget('*', 'System__mail_template');
		return $data;
	}
	
	function getEmailBody($item) {
		global $L;
		$data = $this->getEmailDefaults();
		
		$body = "";
		$body .= $data['body'] . ":\n";
		$body .= $L['useradminAdminEmailURL'] . ": " . $data['url'] . "\n";
		$body .= $L['useradminUsername'] . ": " . $item['username'] . "\n";
		$body .= $L['useradminPassword'] . ": " . $item['password1'] . "\n";
		
		return $body;
	}
	
	function sendUserInfo($item) {
		global $SERVICES, $L;
		// print '<div>sendUserInfo:</div>'; print_r($item);
		$output =& $SERVICES->getService('Output');
		
		$data = $this->getEmailDefaults();
		
		$to = $item['email'];
		$from = $data['sender'];
		$subject = $data['subject'];
		$url = $data['url'];
		
		// print_r($item); print_r($data);
		
		if ($output->isValidEmail($to) && $output->isValidEmail($from)) {
			// continue
		} else {
			return false;	
		}
		
		$body = $this->getEmailBody($item);
		
		$extra = 
		"From: $from\r\n" .
		"Reply-To: $from\r\n" .
		"X-Mailer: PHP/" . phpversion();
		
		if (@mail($to, $subject, $body, $extra)) {
			// print '<div>Mail sent</div>';
			return true;
		}
		
		// print '<div>Mail not sent</div>';
		return false;
	}
}

?>