<?php
require_once("../../prepend.inc");
/**
 * Displays a list of User Groups with links to edit members, edit details, delete, and create a new group.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$output =& $SERVICES->getService('Output');
$SERVICES->getService('Language');
$SERVICES->language->getLanguage('UserAdmin');


function main() {
	global $SERVICES, $output, $L, $ua, $delete, $message;
	
	if (isset($delete) && ($delete > 0)) { 
		$message = $ua->groups->removeGroup($delete); 
	}
	
	$gps = $ua->groups->getGroupList('all', true, $limit, true);// All groups
	// Phil 20040804 - Added Paging
	$total_count = sizeof($gps); 
	$limit = $output->setPagingLimits('frontDefaultListSize', $total_count);
	
	// ---
	$action_links = array(
		'<a href="group.php">' . $L['useradminLinkNewPermissionsGroup'] . '</a>', 
		'<a href="group.php?item[type]=2">' . $L['useradminLinkNewTeamGroup'] . '</a>', 
		// '<a href="group.php?item[type]=1">' . $L['useradminLinkNewPrivateGroup'] . '</a>'
	);
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu((array)$action_links);
	$output->toolbar_link_mode = false;
	
	$content = '';
	$content .= $output->getBeginTable();
	
	// $content .= $output->getTitleRow($L['useradminUserGroups']);
	
	
	
	$content .= $output->getBeginNestedListTable();
	
	$content .= $output->getHeaderRow(
		array(
			'name' => array('label' => $L['useradminGroupName']), 
			'details' => array('label' => $L['useradminGroupDetails']), 
			'members' => array('label' => $L['useradminGroupMembers']), 
			'type' => array('label' => $L['useradminGroupType']), 
			'delete' => array('label' => $L['LinkDelete'])
		)
	);
	
	foreach ($gps as $id => $v) {
		
		$name = $v['name'];
		
		$row = array();
		$row[] = $name;
		
		if ($name == 'Administrators') { // No edit details link
			$row[] = '';
		} else {
			$row[] = '<a href="group.php?id=' . $id . '">' . $L['useradminEditDetails'] . '</a>';
		}
		
		$row[] = '<a href="user_group.php?group_id=' . $id . '">' . $L['useradminEditMembers'] . '</a>';
		
		switch ($v['type']) {
			case '2': 
				$type = $L['useradminGroupLabelTeams'];
			break;
			case '1':
				$type = $L['useradminGroupLabelPrivate'];
			break;
			default:
				$type = $L['useradminGroupLabelPermissions'];
			break;
		}
		
		$row[] = $type;
		
		if ($ua->groups->isEditable($id)) {
			$row[] = $output->getLinkDelete('groups.php?delete=' . $id);
		} else {
			$row[] = '';
		}
		
		$content .= $output->getTableRow($row);
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getPagingRow();
	$content .= $output->getEndTable();
	
	// --------
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($L['useradminUserGroups'], array('bookmark'=>'off'));
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
	
}

main();

?>