<?php
require_once("../../prepend.inc");

/**
 * Change user password.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('UserAdmin');

// $ua->adminRestrict(); // Phil - see doDisplay - restrict based on user_id

function doDisplay($user_id, $message = '') {
	global $SERVICES, $L, $ua, $USER, $PHP_SELF;
	
	// print $user_id;
	if (empty($user_id)) {
		$user_id = $USER['user_id'];
	}
	
	if ($user_id != $USER['user_id']) {
		$ua->adminRestrict('UserAdmin'); // Need admin rights to change another users password
	}

	$output =& $SERVICES->getService('Output');
	
	$content = '';
	$content .= $output->getBeginForm($PHP_SELF);
	$content .= $output->getBeginTable();
	
	// $content .= $output->getTitleRow($L['useradminChangeUserPasswordFor'] . ' ' . $ua->users->getUsername($user_id));
	
	$content .= $output->getHtmlFieldRow(array('label'=>'', 'type'=>'hidden', 'field_key'=>'user_id', 'value'=>$user_id));
	$content .= $output->getBeginNestedEditTable();
	
	if ($message) {
		if (!is_array($message)) {
			$message = array($message);	
		}
		foreach ($message as $v) {
			// $content .= $output->getTextRow($output->getAlert($v));
			$content .= $output->getTextRow($v);
		}
	}
	
	$content .= $output->getHtmlFieldRow(array('label'=>$L['useradminNewPassword'], 'type'=>'password', 'field_key'=>'password1'));
	$content .= $output->getHtmlFieldRow(array('label'=>$L['useradminNewPasswordAgain'], 'type'=>'password', 'field_key'=>'password2'));
	$content .= $output->getSubmitRow();
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndTable();
	$content .= $output->getEndForm();
	
	// ---
	$action_links = array(
		'<a href="users.php">' . $L['useradminAdminUsersListAndMailAccounts'] . '</a>'
	);
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu((array)$action_links);
	$output->toolbar_link_mode = false;
	
	$title_text = $L['useradminChangeUserPasswordFor'] . ' ' . $ua->users->getUsername($user_id);
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTextRow($title_text); // v5 doesnt display title except in tab and actual page title
	$window_layout .= $output->getTitleRow($title_text, array('bookmark'=>'off'));
	
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
	
}


function doSubmit() {
    global $L, $ua, $item, $user_id;

    $message = array();

    if (!$item['password1'])  {
		
		$message[] = $L['useradminPleaseEnterNewPassword'];
		
    } else {
		
		if (!$ua->users->isValidPassword($item['password1']))  {
			$message[] = $L['useradminInvalidPassword'];
		}	
		
	}

    if ($item['password1'] != $item['password2'])  {
        $message[] = $L['useradminNewPasswordsDoNotMatch'];
    }

    if (sizeof($message))  {
		
        return $message;
		
    } else {

		if ( ($retval = $ua->users->changeUserPassword( $item['user_id'], $item['password1'])) !== true) {
			
			$message[] = $retval;
			
			return $message;
			
		}
		
		// Success
		header('Location:users.php');
		
		exit();
		
    }
	
}



function main() {
	global $item, $user_id;

	if (is_array($item)) {
		
		$result = doSubmit();
		
		if (sizeof($result)) {
			
			doDisplay($user_id, $result);
			
		} else {
			
			header('Location: users.php');
			
			exit();
			
		}
		
	} else {
		
		doDisplay($user_id);
		
	}
	
}



main();

?>