<?php
require_once("../../prepend.inc");

/**
 * Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict('UserAdmin');
$SERVICES->getService('Language');
$SERVICES->getservice('Preferences');
$SERVICES->language->getLanguage('UserAdmin');
$SERVICES->language->getLanguage('Front');

function getPref($key) {
	global $SERVICES;
	return $SERVICES->preferences->getCompanyPref($key);
}

function dropDown($data){
	$width = '200';
	if ($data['name'] == 'data[cfgTimeOffsetHours]') {  //special case for timezone; long drop down; hack until we rewrite using output class
		$width = '420';
	}
	
	$html = '<select name="'.$data['name'].'" style="width:' . $width . 'px;">';
	if(sizeof($data['type']) > 0){
		foreach($data['type'] as $k => $v) {
			$html .= '<option value="'.$k.'"'.($data['value'] === strval($k) ? ' selected' : '').'>'.$v.'</option>';
		}
	}	
	
	$html .= '</select>';
	$content = '<td nowrap>'.$data['label'].': </td><td>'.$html.'</td>';
	if ($data['name'] == 'data[cfgTimeOffsetHours]') {  //special case for timezone; long drop down; hack until we rewrite using output class
		$content = '<td nowrap>'.$data['label'].': </td></tr><tr><td colspan="2" align="right">'.$html.'</td>';
	}
	return $content;
}

function formEvents($item) {
	$attr = "";
	foreach ($item as $k => $v) {
			if (substr($k, 0, 2) == 'on') { $attr .= " $k = '$v'"; }
	}
	return $attr;
}


// type name value size maxlength label
function formInput($item) {
	switch ($item['type']) {
	case "text":
			$ro = bcrm_htmlspecialchars($item['value']);
			$rw = "<input" . formEvents($item) . " class = 'input_extras' size = '" . $item['size'] . "' maxlength = '" . $item['maxlength'] . "'type = 'text' name = '" . $item['name'] . "' value = '" . bcrm_htmlspecialchars($item['value']) . "'>";
			break;
	case "textarea":
			$ro = bcrm_htmlspecialchars($item['value']);
			$rw = "<textarea cols = '48' rows = '5' name = '" . $item['name'] . "'>" . bcrm_htmlspecialchars($item['value']) . "</textarea>";
			break;
	case "money":
			$ro = "$" . sprintf("%01.2f", $item['value']);
			$rw = "$<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . sprintf("%01.2f", $item['value']) . "'>";
			break;
	case "percent":
			$ro = $item['value'] . "%";
			$rw = "<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . bcrm_htmlspecialchars($item['value']) . "'>%";
			break;
	case "timestamp":
			$ro = strftime("%d %B %Y", $item['value']);
			$rw = "<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . strftime("%d %B %Y", $item['value']) . "'>";
			break;
	default:
			$ro = isset($item['type'][$item['value']]) ? $item['type'][$item['value']] : "";
			$rw = "<select" . formEvents($item) . " style='width:200px;' name = '" . $item['name'] . "'".(isset($item['javascript']) ? $item['javascript'] : '').">";
			foreach ($item['type'] as $k => $v) {
					$rw .= "<option value = '$k'" . (($item['value'] == $k) ? " selected" : "") . ">$v</option>\n";
			}
			$rw .= "</select>";
			break;
	}
	return (isset($item['label']) ? "<td nowrap>" . $item['label'] . ":</td><td>" : "<td>") . (isset($item['ro']) ? $ro : $rw) . "</td>\n";
}

function doSubmit() {
	global $SERVICES, $L, $PHP_SELF, $USER, $returnpage;
	//check for submit
	if (isset($_POST['submit'])) {
		$data = (isset($_POST['data']) ? $_POST['data'] : '');
		$override = (isset($_POST['override']) ? $_POST['override'] : array());
		$block = (isset($_POST['block']) ? $_POST['block'] : '');
		//loop through all pref names
		foreach($data as $pref => $val) {
			$override[$pref] =  (isset($override[$pref]) ? $override[$pref] : '');
			//save company prefs
			$SERVICES->preferences->setCompanyPref($pref, $val, $override[$pref]);
		}
		// Set the blocked preferences
		if (!isset($block) || !$block) {
			$block = array();
		}
		$SERVICES->preferences->setBlockedPref(array_keys($block));
		if ($returnpage == 'welcome') {
			header('location:../Front/welcome.php?ref=prefs');
			exit();
		} else if (!isset($close_window) || !$close_window) {
			// Lastly return to the main admin page
			header('Location:../Admin/index.php');
			exit();
		} else {
			$target = base64_decode($target);
			if ($target) {
				if ($target == 'parent') { // reload the parent frame
					print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.parent.location.reload();\nwindow.close();\n//-->\n</script>");
				} else { // replace the page with target
					print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.location.replace('" . $target . "');\nwindow.close();\n//-->\n</script>");
				}
			} else { // reload the page
				print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.location.reload();\nwindow.close();\n//-->\n</script>");
			}
		}
		exit();
	}
}


function main () {
	global $SERVICES, $L, $PHP_SELF, $USER, $skinname, $ua, $prefs_inc, $include_files, $returnpage, $override;
	$skin = $USER['skin_web_path'];
	$output =& $SERVICES->getService('Output'); // Even if not used, prevents overriding of Output class as modules are created.
	// Make sure classes are loaded.
	$SERVICES->getService('Config');
	// $links = $SERVICES->config->lookup('modules.Front.prefslink');
	
	// Phil 20060131 Load a single module,or all modules
	if (isset($_GET['module']) && $_GET['module']) {
		$links = $SERVICES->config->lookup('modules.Front.prefslink.' . $_GET['module']);
	} else {
		// Make sure classes are loaded.
		$links = $SERVICES->config->lookup('modules.Front.prefslink');
	}
	$links = (array)$links;
	
	foreach ($links as $k => $v) {
		if (!$ua->readAccess($USER['user_id'], $v['module']) ) {
 			bcrm_unset($links, $k);	
		}
	}
	
	if (isset($links['file'])) {
		$links = array($links);
	}
	
	if (isset($sortarray)) {
		$sortarray = array();
	}
	$SERVICES->getService('Modules');
	foreach ($links as $k => $link) {	
		// print '<div>k=' . $k . '</div>'; print_r($link); print '<hr>';
		$sortarray[] = (isset($link['priority']) ? $link['priority'] : '');
		// Phil 20050405
		$link['file'] = basename($link['file']); // Phil 20050405 - we now have a modules_custom dir as well as a modules dir
		// if (file_exists('../../modules/' . $link['module'] . '/' . $link['file'])) {
			// $link['file'] = '../../modules/' . $link['module'] . '/' . $link['file'];
		// } else if (file_exists('../../modules_custom/' . $link['module'] . '/' . $link['file'])) {
			// $link['file'] = '../../modules_custom/' . $link['module'] . '/' . $link['file'];
		// }
		$link['file'] = $SERVICES->modules->getModulePath($link['module'], true) . '/' . $link['file'];
		// print '<div>[' . $link['file'] . ']</div>';
		
		$links[$k]['file'] = $link['file'];
		// print '<div>UserAdmin/preferences.php link:</div>'; print_r($link); print '<hr>';
	}
	
	array_multisort($sortarray,$links);

	// <tr><td colspan=4 class="titleCell"><strong>' . $L['useradminCompanyPreferences'] . '</strong></td></tr>
	$content = '
	<form action="' . $PHP_SELF . ''. ($returnpage ? '?returnpage='.$returnpage.'' : '') . '" method="POST">
	<div style="width:500px; padding:10px;">' . $L['useradminIntroText'] . '</div>
	';
	
	//<tr><td></td><td><strong>' . $L['useradminPreference'] . '</strong></td><td><strong>' . $L['useradminValue'] . '</strong></td><td><strong>' . $L['useradminOverride'] . '</strong></td><td><strong>' . $L['useradminBlockUsers'] . '</strong></td>
	
	if (isset($prefs_inc) && $prefs_inc) {
		$content .= '		<input type="hidden" name="close_window" value="1">';
	}
	
	$pref_rows = array();
	foreach ($links as $k => $link) {  
		if (isset($include_files) && is_array($include_files)) {
			if (in_array($link['module'], $include_files)) {
				include_once( $link['file'] );
			}
		}
		
		if (isset($prefs_inc) && is_array($prefs_inc)) {
			foreach ($prefs_inc as $p) {
				if ( ($link['module'] == 'Front') || (substr($p, 0, strlen($link['module'])) == strtolower($link['module'])) ) {
					@include_once( $link['file'] );
				}
			}
		} else {
			@include( $link['file'] );
		}
	}
	
	// Phil 20060131
	if (!count($pref_rows)) {
		$content = $L['frontLabelNoPreferences'] . '<br>
		<a href="javascript:history.go(-1)">' . $L['frontBack'] . '</a>';
		quickPage($content);
		exit();
	}
	
	$tabs_content = '';
	$tabs = array();
	$active_tab = false;
	
	// Phil 20070524 Splitting preferences into 2 tabsets
	$tabs_1_content = '';
	$tabs_1 = array();
	$active_tab_1 = false;
	
	if (count($pref_rows) > 10) {
	
		$tabs_1_modules = array(
			'Front',
			'Admin',
			'UserAdmin', 
			'Contact',
			'Company', 
			'Person',
			'ContactImport',
			'ContactRelationship', 
			'ClientLoginManager', 
			'SystemBookmarks', 
			
		);
		foreach ($tabs_1_modules as $k => $v) {
			$tabs_1[$v] = false;
		}
	} else {
		$tabs_1_modules = array();
	}
	
	//now loop through array
	foreach($pref_rows as $module => $prefs) {
		// Check if the privilege to this module is there
		if ($ua->adminAccess($USER['id'], $module)) {
			$current_tab_content = '
			<div id="tab' . $module . '" class="tab-content">
			<table cellpadding="2" cellspacing="3" border="0">
			<tr>
				<td><strong>' . $L['useradminPreference'] . '</strong></td>
				<td><strong>' . $L['useradminValue'] . '</strong></td>
				<td><strong>' . $L['useradminOverride'] . '</strong></td>
				<td><strong>' . $L['useradminBlockUsers'] . '</strong></td>
			</tr>
			';
			
			$SERVICES->language->getLanguage($module);	
			$SERVICES->getService('Config');
			$module_conf = $SERVICES->config->lookup("modules.$module");
			$module_label = $L[$module_conf['label']];	
			
			//if (!isset($prefs_inc) || !$prefs_inc) {
				//$content .= '<tr><td align="center"><b>'.$module_label.'</b></td></tr>';
			//}
		
			foreach($prefs as $pref_name => $pref_row) {
				// if (!$SERVICES->preferences->isBlockedPref($pref_name) && (!$prefs_inc || in_array($pref_name, $prefs_inc))) {
				if ((!$prefs_inc || in_array($pref_name, $prefs_inc))) {
					$current_tab_content .= '<tr>' . $pref_row . '';
					$current_tab_content .= '<td align="center"><input type="checkbox" name="override['.$pref_name.']" value=1' . (isset($override[$pref_name]) && $override[$pref_name] ? ' checked' : '') . '></td>';
					$current_tab_content .= '<td align="center"><input type="checkbox" name="block['.$pref_name.']" value=1' . ($SERVICES->preferences->isBlockedPref($pref_name) ? ' checked' : '') . '></td>
								</tr>';
				}
			}
			
			$current_tab_content .= '
			</table>
			</div>
			';
			
			if (in_array($module, $tabs_1_modules)) {
				$tabs_1_content .= $current_tab_content;
				if (!$active_tab_1) {
					$active_tab_1 = 'tab' . $module;
				}
				$tabs_1[$module] = array('id' => 'tab' . $module, 'title' => $module_label);
				
			} else {
				$tabs_content .= $current_tab_content;
				if (!$active_tab) {
					$active_tab = 'tab' . $module;
				}
				$tabs[$module] = array('id' => 'tab' . $module, 'title' => $module_label);
				
			}
			
		}
	}
	
	if (count($tabs_1)) {
		$content .= '
	<div id="settingsTabs_1">
	' . $tabs_1_content . '
	</div>
	';
	}
	
	if (count($tabs)) {
		$content .= '
	<div id="settingsTabs">
	' . $tabs_content . '
	</div>
	';
	}
	
	$output->initExt();
	
	if (count($tabs_1)) {
		$output->initTabs('settingsTabs_1');
		foreach ($tabs_1 as $tab) {
			if ($tab) {
				$output->addTab($tab, 'settingsTabs_1');
			}
		}
		$output->setFirstTab($active_tab_1, 'settingsTabs_1');
	}
	if (count($tabs)) {
		$output->initTabs('settingsTabs');
		foreach ($tabs as $tab) {
			if ($tab) {
				$output->addTab($tab, 'settingsTabs');
			}
		}
		$output->setFirstTab($active_tab, 'settingsTabs');
	}
	
	$content .= '
	<div style="padding:10px"><input type="submit" name="submit" value=" ' . $L['ButtonSubmit'] . ' "></div>
	</form>
	';
	
	$title = $L['useradminCompanyPreferences'];
	
	$output =& $SERVICES->getService('Output');
	// Phil 20060131 Mimics WebMATList
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title, array('bookmark'=>'off'));
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);

	
	// $output->addToBody($content);
	$output->addToBody($window_layout);
	$output->display();
	
	exit();
	
}



$returnpage = (isset($_GET['returnpage']) ? $_GET['returnpage'] : '');

doSubmit();

main();

?>