<?php
require_once("../../prepend.inc");
/**
 * Show login details and groups for a given user.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 * @author Phil Calder
 */

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('UserAdmin');

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

function main() {
	global $SERVICES, $ua, $USER, $L, $id;
	$output =& $SERVICES->getService('Output');
	if (empty($id)) {
		$id = $USER['user_id'];
	}
	$user_name = $ua->users->getUsername($id);
	if (!$user_name) {
		// Nothing to do - current user should have a user name
		header('Location: users.php');
		exit();
	} else {
		
		// $all_groups = $ua->users->getGroupListInclusive();
		$all_groups = $ua->groups->getGroupList('all', true, '', true);
		$user_groups = $ua->groups->getGroupsForUser($id); // Groups the user is in
		$info = $ua->users->getUser($id);
		$private_group_id = $info['private_group_id']; // $ua->users->getPrivateGroup($id); // The users private group

		// note that "user_groups" should be a subset of "all_groups"
		$skinname = $info['skin'];
		$len = strlen($skinname);
		if ($skinname[ $len - 1 ] == '/') {
			$skinname = substr($skinname,0,$len-1);
		}
		$len = strrpos($skinname,'/');
		if ($len !== false) {
			$skinname = substr($skinname,$len + 1);
		}
		
		$content = '';
		$content .= $output->getBeginTable();
		
		$content .= $output->getBeginNestedViewTable();
		// $content .= $output->getTitleRow($L['useradminUserDetails']);
		$content .= $output->getTableRow(array($L['Username'], $user_name));
		$content .= $output->getTableRow(array($L['useradminLastLogin'], date( 'g:ia j/n/Y', $info[ 'last_login' ] )));
		$content .= $output->getTableRow(array($L['useradminSkin'], $skinname));
		$content .= $output->getTableRow(array($L['useradminContactID'], $output->getLinkContact($info[ 'contact_id' ], '', false) ));
		$content .= $output->getEndNestedTable();
		
		$content .= $output->getTitleRow(
			$L['useradminGroupMemberships'], 
			array(
				'refresh'=>'off',
				'bookmark'=>'off',
				'help'=>-1, 
				'back' => 'off'
			)
		); // no menu or help button
		
		$content .= $output->getBeginNestedListTable();
		$content .= $output->getHeaderRow(
			array(
				'group'      => array('label' => $L['useradminGroupname']), 
				'membership' => array('label' => $L['useradminMembership']), 
				'type'      => array('label' => $L['useradminGroupType'])
			)
		);
		
		foreach ($all_groups as $k => $v) { // group id, fields array
			$name = $v['name'];
			
			if ($k == $private_group_id) {	
				$name = '<strong>' . $v['name'] . ' *</strong>';
			}
			
			if (isset($user_groups[$k])) {
				$name = '<strong>' . $v['name'] . '</strong>';
				
				if ($k == $private_group_id) {
					$link = '<strong>' .$L['useradminGranted']. '</strong>';
					$name = '<strong>' . $v['name'] . ' *</strong>';
				} else {
					$link = '<a href="switch.php?user_id=' . $id . '&group_id=' . $k . '&action=0"><strong>' . $L['useradminGranted'] . '</strong></a>';
				}
				
			} else {
				$link = '<a href="switch.php?user_id=' . $id . '&group_id=' . $k . '&action=1">' . $L['useradminDenied'] . '</a>';
			}
			
			switch ($v['type']) {
				case '2': 
					$type = $L['useradminGroupLabelTeams'];
				break;
				case '1':
					$type = $L['useradminGroupLabelPrivate'];
				break;
				default:
					$type = $L['useradminGroupLabelPermissions'];
				break;
			}
			
			$cols = array();
			$cols[] = $name;
			$cols[] = $link;
			$cols[] = $type;
			
			$content .= $output->getTableRow($cols);
		}
		
		$content .= $output->getEndNestedTable();
		$content .= $output->getEndTable();
		
		// ---
		$action_links = array(
			'<a href="users.php">' . $L['useradminAdminUsersListAndMailAccounts'] . '</a>'
		);
		$output->toolbar_link_mode = true;
		$output->setActionLinksMenu((array)$action_links);
		$output->toolbar_link_mode = false;
		
		// $output->addToBody($content);
		// $output->display();
		// exit();
		$window_layout = $output->getBeginTable('mainTbl', true);
		$window_layout .= $output->getTitleRow($L['useradminUserDetails'], array('bookmark'=>'off'));
		$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
		$window_layout .= $content;
		$window_layout .= '</td>' . $output->getEndRow(true);
		$window_layout .= $output->getEndTable(true);
		
		$output->addToBody($window_layout);
		$output->display();
		exit();
	}
}

main();

?>