<?php
require_once("../../prepend.inc");
/**
 * Edit membership for a given group.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('UserAdmin');

$output =& $SERVICES->getService('Output');

function doSubmit() {
   	global $SERVICES, $ua, $user_id, $permission, $group_id;
	if ( ($user_id > 0) && ($group_id > 0)) {
		// print '<p>set user: ' . $user_id . ', ' . $group_id . ', ' . $permission . '</p>';
		$ua->groups->setUser( $user_id, $group_id, $permission );
	}
}

function main() {
	global $SERVICES, $L, $ua, $USER, $output, $PHP_SELF, $group_id;

	if (empty($group_id)) {
		header('Location: groups.php');
		exit();
	}
	
	$all_users = $ua->users->getUsersList();         
	$yes_users = $ua->groups->getUsers($group_id);
	
	$content = '';
	$content .= $output->getBeginTable();
	
	// $content .= $output->getTitleRow($L['useradminGroupMembers']);
	
	$name = '';
	$group = $ua->groups->getGroup($group_id);
	
	if (is_array($group)) {
		$name = $group['name'];
	}

	if (!empty($name)) {
		$content .= $output->getTextRow($L['useradminGroupName'] . ': ' . $name);
	}
	
	$content .= $output->getBeginNestedListTable();
	$content .= $output->getHeaderRow(
		array(
			'username' => array('label' => $L['Username']), 
			'in_group' => array('label' => $L['useradminInGroup'])
		)
	);
	
	foreach($all_users as $user_id => $name) {
		
		if ( 
			($user_id == $ua->users->getAdminUserId()) && 
			($group_id == $ua->groups->getAdministratorsGroupId()) && 
			($yes_users[$user_id]) 
		) {
			$link = $L['Yes'];
		
		} else {
			$link = '<a href="' . $PHP_SELF . '?user_id=' . $user_id . '&group_id=' . $group_id . '&permission=' . (isset($yes_users[$user_id] ) && $yes_users[$user_id] ? '0">' . $L['Yes'] : '1">' . $L['No'] ) . '</a>';
		}
		
		$content .= $output->getTableRow(array($name, $link));
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getTextRow($L['useradminReloadPermissions']);
	$content .= $output->getTextRow('<a href="groups.php">' . $L['useradminBackToGroupsList'] . '</a>');
	$content .= $output->getEndTable();
	
	// -----
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($L['useradminGroupMembers'], array('bookmark'=>'off'));
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

doSubmit();
main();
?>