<?php
require_once("../../prepend.inc");
/**
 * Displays a matrix of permissions to modules for a given user.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package UserAdmin
 * @author Phil Calder
 */


$SERVICES->getService('Language');
$SERVICES->language->getLanguage('UserAdmin');

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$output =& $SERVICES->getService('Output');

$SERVICES->getService('Modules');

function main() {
	global $SERVICES, $L, $USER, $ua, $output, $id;
	
	if (empty($id)) {
		$id = $USER['user_id'];
	}
	
	$modules = $SERVICES->modules->getModules();
	$user_privs = $ua->getPrivileges($id);
	$title = $L['useradminPermissions'];
	$menu = '';
	
	$header = array(
		'module' => array('label' => $L['useradminModule']), 
		'r' => array('label' => $L['useradminRead']), 
		'w' => array('label' => $L['useradminWrite']), 
		'a' => array('label' => $L['useradminAdministrator'])
	);
	
	$action_links = array(
		'<a href="users.php">' . $L['useradminAdminUsersListAndMailAccounts'] . '</a>'
	);
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu((array)$action_links);
	$output->toolbar_link_mode = false;
	
	$content = '';
	
	$content .= $output->getBeginTable();
	// $content .= $output->getTitleRow($title, $menu);
	
	$content .= $output->getTextRow($L['useradminUsername'] . ': <strong>' . $ua->users->getUsername($id) . '</strong>');
	$content .= $output->getTextRow($L['useradminPermissionsDescription']);
	$content .= $output->getBeginNestedListTable();
	$content .= $output->getHeaderRow($header);
	
	if (is_array($user_privs)) {
		
		foreach($user_privs as $k => $v) {
			if (in_array($k, $modules)) {
				
				$cols = array();
				
				$cols[0] = $k;
				
				switch ($v) {
				case 0:
					$cols[1] = ''; $cols[2] = ''; $cols[3] = '';
				break;
				case 1:
					$cols[1] = 'x'; $cols[2] = ''; $cols[3] = '';
				break;
				case 2:
					$cols[1] = ''; $cols[2] = ''; $cols[3] = '';
				break;
				case 3:
					$cols[1] = 'x'; $cols[2] = 'x'; $cols[3] = '';
				break;
				case 4:
					$cols[1] = ''; $cols[2] = ''; $cols[3] = 'x';
				break;
				case 5:
					$cols[1] = 'x'; $cols[2] = ''; $cols[3] = 'x';
				break;
				case 6:
					$cols[1] = 'x'; $cols[2] = 'x'; $cols[3] = '';
				break;
				case 7:
					$cols[1] = 'x'; $cols[2] = 'x'; $cols[3] = 'x';
				break;
				default:
					$cols[] = '-';
				break;
				}
				
				$content .= $output->getTableRow($cols);
				
			}
		}
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndTable();
	
	
	// $output->addToBody($content);
	// $output->display();
	// exit();
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title, array('bookmark'=>'off'));
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();

}

main();
?>
