<?php
require_once("./public_prepend.inc.php");
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package BrowserCRM
 * @access private
 */

// This web form allows vistors to your site to 'signup'. 
// A new contact is created in the CRM database with the details provided by the visitor.
// Using your Companies default user preferences, you can:
// - assign the new contact to a particular user (see 'user_id' below)
// - assign a status to the contact (see 'status_id' below)
// Basically, anything that you can do by manually adding a contact, you can set here.


$L['pubSignupPageLabel'] = 'Signup Form';
$L['pubCompany'] = 'Company';
$L['pubFirstName'] = 'First Name';
$L['pubLastName'] = 'Last Name';
$L['pubEmailAddress'] = 'Email Address';
$L['pubEmailSubscribe'] = 'Subscribe';

$L['pubError'] = 'Error';
$L['pubThankYouMessage'] = 'Thank you for your input';
$L['pubBack'] = 'Back';

$L['pubDescriptionMessage'] = 'This example web form is accessible without logging in to BrowserCRM. A new contact is created when the form is submitted.';

$L['pubCredits'] = 'Created by BrowserCRM Web Forms';

$L['pubSignupNoWritePermission'] = 'You dont have permission to access this page';

	
/* =================== Page Under Construction ==================== */
quickPage($L['pubDescriptionMessage']);
exit();


$SERVICES->getService('Preferences');
// Not a 'Module'. 
// This class provides us with access to the real functionality we want.
class WebForm {
	
	
	// Attempts to add a new contact and email address from the given item array
	// Returns the new contact id, or false
	function addItem($item) {
		global $SERVICES;
	
		$contact_data = array(
			'company_name'=>$item['company_name'], 
			'first_name'=>$item['first_name'], 
			// 'middle_name'=>$item['middle_name'],
			'last_name'=>$item['last_name'], 
			'active'=>1, 
			'created'=> time(), 
			);
			
		// Use user preferences for these values
		// You can change these in the admin area of BrowserCRM by setting 'company preferences' 
		// and overriding values for current users
		// $contact_data['entity_id'] = $SERVICES->preferences->getUserPref('crmDefaultEntity');
		$contact_data['status_id'] = $SERVICES->preferences->getUserPref('crmDefaultStatus');
		$contact_data['region_id'] = $SERVICES->preferences->getUserPref('crmDefaultRegion');
		// Set 'source_id' to 'Web Signup' (or similar) by creating a custom 'source' field in the CRM admin section 
		// $contact_data['source_id'] = $SERVICES->preferences->getUserPref('crmDefaultSource');
		$contact_data['group_id'] = $SERVICES->preferences->getUserPref('crmDefaultGroup');
		$contact_data['editableby_group_id'] = $SERVICES->preferences->getUserPref('crmDefaultEditableByGroup');
		$contact_data['user_id'] = $SERVICES->preferences->getUserPref('crmDefaultUser');

		foreach($contact_data as $k => $v) {
			$contact_data[$k] = stripslashes($v);
		}
		
		$SERVICES->getService('Modules');
		$contact = $SERVICES->modules->getModule('Contact');
		$address_email = $SERVICES->modules->getModule('AddressEmail');
		
		$result = $contact->addQuickContact($contact_data);
		
		if ($result) {

			$email_data = array(
				'contact_id'=>$result,
				'content'=>stripslashes($item['email_address']), 
				'subscribed'=>''.$item['subscribed'].''
				);
			$result = $address_email->addQuickAddress($email_data);	
		}
		
		return $result; // The new contact id, or false
	}
	
}

$mod = new Webform(); // WebForm is not a full module, but we treat it as one.
$output =& $SERVICES->getService('Output');

// Redirect if the public user doesnt have rights to write to the CRM module
// (The page wont work even if we dont have this here - this just allows us to handle it more elegantly)
$ua =& $SERVICES->getService('Authentication');
if (!$ua->writeAccess($USER['user_id'], 'Contact')) {
	quickPage($L['pubSignupNoWritePermission']);
	exit();
}

function getFormFields($item, $extras = array()) {
	global $L;
	
	//field definitions
	$fields =  array( 			
		array('label'=>$L['pubCompany'], 'field_key'=>'company_name', 'type'=>'text', 'maxlength'=>30), 
		array('label'=>$L['pubFirstName'], 'field_key'=>'first_name', 'type'=>'text', 'maxlength'=>30, 'notnull'=>1), 
		array('label'=>$L['pubLastName'], 'field_key'=>'last_name', 'type'=>'text'), 
		array('label'=>$L['pubEmailAddress'], 'field_key'=>'email_address', 'type'=>'text',  'notnull'=>1), 
		array('label'=>$L['pubEmailSubscribe'], 'field_key'=>'subscribed', 'type'=>'checkbox')
		
	);
	
	foreach ($fields as $k => $v) {
		$fields[$k]['value'] = $item[$v['field_key']];
		$fields[$k]['tag_extras'] = $extras[$v['field_key']]['tag_extras'];
	}
	
	return $fields;
		
}

function doSubmit() {
	global $mod, $output, $PHP_SELF, $submit, $item, $L;
	
	if (isset($submit)) {
		
		// --- Validation -----
		
		$fields = getFormFields($item);	//get field definitions
		$output->validateFields($item, $fields, $error_msg); //validate $item based on the definitions in $fields; $item values will get updated
		if (is_array($error_msg)) {		//if server-side validation errors, return to form
			main( $item['id'], $item, $error_msg);
			exit();
		}
		
		
		if (! $mod->addItem($item)) { // Add the item
			
			$content = $L['pubError'];
			quickPage($content);
			exit();
		}
		
		header ('Location: ' . $_PHP_SELF . '?action=done');
		exit();
		
	}
}


function main() {
	global $mod, $output, $L, $PHP_SELF, $item, $action;
	
	$title_links = array('bookmark'=>'off');
	
	if (isset($action) && $action == 'done') {
		
		$title = $L['pubThankYouMessage'];
		
		$content .= $output->getBeginTable();	
		
		$content .= $output->getTitleRow($title, $title_links);	
		
		$content .= $output->getTextRow('<a href="' . $PHP_SELF . '">' . $L['pubBack'] . '</a>');
		
		$content .= $output->getEndTable();	
		
		quickPage($content);
		
		exit();
		
	}
	
	if (!$item) {
			
		// Create a new item
		$item = array(
			'first_name' => '', 
			'last_name' => '', 
			'last_name'=>'',
			'email_address'=>'', 
			'subscribed'=>1
		);
	
	}
	
	
	//initialise $content variable for the page
	$content = '';
	$content .= $output->getBeginTable();
	$content .= $output->getTitleRow($L['pubSignupPageLabel'], $title_links);
	$content .= $output->getTextRow($L['pubDescriptionMessage']);
	$content .= $output->getSpacerRow();
	
		//nested data table ------------------
		$content .= $output->getBeginNestedTable();
		
		//form
		$content .= $output->getBeginForm($PHP_SELF);  

		
		foreach (getFormFields($item) as $k => $v) {
			
			$content .= $output->getHtmlFieldRow($v, $error_msg[$v['field_key']]);
			
		}
		
		$content .= $output->getSpacerRow();
		$content .= $output->getSubmitRow();
		$content .= $output->getSpacerRow();
		
		$content .= $output->getEndForm();
		//end form
	
		$content .= $output->getEndNestedTable();
		//end nested data table ------------------
		
		$content .= $output->getTextRow($L['pubCredits']);
	
	$content .= $output->getEndTable();
	
	$output->addToBody($content);
	$output->display();	
}

doSubmit();
main();

?>
