<?php
/**
 *
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Services
 */

/**
 * Message - prints message to screen
 * 
 * @author Phil Calder
 * @package Services
 */
class Message extends Service{
	
	/**
	 * Prints the given message
	 *
	 * @param $str message
	 */
	function display($str) {
		
		echo $str;
		
	}
	
	/**
	 * Displays a 'full page' message using a standard message template.
	 *
	 * @param $messages a string, or array of strings to display (will be concatenated).
	 * @param $footer boolean - optional, default false -  display 'setup' footer (links to phpinfo etc)
	 * @param $heading string - optional - a heading displayed before messages
	 */
	function displayMessage($messages, $footer = false, $heading = '') {
		global $BCRM_DOCUMENT_ROOT, $SERVICES, $base_dir;
		
		$config =& $SERVICES->getService('Config');
		$base_dir = $config->lookup('site.websubdir');
		
		if (!is_array($messages)) {
			$messages = array($messages);
		}
		
		$message = '';
		
		if (!empty($heading)) {
			$message .= '<p class="head">' . $heading . '</p>';
			$message_title = $heading; // Phil 20060411
		}
		
	
		foreach ($messages as $k => $v) {
			$message .= '<p>' . $v . '</p>';
			
		}
		
		$message_body = $message; // Phil 20060411
		
		include($BCRM_DOCUMENT_ROOT . '/message.inc.php');
		die();
	}
}
?>