<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 *
**/

// optional GET vars for debugging or additional functionality
// $_GET['server_os']
// // $_GET['debug']
// if ($_GET['debug'])
// $_GET['check_php_config'] 	to force PHP config check and step 2 display
// $_GET['report_only']   shows step 2 page with no progress link - is called from app About page


if (!empty($_REQUEST)) extract($_REQUEST);
if (empty($PHP_SELF)) $PHP_SELF = $_SERVER['PHP_SELF'];


define('DEV_SHOW_MESSAGES', 0); // must be zero for shipping

//if ($_GET['debug']) {   //Matt
define('DEBUG', 0); // 0 = no debugging
//}

if (DEBUG) {
	if (isset($_SERVER) && is_array($_SERVER) && array_key_exists('REQUEST_URI', $_SERVER)) {
		setupLog($_SERVER['REQUEST_URI']);
	}
}

// Phil - 20050411 - Dont want to use REQUEST, but some automated setup scripts send allinput in through the query string
if (!isset($_POST) || !sizeof($_POST)) {
        $_POST = $_GET;
} 
// The 'robot' variable wants simpler output (ie 'Complete' when setup has successfully completed)
if (isset($_POST['robot']) && $_POST['robot']) {
	$_POST['robot'] = 1;
} else {
	$_POST['robot'] = 0;
}


//establish web server software
if ( strpos($_SERVER["SERVER_SOFTWARE"], 'Apache') !== false) {
	define('WEB_SERVER','Apache');	
} elseif ( strpos($_SERVER["SERVER_SOFTWARE"], 'IIS') !== false) {
	define('WEB_SERVER','IIS');	
}

//establish server os
if (isset($_GET['server_os']) && $_GET['server_os']) {   //Matt, for testing
	define('SERVER_OS',$_GET['server_os']);
} else {
	//MCR / Shoaib 20061120 if ( strpos($_SERVER["SERVER_SOFTWARE"], 'Win') !== false) {  
	if ((strpos($_SERVER["SERVER_SOFTWARE"], 'Win') !== false) || (strpos($_SERVER["SERVER_SOFTWARE"], 'IIS') !== false)) {
			
		define('SERVER_OS','Windows');	
	} elseif ( strpos($_SERVER["SERVER_SOFTWARE"], 'Trustix') !== false) {
		define('SERVER_OS','Trustix');
	} else {
		//*** use as default***
		
		//if (( strpos($_SERVER["SERVER_SOFTWARE"], 'Red Hat') !== false) || ( strpos($_SERVER["SERVER_SOFTWARE"], 'Fedora') !== false) || ( strpos($_SERVER["SERVER_SOFTWARE"], 'RedHat') !== false)) {
		define('SERVER_OS','Red Hat');
	}
}

if (!isset($no_inserts)) $no_inserts = 0; // perform db inserts
if (!isset($data_transfer)) $data_transfer = 0; // perform data transfer from multi db to single

//put licence in get string for support via phplivechat
$ver =  '5.001.00';

// get directory _above_ this file
$BCRM_DOCUMENT_ROOT = str_replace('/setup/index.php', '', __FILE__);
$BCRM_DOCUMENT_ROOT = str_replace('\setup\index.php', '', $BCRM_DOCUMENT_ROOT);  //for Windows
$messages[] = 'BCRM_DOCUMENT_ROOT: ' .$BCRM_DOCUMENT_ROOT . '<br>';

//MCR 20060106; get existing config file values
if (file_exists($BCRM_DOCUMENT_ROOT . '/' . 'config.inc.php')) {
	include_once($BCRM_DOCUMENT_ROOT . '/' . 'config.inc.php');
	if (isset($is_new_installation) && $is_new_installation) {  //flag that config was just written in previous step
		define('IS_UPGRADE', false);
	} else {
		define('IS_UPGRADE', true);
	}
} else {
	define('IS_UPGRADE', false);
	//MCR 20060424
	if (file_exists($BCRM_DOCUMENT_ROOT . '/' . 'default.config.inc.php')) {
		//get default config arra to determine default language
		include_once($BCRM_DOCUMENT_ROOT . '/' . 'default.config.inc.php');
		$default_config_login_lang = $config['login']['lang'];
		unset($config);
	}
}

define('SKIN_PATH', '../skins/plain/img');

// *********************************** //
	//MCR 20060419 - for testing PHPlets
	//define $item
	//	$DEBUG_TOOL_UPGRADE_VERSION = '4.158';  // 'to' version
	//	echo '<h1>PHP-let DEBUG SECTION ENABLED</h1>';
	//	$item = array();
	//define item here if you need it
	
	//define db connection if you need it
	//$link = @mysql_connect($item['mysql_host'], $item['mysql_root_username'], $item['mysql_root_password'])
	
	//	runPhpUpgradeScripts($item, '4.157', $link);
	//	exit();
// *********************************** //


// Phil 20051012 Added $built_tables_for_new_modules
// an array which can store module names to ignore when running upgrade scripts. 
// We do this because these modules have recently been added through function buildTablesForNewModules
// see functions buildTablesForNewModules and executeMysqlScript
$built_tables_for_new_modules = array();

//############## debug section ##########

//print_r(getUpgradeScripts(array(), '4.00'));
//die();

//############## end debug section ##########

$install_guide['root_dir_chmod'] = 'chmod ug+w ' . $BCRM_DOCUMENT_ROOT . ' -R<br>chown apache:apache ' . $BCRM_DOCUMENT_ROOT . ' -R';
$install_guide['root_dir_chmod_trustix'] = 'chmod ug+w ' . $BCRM_DOCUMENT_ROOT . ' -R<br>chown httpd:httpd ' . $BCRM_DOCUMENT_ROOT . ' -R';


$install_guide['mysql_install'] = '"up2date mysql" and "up2date mysql-server"';
$install_guide['mysql_install_wget'] = 'wget ftp://rpmfind.net/linux/fedora/core/2/i386/os/Fedora/RPMS/mysql-3.23.58-9.i386.rpm<br>
											rpm -Uvh mysql-3.23.58-9.i386.rpm';
$install_guide['mysql-server_install_wget'] = 'wget ftp://rpmfind.net/linux/fedora/core/2/i386/os/Fedora/RPMS/mysql-server-3.23.58-9.i386.rpm<br>
											rpm -Uvh mysql-server-3.23.58-9.i386.rpm';
											
$install_guide['mysql_rpm_q'] = '"rpm -q mysql" and "rpm -q mysql-server"';
$install_guide['mysql-server_start'] = 'service mysqld start';
$install_guide['mysql-server_start_on_boot'] = '/sbin/chkconfig --level 345 mysqld on';


$install_guide['php-mysql_install'] = 'up2date php-mysql';
$install_guide['php-mysql_install_wget'] = 'wget ftp://rpmfind.net/linux/fedora/core/updates/2/i386/php-mysql-4.3.8-2.1.i386.rpm<br>
											rpm -Uvh php-mysql-4.3.8-2.1.i386.rpm';

$install_guide['php-imap_install'] = 'up2date php-imap';
$install_guide['php-imap_install_wget'] = 'wget ftp://rpmfind.net/linux/fedora/core/updates/2/i386/php-imap-4.3.8-2.1.i386.rpm<br>
											rpm -Uvh php-imap-4.3.8-2.1.i386.rpm';

$install_guide['apache_allow_override'] = '' . htmlentities('<') . 'Directory "' . $BCRM_DOCUMENT_ROOT . '"><br>&nbsp;&nbsp;&nbsp;&nbsp;AllowOverride All<br>' . htmlentities('<') . '/Directory><br>';
$install_guide['apache_restart'] = 'apachectl graceful';
$install_guide['apache_vi_conf_file'] = 'vi /etc/httpd/conf/httpd.conf';

$install_guide['file_type_block_list'] = '*.inc, *.conf, *.config, *.inc.php, *.txt';

// used in getReconfigureTextFromOldVersions
$install_guide['auto_prepend_error'] = 'The auto_prepend_file is set to hub/hub.inc from a previous BrowserCRM installation.';
$install_guide['htaccess_apache_conf'] = 'BrowserCRM no longer requires settings in the Apache config file and you need to remove parts of your Apache config file that were for previous versions of BrowserCRM.';

$install_guide['remove_apache_conf_lines'] = 'Typically, the lines to remove will look like the following (in some cases a subset of these lines):';
$install_guide['detailed_apache_setup'] = '
' . htmlentities('<') . 'Directory "/' . htmlentities('<') . 'path>/browsercrm"><br>
					&nbsp;&nbsp;&nbsp;&nbsp;#tell apache not to look for .htaccess files<br>
					&nbsp;&nbsp;&nbsp;&nbsp;AllowOverride None<br>
					&nbsp;&nbsp;&nbsp;&nbsp;<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#deny web access to inc and conf files etc<br>
					&nbsp;&nbsp;&nbsp;&nbsp;' . htmlentities('<') . 'Files ~  "((\.(inc|bkp|bak|conf|config|inc.php|txt))|~)$"><br>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Order allow,deny<br>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Deny from all<br>
					&nbsp;&nbsp;&nbsp;&nbsp;' . htmlentities('<') . '/Files><br>
					' . htmlentities('<') . '/Directory><br>
					<br>
					' . htmlentities('<') . 'Directory "/' . htmlentities('<') . 'path>/browsercrm/data"><br>
					&nbsp;&nbsp;&nbsp;&nbsp;#tell apache not to look for .htaccess files<br>
					&nbsp;&nbsp;&nbsp;&nbsp;AllowOverride None<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#deny web access<br>
					&nbsp;&nbsp;&nbsp;&nbsp;Order deny,allow<br>
					&nbsp;&nbsp;&nbsp;&nbsp;Deny from all<br>
					' . htmlentities('<') . '/Directory><br>
					&nbsp;&nbsp;&nbsp;&nbsp;<br>
					and, within your virtual host block:<br>
					&nbsp;<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#to run the BrowserCRM test scripts, comment out the next line with #<br>
					&nbsp;&nbsp;&nbsp;&nbsp;php_value auto_prepend_file /' . htmlentities('<') . 'path>/browsercrm/hub/hub.inc<br>
					&nbsp;&nbsp;&nbsp;&nbsp;php_value session.auto_start 0<br>
					<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#if you are using PHP 4.3 you need to uncomment the following line<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#php_value allow_call_time_pass_reference 1<br>
					&nbsp;&nbsp;&nbsp;&nbsp;<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#the following lines ensure these two variables are correct although<br>
					&nbsp;&nbsp;&nbsp;&nbsp;#they may be set in your php.ini file<br>
					&nbsp;&nbsp;&nbsp;&nbsp;php_value register_globals 1<br>
';

$install_guide['keep_virtual_host_settings'] = 'You will still need to keep lines necessary to your Virtual Host configuration such as ServerName and DocumentRoot';
$install_guide['refresh_reload'] = 'Then refresh this page.';


// get Setup language file
// get base lang file (en)
if (file_exists($lang_file = '../lang/en/Setup.inc')) {
	include_once($lang_file);
}
if (file_exists($lang_file = '../lang/en/_Global.inc')) {
	include_once($lang_file);
}

if (isset($_GET['language'])) {
	$language = $_GET['language'];
} else if (isset($_POST['language'])) {
	$language = $_POST['language'];
} else if (isset($config['login']['lang'])) {
	$language = $config['login']['lang'];
} else if (isset($default_config_login_lang) && $default_config_login_lang) {
	$language = $default_config_login_lang;
}
	
// also include other lang file if set
if (isset($language)) {
	$lang_file = '../lang/'.$language.'/_Global.inc';
	if (file_exists($lang_file)) {
		include_once($lang_file);
	}
	$lang_file = '../lang/'.$language.'/Setup.inc';
	if (file_exists($lang_file)) {
		include_once($lang_file);
	}
}


function deployHtAccess() {
	//MCR 20051109   
	// TODO add testing of various htaccess options in a subdir then, 
	// if htaccess php_values are allowed, deploy the 'recommended' htaccess file
	
	if (!(is_file('../.htaccess.block') || is_file('.htaccess.block'))) {  //MCR 20051109 in case we need to completely avoid htaccess deployment for a customer, we could write this flag file
		if (!is_file('../.htaccess') && is_file('../default.htaccess')) {
			writeBcrmHtAccessFile();
		} elseif (is_file('../.htaccess') && is_readable('../.htaccess')) {
			//read, check for auto_prepend
			$filename = "../.htaccess";
			$handle = @fopen($filename, "r");
			$contents = @fread($handle, filesize($filename));
			@fclose($handle);
			
			if (strpos($contents, 'auto_prepend_file') !== false) {
				//seems to be our pre 3.0 htaccess
				unlink('../.htaccess');
				writeBcrmHtAccessFile();
			}
		}
	}
}


$messages = array();

function displayMessage($messages, $footer = true) {
	global $L;
	
	if (DEBUG) { setupLog('display message (count: ' . sizeof($messages) . ')'); }
	
	$message_title = $L['setupTitleSetup'] . (IS_UPGRADE ? ' -- ' . $L['setupTitleUpgrade']. '' : '');
	
	$message_body = '';
	foreach ($messages as $k => $v) {
		$message_body .= $v;
	}
	
	global $base_dir, $PHP_SELF;
	$base_dir = trim(substr($PHP_SELF, 0, strpos($PHP_SELF, 'setup')), '/'); // This is the sub directory we were in
	
	define('MESSAGE_SHOW_HELP', 1);
	$so_link = getNewsPage(true); // Setup Offer
	include('../message.inc.php');
	die();
}


//----------------sequence----------------

if (!isset($step) || !$step) {
	$step = 1;
}

switch ($step) {
	
	case '1':
		//initialisation section
	
		// MCR 20051109 deployHtAccess moved to here; previously was deploying on every page load, 
		// so if you had to delete it for server 500 errors, it would be recreated
		
		//MCR 20060608; will no longer auto-deploy .htaccess
		//TODO add testing in a subdir and then deploy if permitted
		//deployHtAccess();  
		
		if ( ! (isset($GET['language']) || isset($POST['language']))) {
			confirmLanguage();
		}
		break;
		
	
	case 2 :
		//getNewspage(); // Phil 20061114 removed
		testWebServer();
		break;
		
	case 3 :
		selectDatabaseOption();
		break;
		
	case 4:
		if (isset($submit) && $submit) {
			//confirm that the 'bcrm' passwords are identical
			if ($item['mysql_password1'] != $item['mysql_password2']) {
				header('Location: ./index.php?step=4&error=mysql_pwd_no_match' . getQueryString());
				exit();
			}
			//check password is not blank
			if (!$item['mysql_password1']) {
				header('Location: ./index.php?step=4&error=mysql_pwd_blank' . getQueryString());
				exit();
			}
			
			//check password is not blank
			if (!$item['mysql_host']) {
				header('Location: ./index.php?step=4&error=mysql_host_blank' . getQueryString());
				exit();
			}
			
			//allow blank root password; some installations have blank root password; probably no need to log in as root if user already exists
			
			// For serious debugging only
			// ob_start();
			// print_r($item);
			// $msg = nl2br(ob_get_contents());
			// ob_end_clean();
			// if (DEBUG) { setupLog('**** SETUP info *****.'); }
			// if (DEBUG) { setupLog($msg); }
			// if (DEBUG) { setupLog('-----------------'); }

			
			//MCR 20040908
			//try to connect to mysql; give priority to a root connection if it has been supplied
			//if root password supplied; use that only; require that it works
			$is_root_connection = 0;
			if (isset($item['mysql_root_username']) && $item['mysql_root_username'] && isset($item['mysql_root_password']) && $item['mysql_root_password']) {
				if (DEBUG) { setupLog('root username and password supplied.'); }
				
				if ( ! ($link = @mysql_connect($item['mysql_host'], $item['mysql_root_username'], $item['mysql_root_password'])) ) {
					if (DEBUG) { setupLog('Couldnt connect with supplied root username and password.'); }
					
					//special, try 'admin' instead or provided root user, usually 'root'
					if ( ! ($link = @mysql_connect($item['mysql_host'], 'admin', $item['mysql_root_password'])) ) {
						if (DEBUG) { setupLog('Could not connect as root user from special connection.'); }
					
						//try to connect to server to see if is running
						@mysql_connect($item['mysql_host'], 'xsxjd8i', 'xcdfs9lk'); //junk to make an invalid login
						$mysql_error_message = strtolower(mysql_error());
						
						if (strpos($mysql_error_message, 'access denied') === false) {  //then probably no mysql server
							header('Location: ./index.php?step=4&error=mysql_could_not_connect_no_server' . getQueryString());
							exit();
						} else {
							header('Location: ./index.php?step=4&error=mysql_root_login_incorrect' . getQueryString());
							exit();
						}
					
					} else {
						//continue
						if (DEBUG) { setupLog('connected as root \'admin\' user from special connection'); }
						
						//return $link;
						$is_root_connection = 1;
					}
					
				} else {
					//continue
					if (DEBUG) { setupLog('connected as root user with supplied root username and password');}
					
					//return $link;
					$is_root_connection = 1;
				}
				
			} else {
				//try with blank root password - some installations are set up like this!
				// Phil 200602 Adding check for root username
				if ( (isset($item['mysql_root_username']) && $item['mysql_root_username']) && ($link = @mysql_connect($item['mysql_host'], $item['mysql_root_username'], '')) ) {
					//continue
					if (DEBUG) { setupLog('connected as root user with supplied root username and password at second attempt');}
					
					$is_root_connection = 1;
					//return $link;
				} else {
					
					// Debug
					if (isset($item['mysql_root_username']) && $item['mysql_root_username']) {
						if (DEBUG) { setupLog('Could not connect as root user with supplied root username and password at second attempt');}
					} else {
						if (DEBUG) { setupLog('No root user supplied');}
					}
					//
					if (DEBUG) { setupLog('Attempting to connect as bcrm user');}
					
					if ( ! ($link = @mysql_connect($item['mysql_host'], $item['mysql_username'], $item['mysql_password1'])) ) {
						if (DEBUG) { setupLog('Could not connect as bcrm user');}
						
						//try to connect to server to see if is running
						@mysql_connect($item['mysql_host'], 'xsxjd8i', 'xcdfs9lk'); //junk to make an invalid login
						$mysql_error_message = strtolower(mysql_error());
						
						if (strpos($mysql_error_message, 'access denied') === false) {  //then probably no mysql server
							//echo 'no server';
							if (DEBUG) {setupLog('MYSQL server not running');	}
							
							header('Location: ./index.php?step=4&error=mysql_could_not_connect_no_server' . getQueryString());
							exit();
						} else {
							
							//echo 'server, got access denied msg';
							//mysql is running, so return could not connect
							header('Location: ./index.php?step=4&error=mysql_could_not_connect' . getQueryString());
							exit();
						}
					} else {
						//continue
						if (DEBUG) {setupLog('connected as bcrm user');	}
						//return $link;
					}
				}
			}
			// end get connection 'link'
			if (DEBUG) {setupLog('End of connect block');	}
			
			//MCR 20061122
			//run MySQL 5+ strict mode off query
			//$query = "SET SESSION @@sql_mode=''"; //ok too I think
			if ( @mysql_get_server_info() >= '5.0' ) {
				if (DEBUG) { setupLog('MySQL >= 5.0. Query: SET @@session.sql_mode=\'\' '); }
				$query = "SET @@session.sql_mode=''";
				if ( ! ($result = mysql_query($query)) ) { 
					if (DEBUG) { setupLog('Error setting @@session.sql_mode=\'\' '); }
						_checkMysqlError($link, $query, $L['setupMysqlErrorSettingStrictModeOff']);
					return false;
				}
			}
			
			
			
			if (isset($item['mysql_prefix']) && $item['mysql_prefix'] && substr($item['mysql_prefix'], strlen($item['mysql_prefix'])-1) != '_') {
				$item['mysql_prefix'] .= '_';
			}
			
			$current_version = getCurrentVersionFromDb($item, $link);
			
			if (DEBUG) {setupLog('current version from db: ' . $current_version . '');	}
			
			$upgrade_to_211 = 0; // Phil 20060526 Need to initialise this variable
			
			if ($current_version < 4.624) { // Phil 20070825
				if (DEBUG) {setupLog('DEBUG: upgrade from ' . $current_version);}
				
				$_upg_message = '<div>
				You cannot upgrade to version 5 without first upgrading to version 4.624 or greater.
				<br />
				Packages can be downloaded here:
				<br />
				<a href="http://www.browsercrm.com/download/browsercrm-4.624.90.tar.gz">http://www.browsercrm.com/download/browsercrm-4.624.90.tar.gz</a>
				<br />
				<a href="http://www.browsercrm.com/download/browsercrm-4.624.90.exe">http://www.browsercrm.com/download/browsercrm-4.624.90.exe</a>
				</div>';
				
				die($_upg_message);
			}
			
			//TEMP
			if ($current_version < '4.69') {
				// Phil 20070825 Run the v4 to v5 upgrade script
				$v4tov5_upgrade_file = 'v4tov5_upgrade.php';
				// print '<div>look for file ' . $v4tov5_upgrade_file . '</div>';
				if (file_exists($v4tov5_upgrade_file) && is_readable($v4tov5_upgrade_file)) {
					
					setupLog('Loading v4 to v5 upgrade script'); 
					
					$v4tov5_upgrade_sql_file = 'sql/upgrades/db_v4tov5_upgrade.sql';
					// print '<div>look for file ' . $v4tov5_upgrade_sql_file . '</div>';
					if (file_exists($v4tov5_upgrade_sql_file) && is_readable($v4tov5_upgrade_sql_file)) {
						// Run hard coded upgrade script
						// print '<div>running script</div>';
						global $skip_all_errors;
						$skip_all_errors = true;
						
						$v4tov5_upgrade_sql_file = substr($v4tov5_upgrade_sql_file, 4);
						
						executeMysqlScript($item, $v4tov5_upgrade_sql_file, $link);
						$skip_all_errors = false;
						setupLog('Finished v4 to v5 database upgrade script'); 
					}
					// print '<div>loading upgrade class script</div>';
					// error_reporting(E_ALL);
					include_once($v4tov5_upgrade_file);
					// print '<div>get current version</div>';
					$current_version = getCurrentVersionFromDb($item, $link); // Need to check for upgraded version
					
					setupLog('Finished v4 to v5 upgrade script');
					setupLog('Upgraded db version: ' . $current_version); 
					
					// ----------
					// Remove entries to deprecated modules
					// getCurrentModules
					// Look for Address*, Accounts, get ids
					// _deleteCurrentModules($ids, $item = false, $link = false)
					$_remove_v4_mods = array(
						'Accounts', 
						'AddressEmail', 
						'AddressFax', 
						'AddressPhone', 
						'AddressPostal', 
						'AddressPhysical', 
						'AddressURL'
					);
					$current_modules = getCurrentModules($item, $link);
					$_remove_v4_mod_ids = array();
					foreach ($current_modules as $k => $v) {
						if (isset($v['name']) && in_array($v['name'], $_remove_v4_mods)) {
							$_remove_v4_mod_ids[] = $v['id'];
						}
					}
					_deleteCurrentModules($_remove_v4_mod_ids, $item, $link);
					// ----------
					
					// Tidy up
					purgeCache();
					createCacheDir();
					
					// Phil - upgrade script sets db version to 4.999. 
					// We may still need to run other upgrade scripts
					// If not, we are finished
					if ($current_version == getUpgradeVersion()) {
						// Redirect and exit
						$query_str = array();
						$query_str[] = 'step=complete';	
						if (isset($_POST['robot']) && $_POST['robot']) { // Phil 20050411
							$query_str[] = 'robot=' . $_POST['robot'];
						}
						$next_link = './index.php?' . implode('&', $query_str);
						header('Location: ' . $next_link);
						$txt_complete = ($L['setupComplete'] ? $L['setupComplete'] : 'Complete');
						$txt_next = ($L['setupNextStep'] ? $L['setupNextStep'] : 'Next');
						
						exit($txt_complete . ' <a href="' . $next_link . '">' . $txt_next . '</a>');
					
					}
					
				} else {
					setupLog('Unable to find v4 to v5 upgrade script'); 
					die('You cannot upgrade a pre 5.x installation yet. Please select a new database.');
				}
			}
			
			
			if (DEBUG && $no_inserts) {	setupLog('current version from db: ' . $current_version . ', no inserts');	}
			if (DEBUG && !$no_inserts) {setupLog('current version from db: ' . $current_version . ', - inserts'); }
			
			$messages = doInstall($item, $current_version, $upgrade_to_211, $link, $is_root_connection);
			if (DEBUG) { setupLog('Finished "do" install'); }
			displayMessage($messages);
			
		} else {
			// load form for input
			$messages[] = getInputForm($step);
			displayMessage($messages);
		}
		break;
		
	case 'complete':
		// Phil - 20040411
		if(isset($_POST['robot']) && $_POST['robot']) { // An automated install script waits for the output 'Complete' message
			print 'Complete'; 
			exit();
		}
		
		$messages[] = '<p>' . $L['setupComplete'] . '</p>';
		$messages[] = '<p>' . '&nbsp;' . '</p>';
		
		if (isset($defaultpwd) && $defaultpwd) {
			$messages[] = '<p><ul>' . $L['setupProductStart2'] . '</ul></p>';
			$messages[] = '<p><ul>' . $L['setupProductStartUsername'] . ' \'admin\'<br>' . $L['setupProductStartPassword'] . ' \'admin\'' . '</ul></p>';
		}
		
		$messages[] = '<p>' . '&nbsp;' . '</p>';
		
		$messages[] = '<p>&nbsp;</p><div class="eButtTxt" align="center"><div>';
		$messages[] = '<p class="Continue"><a href="../' . (ini_get('safe_mode') ? '?language=' . $language : '') . '">' . $L['setupProductStart1'] . ' &gt</a></p>';
		$messages[] = '</div></div>';
		
		$messages[] = '<p>' . '&nbsp;' . '</p>';
		$messages[] = '<p>' . '&nbsp;' . '</p>';
		if (WEB_SERVER == 'Apache') {
			$messages[] = '<p>' . $L['setupProductStart3'] . ', '  . $BCRM_DOCUMENT_ROOT . '/.htaccess </p>';
		}
		
		$messages[] = '<p>' . '&nbsp;' . '</p>';
		displayMessage($messages);
		break;
		
	default:
		die ('Reached undefined install step.');
		break;
}
	

//------------------ functions ------------------

function isDefaultAdminPassword() {
	$query = "SELECT password FROM System__users where id = 1"; //get default installed admin user; name may change with multi-lingual later
	if ( ! ($result = mysql_query($query)) ) { 
		_checkMysqlError($link, $query);
		return $messages;
	}
	
	while ($line = mysql_fetch_row($result)) {
		$password = $line[0];
	}
	
	if (($password == '43e9a4ab75570f5b') || ($password == '*4ACFE3202A5FF5CF467898FC58AAB1D615029441')) {  //password encrypted 'admin'; 2nd is for mysql 4.1.1+
		setupLog('Admin password detected as default, eg admin');
		return true;
	} else {
		setupLog('Admin password detected as non - default');
		return false;
	}
}


function remove_directory_recursive($dirname, $contents_only = false) {
	if (is_file($dirname)) {       
		// print '<div>file: ' . $dirname . '</div>';
		return unlink($dirname);
	} else if (is_dir($dirname))  {   
		// Loop through the folder    
		$dir = dir($dirname);    
		while (false !== ($entry = $dir->read())) {
			if ($entry == '.' || $entry == '..') {            
				continue;        
			}       
			// delete directories              
			if (is_dir("$dirname/$entry")) {            
				remove_directory_recursive("$dirname/$entry");        
			} else {            
				unlink("$dirname/$entry");        
			}    
		}    
		// Clean up   
		$dir->close(); 
		if (!$contents_only) { // Phil 20060918
			return rmdir($dirname);
		}
	}
	
	return true; // default
	
}


function guessPreviousDataDir() {
	global $L, $BCRM_DOCUMENT_ROOT;
	
	$content = $BCRM_DOCUMENT_ROOT . '/data';
	
	//windows, for display to use in Windows format
	if (SERVER_OS == 'Windows') {
		$content = str_replace('/', '\\', $content);// for Windows
	}
	
	return $content; 
	
}

function createConfigFile($read_file_name, $write_file_name, $replace_list = '') {
	global $BCRM_DOCUMENT_ROOT, $is_new_installation;
	
	//read from template in this /setup dir
	$fp = fopen($read_file_name, "r");
	$contents = fread($fp, filesize($read_file_name));
	fclose ($fp);
	
	if (is_array($replace_list)) {
		foreach ($replace_list as $k => $v) {
			$contents = str_replace($k, $v, $contents);
		}
	}
	
	if (!file_exists($write_file_name)) {
		$is_new_installation = 1;
	}
	//write altered file in BCRM root dir
	if ($fp = fopen($write_file_name, "w")) {
		if (!fwrite($fp, $contents)) {
			
		} else {
		}
		fclose($fp);
		
	} else {
	}
}


function doInstall($item, $current_version, $upgrade_to_211, $link, $is_root_connection) {   //doInstall($item, $current_version ) {
	global $BCRM_DOCUMENT_ROOT, $L, $language, $lic, $ver, $no_inserts, $data_transfer, $is_new_installation;
	
	$messages = array();
	
	//test is root connection
	if (!$is_root_connection) {
		if ($current_version > 4.69) {
			//OK, uprading a previous installation, already has privs because has been able to read version
			if (DEBUG) { setupLog('bcrm user is already configured with access; has read version ' . $current_version . ' from db'); }
			
		} elseif ($current_version == 4.69) {  //new
			
			//deal with Powweb host type situation where user (and maybe db?) has been created; check privs, db 
			//has connection but no version
			
			// if (DEBUG) { setupLog('Attempting to test/update strict mode'); }
			// testStrictMode($is_root_connection);
			
			if (@mysql_select_db($item['mysql_dbname'])) {
				//(empty) db exists
				if (DEBUG) { setupLog('bcrm user exists and successfully selected db ' . $item['mysql_dbname'] . '; assume it is empty since version was not read'); }
				
			} else {
				//try to create db; if user can't create db then we can't proceed.
			if (DEBUG) { setupLog('bcrm user exists; about to create database'); }
				$query = 'CREATE DATABASE ' . $item['mysql_dbname'];
				if ( ! ($result = mysql_query($query)) ) {
					if (DEBUG) { setupLog('bcrm user could not create database'); }
					header('Location: ./index.php?step=4&error=user_without_db_needs_root' . getQueryString());
					exit();
				} else {
					if (DEBUG) { setupLog('created database ' . $item['mysql_dbname']); }
				}				
			}
		
		} else {
			//will never get here, earlier code ensures a pre 2.99 install must have a root connection
			die('Oops. Shouldn\'t be here. Contact BrowserCRM Support.');
		}
		
	} else {
		// when root is provided,
		// create and/or update mysql privs for bcrm user

		// if (DEBUG) { setupLog('Attempting to test/update strict mode'); }
		// testStrictMode($is_root_connection);
		
		
		if (DEBUG) { setupLog('Attempting to create/update bcrm user'); }
				
		$query = 'mysql';
		if ( ! mysql_select_db($query) ) {
			_checkMysqlError($link, 'USE ' . $query, $L['setupMysqlErrorCreatingUser']);
			return $messages;
		}
		
		if (DEBUG) { setupLog('Attempting to grant privileges to bcrm user'); }
		
		$query = "GRANT ALTER,DELETE,INDEX,INSERT,SELECT,UPDATE,CREATE,DROP ON " . $item['mysql_dbname'] . ".* 
				TO " . $item['mysql_username'] . "@" . $item['mysql_host'] . " IDENTIFIED BY '" . $item['mysql_password1'] . "'";
		if ( ! ($result = mysql_query($query)) ) { 
			_checkMysqlError($link, $query);
			return $messages;
		} else {
			if (DEBUG) { setupLog('Grant privs OK'); }
		}
		
		if (DEBUG) { setupLog('Attempting to update File privileges for user ' . $item['mysql_username'] . ''); }
		// this *IS* necessary; this privilege sets whether the user can read files; eg in the BrowserCRM Import
		$query = "UPDATE user set File_priv = 'Y' where User = '" . $item['mysql_username'] . "'";
		if ( ! ($result = mysql_query($query)) ) { 
			_checkMysqlError($link, $query);
			return $messages;
		} else {
			if (DEBUG) { setupLog('File priv OK'); }
		}
		
		if (DEBUG) { setupLog('Flushing privileges'); }
		$query = "FLUSH PRIVILEGES";
		if ( ! ($result = mysql_query($query)) ) { 
			_checkMysqlError($link, $query);
			return $messages;
		} else {
			if (DEBUG) { setupLog('flush OK'); }
		}
		
		if (DEBUG) { setupLog('Finished privileges'); }
	}
	
	//create new single db and/or tables where they don't already exist
	if ( ! mysql_select_db($item['mysql_dbname']) || !tableExists('System__version') ) { 

		// here we build the db, structure and data to the latest spec
		
		$structure_file = 'db_structure.sql';
		$default_data_file = 'db_default_data.sql';
		$data_file = 'db_lang_data_en.sql';
	
		//load structure
		if (DEBUG) { setupLog('loading structure and data'); }
		executeMysqlScript($item, $structure_file, $link); //this creates the db when necessary
		
		// Phil 20051003 - moved from below
		// build new tables for any new modules 
		// modules in code which don't yet have db structure in this installation
		buildTablesForNewModules($item);
		
		executeMysqlScript($item, $default_data_file, $link); //this creates the db when necessary
		
		if ($item['mysql_sample_data_load']) {
			if (DEBUG) { setupLog('requesting sample data: ' . $data_file ); }
			
			//load data def
			executeMysqlScript($item, $data_file, $link);
		} else {
			if (DEBUG) { setupLog('skipped sample data: ' . $data_file ); }
		}
		
	} else {
		
		// Phil 20051017
		// Ensure module id and group permissions are correct
		checkModules($item, $link, $current_version);
		
		// Phil 20051003 - 
		// 2nd param = true, ie populate the list of tables/modules we dont want to upgrade.
		// DOES NOT execute any sql (will do this after running upgrade scripts)
		buildTablesForNewModules($item, true);
		
		// we only get here if the single db structure existed already, so 3.0+
		// run upgrade scripts for versions after 3.0 
		upgradeBcrmDatabases($item, $current_version, $link);
		
		// Phil 20051003
		// build new databases for any new modules 
		// modules in code which don't yet have db structure in this installation
		buildTablesForNewModules($item);
	}
	
	// Phil 20050720 - Added to provide functionality to run php upgrade scripts
	runPhpUpgradeScripts($item, $current_version, $link);
	
	//create data dir
	createDataDirectory($item);
	
	//create custom directories
	createCustomDirectories();
	//write config.inc.php file
	writeBcrmConfigFile($item);
	
	// Phil 20051003 - moved buildTablesForNewModules to 2 places (above)
	
	
	// Phil 20060918 Remove cached language and config file
	purgeCache();
	// Phil 20060920 Create cache dir (and lang) if they dont exist
	createCacheDir();
	
	
	$query_str = array();
	$query_str[] = 'step=complete';
	
	
	if (isset($_POST['robot']) && $_POST['robot']) { // Phil 20050411
		$query_str[] = 'robot=' . $_POST['robot'];
	}
	
	if (isDefaultAdminPassword()) {
		$query_str[] = 'defaultpwd=1';
	}
	
	//is also picked up by transfer page
	$next_link = './index.php?' . implode('&', $query_str) . getQueryString();
	
	// transfer from pre 3.x version; multi db to single db
	// MCR 2009-09-21	
	if ($current_version < 2.9) {
		if (DEBUG) { setupLog('current version < 2.9'); }
		
		die('Cannot upgrade to version 5 from here. Contact BrowserCRM support for help.');
	}
	
	if (DEBUG) { setupLog('Redirecting to ' . $next_link .''); }
	header('Location: ' . $next_link);
	exit();
}

function getQueryString() {
	global $language, $lic, $ver, $existing_db, $no_localhost_mysql, $is_new_installation;
	return '&language=' . $language . '&lic=' . $lic . '&ver=' . $ver . ($existing_db ? '&existing_db=' . $existing_db : '') 
	. ($no_localhost_mysql ? '&no_localhost_mysql=' . $no_localhost_mysql : '')
	. ($is_new_installation ? '&is_new_installation=' . $is_new_installation : '');
}


function getReloadLink($step, $lang_key = 'setupNextStep', $get_string = '') {
	global $L, $PHP_SELF;
	return '<p class="Continue"><a href="' . $PHP_SELF . '?step=' . $step . getQueryString() . $get_string .'">' . $L[$lang_key] . ' &gt</a></p>';
}

function getMysqlHostHtml() {
	global $config, $L, $no_localhost_mysql, $error;
	$content = '';
	
	if ($error == 'mysql_host_blank') {
		$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlHostBlank'] .'</p></td></tr>';
	}
	
	$content .= '<tr><th>' . $L['setupMysqlHost'] . '</th><td><input type="text" name="item[mysql_host]" size="20" ';
	if (IS_UPGRADE) {
		$content .= 'value="' . $config['database']['host'] . '" readonly class="rdOnly"';
	} else {
		$content .= 'value="' . ($no_localhost_mysql ? '' : 'localhost') . '" class="inTxt"';
	}
	$content .= '></td></tr>';
	
	return $content;
}

function getSampleDataHtml() {
	global $L;
	$content .= '
	<tr><td colspan="2"><p><b>' . $L['setupSampleData'] .'</b></p></td></tr>
	<tr><td colspan="2"><p>' . $L['setupSampleDataExplanation'] .'</p></td></tr>
	<tr><th><p>' . $L['setupSampleDataLoad'] . '</p></th><td><input type="checkbox" class="cb" name="item[mysql_sample_data_load]" value="1" checked></td></tr>
	<tr><td colspan="2">&nbsp;</td></tr>';
	return $content;
}

function getInputForm($step) {
	global $L, $BCRM_DOCUMENT_ROOT, $error, $install_guide, $DOCUMENT_ROOT, $PHP_SELF, $language, $lic, $ver;
	global $no_inserts, $data_transfer, $config, $existing_db, $no_localhost_mysql;
	
	$content = '<form action="' . $PHP_SELF . '?&step=' . $step . getQueryString() . '" method="post">
	<input type="hidden" name="item[mysql_multi_prefix]" value="';
	
	if (isset($item['mysql_multi_prefix'])) {
		$content .= $item['mysql_multi_prefix'];
	}
	
	$content .= '">
	<input type="hidden" name="data_transfer" value="' . $data_transfer . '">
	<input type="hidden" name="no_inserts" value="' . $no_inserts . '">
	<table cellpadding="2" cellspacing="0" border="0" width="100%">
	';
	
	//it is a new installation and offer sample data option
	if (!IS_UPGRADE) {
		//replace this line for some builds, DONT TOUCH THIS
		$content .= getSampleDataHtml();
	}
	
	$content .= '
	<tr><td colspan="2"><p><b>' . $L['setupMysqlTitle'] .'</b></p></td></tr>
	';
	
	$content .= '
	<tr><th><p>' . $L['setupMysqlDatabaseName'] . '</p></th><td><input type="text" name="item[mysql_dbname]" size="20" ';
	
	if (IS_UPGRADE) {
		$content .= 'value="' . $config['database']['dbname'] . '" readonly class="rdOnly"';
	} else {
		$content .= 'value="' . ($existing_db ? '' : 'browsercrm') . '" class="inTxt"';
	}
	$content .= '></td></tr>
	';
	
	if ($error == 'mysql_could_not_connect_no_server') {
		$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlCouldNotConnectNoServer'] .'</p></td>
		<tr><td colspan="2">&nbsp;</td></tr>';
	} elseif ($error == 'mysql_could_not_connect') {
		$content .= '
		<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlCouldNotConnect1'] .'</p></td>
		<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlCouldNotConnect2'] .'</p></td>';
		
		if (!IS_UPGRADE) {
			$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlCouldNotConnect3'] .'</p></td>
		';
		}
		$content .= '
		</td></tr>
		<tr><td colspan="2">&nbsp;</td></tr>';
	} elseif ($error == 'user_without_db_needs_root') {
		$content .= '<tr><td colspan="2">
		<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlUserWithoutDbNeedsRoot1'] .'</p></td>
		<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlUserWithoutDbNeedsRoot2'] .'</p></td>
		</td></tr>
		<tr><td colspan="2">&nbsp;</td></tr>';
	}
	
	
	$content .= '<tr><td colspan="2"><p>';
	if (IS_UPGRADE) {
		$content .= $L['setupMysqlUsernameExisting'];
	} else {
		$content .= $L['setupMysqlUsernameDetail'];
		if (!$existing_db) {
			$content .= ' ' . $L['setupMysqlUsernameDetail2'];
		}
	}
	$content .= '</p></td></tr>';
	
	
	$content .= '
	<tr><th><p>' . $L['setupMysqlUsername'] . '</p></th><td><input type="text" name="item[mysql_username]" size="20" ';
	
	if (IS_UPGRADE) {
		$content .= 'value="' . $config['database']['username'] . '" readonly class="rdOnly"';
	} else {
		$content .= 'value="' . ($existing_db ? '' : 'browsercrm') . '" class="inTxt"';
	}
	
	$content .= '></td></tr>';
	
	if ($error == 'mysql_pwd_no_match') {
		$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlPasswordsDontMatch'] .'</p></td></tr>';
	}
	
	if ($error == 'mysql_pwd_blank') {
		$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlPasswordBlank'] .'</p></td></tr>';
	}
	
	$content .= '<tr><td colspan="2"><p>' . ( IS_UPGRADE ? $L['setupMysqlPasswordMatchExisting'] : $L['setupMysqlPasswordDetail']) .'</p></td></tr>';
	 
	$content .= '
	<tr><th><p>' . $L['setupMysqlPassword'] . '</p></th><td><input type="password" class="inTxt" name="item[mysql_password1]" size="20"></td></tr>
	<tr><th><p>' . $L['setupMysqlPasswordConfirm'] . '</p></th><td><input type="password" class="inTxt" name="item[mysql_password2]" size="20"></td></tr>
	';
	$content .= '
	<tr><td colspan="2">&nbsp;</td></tr>
	';
	
	if (!(IS_UPGRADE || $existing_db)) {
	
		if ($error == 'mysql_root_login_incorrect') {
			$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlRootLoginIncorrect'] .'</p></td></tr>';
		}
		if ($error == 'mysql_root_login_not_supplied') {
			$content .= '<tr><td colspan="2"><p class="eInvalidSpan">' . $L['setupMysqlRootLoginNotSupplied'] . '</p></td></tr>';
		}
		
		$content .= '
		<tr><td colspan="2">' . $L['setupMysqlRootPasswordDetail'] .'</td></tr>
		<tr><th><p>' . $L['setupMysqlRootUserName'] . '</p></th><td><input type="text" class="inTxt" name="item[mysql_root_username]" size="20" value="root"></td></tr>
		<tr><th><p>' . $L['setupMysqlRootUserPassword'] . '</p></th><td><input type="password" class="inTxt" name="item[mysql_root_password]" size="20"></td></tr>
		';
		$content .= '
		<tr><td colspan="2">&nbsp;</td></tr>
		';
	
	}
	
	//put hostname stuff here if it will be requiring a (non localhost) value
	if (($no_localhost_mysql && (!IS_UPGRADE) ) || ($error == 'mysql_host_blank')) {
		$content .= getMysqlHostHtml();
		$flag_done_mysql_host_html = true;
	}
	
	// JACK 20060109 shows optional params
	//<tr><td colspan="2">&nbsp;</td></tr>
	
	//MCR
	$content .= '
	<tr><td></td><td class="commands">
	<a href="javascript:showHideTbody(\'optional\', \'optParam\', \'' . $L['setupAdvancedSettingsHide'] . '\', \'' . $L['setupAdvancedSettings'] . '\');"><span id="optParam">' . $L['setupAdvancedSettings'] . '</span>...</a></td></tr>
	<tbody id="optional" style="display:none;">
	';
	
	$content .= '
	<tr><td colspan="2">&nbsp;</td></tr>
	';
	
	//if (!$no_localhost_mysql && ($error != 'mysql_host_blank')) {
	if (!isset($flag_done_mysql_host_html) || !$flag_done_mysql_host_html) {
		$content .= getMysqlHostHtml(); 
		$content .= '<tr><td colspan="2">&nbsp;</td></tr>';
	}
	
	$content .= '
	<tr><td colspan="2"><p><b>' . $L['setupOtherOptions'] .'</b></p></td></tr>
	';
	
	$charsets = array(
		'iso-8859-1'=>'iso-8859-1', 
		'utf-8' => 'utf-8',
		'iso-8859-9'=>'iso-8859-9 (' . $L['setupCharsetForTurkish'] . ')',
		'iso-8859-2'=>'iso-8859-2 (' . $L['setupCharsetForEastEurope'] . ')',
	);
	$content .= '
	<tr><th><p>' . $L['setupSelectCharset'] . '</p></th>
	<td>';
	$content .= '<select class="inTxt" name="item[character_set]">';
	foreach ($charsets as $k =>$val) {
		$content .= '<option value="'.$k.'"'.($k=='iso-8859-1' ? ' selected' : '').'>'.$val.'</option>';
	}
	$content .= '</select>';
	$content .= '</td></tr><tr><td colspan="2">&nbsp;</td></tr>';
	
	//detect and generate form for data directory path
	$content .= '<tr><td colspan="2"><p><b>' . $L['setupDataDirTitle'] .'</b></p></td></tr>';
	
	if (IS_UPGRADE) {
		$content .= '<tr><th><p>' . $L['setupDataDirDataPathYour'] . '</p></th><td><input type="text" name="item[data_directory]" size="38" value="' . $config['files']['dir'] . '" readonly class="rdOnly"></td></tr>';
	} else {
		
		$content .= '<tr><td colspan="2"><p>' . $L['setupDataDirDetail1'] .'</p></td></tr>';
		
		$temp_data_dir = guessPreviousDataDir();
		
		if (	is_dir($temp_data_dir) && 
			is_dir($temp_data_dir . '/mail') && 
			// is_dir($temp_data_dir . '/intranet') && // Phil, 20050310 removed - MCR request
			is_dir($temp_data_dir . '/pspell')
			) 
		{
			//all directories match, looks like it is existing data dir
			$content .= '
			<input type="hidden" name="item[data_directory]" value="' . $temp_data_dir . '">
			<tr><th><p>' . $L['setupDataDirDataPathDetected'] . ': ' . '</p></th><td><p>"' . $temp_data_dir . '"</p></td></tr>';
				
		} else {
			
			$content .= '<tr><td colspan="2"><p>' . $L['setupDataDirDetail2'] .'</p></td></tr>';
			$content .= '<tr><th><p>' . $L['setupDataDirBcrmPathYour'] . '</p></th><td><p>' . $BCRM_DOCUMENT_ROOT . '</p></td></tr>
			<tr><th><p>' . $L['setupDataDirDataPathYour'] . '</p></th><td><input type="text" class="inTxt" name="item[data_directory]" size="38" value="' . $temp_data_dir . '"></td></tr>';
		
		}
		
	}
	
	$content .= '<tr><td colspan="2">&nbsp;</td></tr>';
	
	// JACK 20060109 shows optional params
	$content .= '</tbody>';
	

	//detect and generate form for web sub directory
	$temp_web_sub_dir = $_SERVER["PHP_SELF"];
	$temp_web_sub_dir = str_replace('/setup/index.php', '', $temp_web_sub_dir);
	$temp_web_sub_dir = str_replace('/setup', '', $temp_web_sub_dir);
	$temp_web_sub_dir = trim($temp_web_sub_dir, '/');
	
	$content .= '<input type="hidden" name="item[web_sub_directory]" value="' . $temp_web_sub_dir . '">';
		
	$content .= '
	<tr><td></td><td><input type="submit" name="submit" value="' . $L['setupInstallButton'] . '" style="width: 140px"></td></tr>
	</table>
	</form>
	';
	return $content;
}


function createSubDirectory($dir) {
	if (DEBUG) { setupLog('Create sub directory ' . $dir .''); }
	global $L;
	
	if (mkdir($dir, 0770)) {
	} else {
		$message = '<p><span class="eInvalidSpan"><b>' . $L['setupError'] . '</b></span>: ' . $L['setupDataDirCannotCreate'] . ' ' . $dir . '</p>';
		
		//TODO add manual mkdir message
	}
	
	return $message;
}

function createCustomDirectories() {
	// Dont create these directories, they are created when required
	// modules_custom: lookup('modules.custom_basedir')
	// modules_ext: lookup('modules.extension_basedir')
	// lang_custom: lookup('site.customlangdir')
	// webmat_custom: lookup('webmat.customdir')
}

function createDataDirectory($item) {
	global $L, $BCRM_DOCUMENT_ROOT, $step, $install_guide;
	
	if (DEBUG) { setupLog('Create data directory'); }
	
	$messages = array();
	
	//check for existing dir
	if (is_dir($item['data_directory'])) {
		//check that tree is correct, otherwise print HowToFix message
		
	} else {
		if (mkdir($item['data_directory'], 0770)) {
			//write htacccess file in the datadir
			$messages[] = createConfigFile('default.datadir.htaccess', $item['data_directory'] . '/' . '.htaccess');
			
			$messages[] = createSubDirectory($item['data_directory'] . '/' . 'mail');
			$messages[] = createSubDirectory($item['data_directory'] . '/' . 'files');
			$messages[] = createSubDirectory($item['data_directory'] . '/' . 'backup');
			// $messages[] = createSubDirectory($item['data_directory'] . '/' . 'intranet'); // // Phil, 20050310 removed - MCR request
			//$messages[] = createSubDirectory($item['data_directory'] . '/' . 'pspell');
			//$messages[] = createSubDirectory($item['data_directory'] . '/' . 'customlang'); // Phil 20050404 - no longer using this custom lang dir (see Service::Language)
			$messages[] = createSubDirectory($item['data_directory'] . '/' . 'tmp');
			
		} else {
			$messages[] = '<p><span class="eInvalidSpan"><b>' . $L['setupError'] . '</b></span>: ' . $L['setupDataDirCannotCreate'] . ' ' . $item['data_directory'] . '</p>
					<p>' . $L['setupFileWriteTestChangePermissions'] . '</p>
					<ul>' . $install_guide['root_dir_chmod'] . '</ul>';
			
		}
	}
}


function writeBcrmHtAccessFile() {
	global $L, $BCRM_DOCUMENT_ROOT;
	
	if (DEBUG) { setupLog('Write access file'); }
	
	//just write the file, no replace
	$replace_list = array('__DUMMY_prepend_file__' => 'x');
	createConfigFile($BCRM_DOCUMENT_ROOT . '/' . 'default.htaccess', $BCRM_DOCUMENT_ROOT . '/' . '.htaccess', $replace_list);  
}


function writeBcrmConfigFile($item) {
	global $L, $BCRM_DOCUMENT_ROOT;
	
	if (DEBUG) { setupLog('Write config file'); }
	
	$item['data_directory'] = str_replace('\\', '/', $item['data_directory']); // for Windows
	$item['data_directory'] = str_replace('//', '/', $item['data_directory']); // clean up
	
	
	$prefix = '';
	$dbname = $item['mysql_dbname']; // May need this, ie as $config['database']['dbname'] = '';
	
	
	$replace_list = array(
		'__mysql_host__' => $item['mysql_host'],
		'__mysql_prefix__' => $prefix, 
		'__mysql_dbname__' => $dbname, 
		'__mysql_username__' => $item['mysql_username'],
		'__mysql_password__' => $item['mysql_password1'],
		'__web_sub_directory__' => $item['web_sub_directory'],
		'__data_directory__' => $item['data_directory'],
		'__character_set__' => $item['character_set']
		);
	createConfigFile($BCRM_DOCUMENT_ROOT . '/' . 'default.config.inc.php', $BCRM_DOCUMENT_ROOT . '/' . 'config.inc.php', $replace_list);
	
	//test for old style config.inc file & remove
	if (is_file('../config.inc')) {  
		unlink('../config.inc');
	}

}

function createCacheDir() {
	global $BCRM_DOCUMENT_ROOT;
	$cache_dir = $BCRM_DOCUMENT_ROOT . '/cache';
	$cached_lang_dir = $BCRM_DOCUMENT_ROOT . '/cache/lang';
	
	$cache_dir_exists = false;
	$cached_lang_dir_exists = false;
	
	//check for existing dir
	if (is_dir($cache_dir)) {
		$cache_dir_exists = true;
	} else {
		// Create the cache dir
		$cache_dir_exists = mkdir($cache_dir, 0770);
	}
	
	if ($cache_dir_exists) {
		if (is_dir($cached_lang_dir)) {
			// OK
		} else {
			$cached_lang_dir_exists = mkdir($cached_lang_dir, 0770);
		}	
	}
	
	if (DEBUG) {
		if ($cache_dir_exists) {
			setupLog('Cache dir exists');
		} else {
			setupLog('Cache dir does not exist');
		}
		if ($cached_lang_dir_exists) {
			setupLog('Cached lang dir exists');
		} else {
			setupLog('Cached lang dir does not exist');
		}
	}
}

function purgeCache() {
	global $BCRM_DOCUMENT_ROOT;
	$cached_lang_dir = $BCRM_DOCUMENT_ROOT . '/cache/lang';
	$cached_config_file = $BCRM_DOCUMENT_ROOT . '/cache/compiled.config.inc.php';
	$cached_db_file = $BCRM_DOCUMENT_ROOT . '/cache/compiled.db.inc.php';
	
	if (file_exists($cached_lang_dir) && is_dir($cached_lang_dir)) {
		remove_directory_recursive($cached_lang_dir, true);
	}
	if (file_exists($cached_config_file) && is_file($cached_config_file)) {
		remove_directory_recursive($cached_config_file);
	}
	if (file_exists($cached_db_file) && is_file($cached_db_file)) {
		remove_directory_recursive($cached_db_file);
	}
}


// ============ Module id functions ====================
global $default_module_ids;
$default_module_ids = false;

// Phil 20051017
// Ensure module id and group permissions are correct
function checkModules($item = false, $link = false, $current_version = false) {
	// Rule of thumb:
	//
	// id: 1 - 199
	// standard modules
	//
	// id 200 - 299
	// Optional modules (may or may not be included in distribution)
	//
	// id: 300+
	// Custom modules
	
	if ( ($current_version === false) || ($current_version < 4.134) ) {
		$process_standard_modules = true;
	} else {
		$process_standard_modules = false;
	}
	
	$default_module_ids = getDefaultModuleIds();
	
	if (!is_array($default_module_ids)) {
		if (DEBUG) { setupLog('No default module ids - config file doesnt exist or is not readable'); }
		return false;	
	}
	// print '<div>default_module_ids:</div>'; print_r($default_module_ids); print '<hr>';
	
	$current_modules = getCurrentModules($item, $link);
	$current_modules_to_remove = array(); // Temporarily remove
	// print '<div>current_modules:</div>'; print_r($current_modules); print '<hr>';
	
	// Process in this order:
	// Unknown modules (non-custom)
	// Unknown modules (custom)
	// Modules
	foreach ($current_modules as $k => $v) {
		if (!array_key_exists($k, $default_module_ids)) {
			if ($v['is_custom']) {
				// Unknown modules (custom)
				$current_modules[$k]['new_id'] = _updateCustomModuleSettings($k, $v['id'], $item, $link);
			} else {
				// Unknown modules (non-custom)
				$current_modules[$k]['new_id'] = _updateUnknownModuleSettings($k, $v['id'], $item, $link);
			}
		} else {
			if ($process_standard_modules) {
				// Known modules (non-custom)
				$current_modules_to_remove[] = $v['id'];
				$current_modules[$k]['settings'] = getModuleGroups($v['id']);
			}
		}
	}
	
	
	if ($process_standard_modules) {
		// print_r($current_modules_to_remove); print '<hr>'; exit();
		_deleteCurrentModules($current_modules_to_remove, $item, $link);
		
		// Known modules (non-custom)
		foreach ($current_modules as $k => $v) {
			if (array_key_exists($k, $default_module_ids)) {
				if (!$v['is_custom']) {
					// Known modules (non-custom)
					$v['new_id'] = $default_module_ids[$k];
					// print '<div>---------update standard module old: ' . $v['id'] . ' to new: ' . $v['new_id'] . '</div>';
					$current_modules[$k]['new_id'] = _updateCurrentModuleSettings($v['id'], $v['new_id'],  $v['name'], $v['settings'], $item, $link);
				}
			}
		}
	}
	
	// print '<div>[2] current_modules:</div>'; print_r($current_modules); print '<hr>';
}

function _deleteCurrentModules($ids, $item = false, $link = false) {
	if (is_array($ids) && sizeof($ids) ) {
		
		$id_list = implode(', ', $ids);
		$query = 'DELETE FROM `System__modules` WHERE id IN (' . $id_list . ')';
		// print '<div>query: ' . $query . '</div>';
		if ( ! ($result = @mysql_query($query)) ) { 
			_checkMysqlError($link, $query);
			// print '<div>query: ' . $query . ' - false</div>';
			return false;
		} else {
			$retval =  @mysql_affected_rows();
			$query = 'DELETE FROM `System__module_group` WHERE module_id IN (' . $id_list . ')';
			if ( ! ($result = @mysql_query($query)) ) { 
				_checkMysqlError($link, $query);
				// print '<div>query: ' . $query . ' - false</div>';
				return false;
			}
			return $retval;	
		}
	}
	return true;
}

function getDefaultModuleIds() {
	global $default_module_ids, $config_default_modules;
	$setup_perms_config_file = 'sql/perms/config.inc.php';
	if (!is_array($default_module_ids) && file_exists($setup_perms_config_file) && is_readable($setup_perms_config_file)) {
		// include_once('../setup/sql/perms/config.inc.php');
		// print '<div>loading: ' . $setup_perms_config_file. '</div>'; exit();
		@include_once($setup_perms_config_file);
		$default_module_ids = array_flip($config_default_modules);	
	}
	// print '<div>cant load: ' . $setup_perms_config_file. '</div>'; exit();
	return $default_module_ids;
}

function getCurrentModules($item = false, $link = false) {
	
	$current_modules = array();
	$query = "SELECT * FROM System__modules";
	if ( ! ($result = @mysql_query($query)) ) { 
		_checkMysqlError($link, $query);
		return $current_modules;
	} 
	
	while ($row = @mysql_fetch_assoc($result)) {
		$current_modules[$row['name']] = $row;
	}	
	
	return $current_modules;
}

function _updateModuleId($old_id, $new_id, $item = false, $link = false) {
	$retval = false;
	$query = "UPDATE `System__modules` SET id = '$new_id' WHERE id = '$old_id'";
	
	if ($result = @mysql_query($query)) {
		$retval = @mysql_affected_rows();
		// print '<div>affected: ' . $retval . '</div>';
	}
	return $retval;
}

function _insertStandardModule($id, $module_name, $item = false, $link = false) {
	$retval = false;
	
	$query = "
	INSERT INTO `System__modules` 
	SET 
	id = '$id', 
	name = '$module_name', 
	is_custom = 0 
	";
	
	if ($result = @mysql_query($query)) {
		$retval = @mysql_affected_rows();
		// print '<div>_insertStandardModule affected: ' . $retval . ' for ' . $query . '</div>';
	}
	return $retval;
	
}

function getModuleGroups($id, $item = false, $link = false) {
	$retval = false;
	$query = "SELECT group_id, priv FROM `System__module_group` WHERE module_id = '$id'";
	
	if ( ! ($result = @mysql_query($query)) ) { 
		return false;
	} 
	
	$module_groups = array();
	
	while ($row = @mysql_fetch_assoc($result)) {
		$module_groups[$row['group_id']] = $row['priv'];
	}
	
	return $module_groups;	
}

function _updateModuleGroups($old_id, $new_id, $item = false, $link = false) {
	$retval = false;
	$query = "UPDATE `System__module_group` SET module_id = '$new_id' WHERE module_id = '$old_id'";
	if ($result = @mysql_query($query)) {
		$retval = @mysql_affected_rows();
		// print '<div>_updateModuleGroups(' . $old_id . ', ' . $new_id . ') affected: ' . $retval . '</div>';
	}
	return $retval;
}

function _insertModuleGroups($id, $settings, $item = false, $link = false) {
	$retval = false;
	if (!is_array($settings) || !sizeof($settings)) {
		$settings = array();
	}
	
	foreach ($settings as $k => $v) {
		$query = "INSERT INTO `System__module_group` (`module_id`, `group_id`, `priv`) VALUES ('$id', '$k', '$v')";
		if (! ($result = @mysql_query($query))) {
			if (DEBUG) { setupLog('query ERROR: ' . $query . ''); }
		}
	}
	return $retval;
}

function _getModuleInsertId($minimum = 300, $item = false, $link = false) {
	$query = 'SELECT id FROM `System__modules` ORDER BY id ASC';
	if ( ! ($result = @mysql_query($query)) ) { 
		_checkMysqlError($link, $query);
		return $messages;
	} 
	$current_modules_ids = array();
	while ($row = @mysql_fetch_assoc($result)) {
		$current_modules_ids[] = $row['id']; // print_r($row);
	}
	
	// print '<div>current_modules_ids</div>'; print_r($current_modules_ids); print '<hr>';
	$default_module_ids = getDefaultModuleIds();
	
	while ( in_array($minimum, $current_modules_ids) || in_array($minimum, $default_module_ids) ) {
		$minimum++;
	}
	// print '<div>new id = ' . $minimum . '</div>';
	
	return $minimum;
	
}

// Known modules (standard)
function _updateCurrentModuleSettings($old_id, $new_id, $module_name, $settings = false, $item = false, $link = false) {
	// print '<div>update module settings for [' . $module_name . ' -> ' . $new_id . ']</div>';
	
	if (_insertStandardModule($new_id, $module_name, $item, $link)) {
		// print ' inserted -> ' . $new_id . ']</div>';
		// _updateModuleGroups($old_id, $new_id);
		_insertModuleGroups($new_id, $settings, $item, $link); // Phil 20051018
		return $new_id;
	}
	
	//print ' -> no change]</div>';
	return $old_id;
}

// Unknown modules (custom)
function _updateCustomModuleSettings($old_id, $new_id, $item = false, $link = false) {
	// print '<div>update custom module settings for [' . $old_id . ' -> ' . $name . ' ';
	// Change id to > 299
	$minimum = 300;
	if ($old_id < $minimum) {
		$new_id = _getModuleInsertId($minimum, $item, $link);
		if (_updateModuleId($old_id, $new_id, $item, $link)) {
			// print ' -> ' . $new_id . ']</div>';
			_updateModuleGroups($old_id, $new_id);
			return $new_id;
		}
	}
	// print ' -> no change]</div>';
	return $old_id;
}

// Unknown modules (non-custom)
function _updateUnknownModuleSettings($old_id, $new_id, $item = false, $link = false) {
	// print '<div>update unknown module settings for [' . $old_id . ' -> ' . $name . ' ';
	// Change id to > 200
	$minimum = 200;
	if ($old_id < $minimum) {
		$new_id = _getModuleInsertId($minimum, $item, $link);
		if (_updateModuleId($old_id, $new_id, $item, $link)) {
			// print ' -> ' . $new_id . ']</div>';
			_updateModuleGroups($old_id, $new_id);
			return $new_id;
		}
	}
	// print ' -> no change]</div>';
	return $old_id;
}



// ============ End Module id functions =================

function upgradeBcrmDatabases($item, $current_version, $link) {
	global $BCRM_DOCUMENT_ROOT, $L;
	global $built_tables_for_new_modules; // Phil 20051012
	
	if (DEBUG) { setupLog('Upgrade database'); }
	
	// An array of upgrade scripts to run
	$upgrades = getUpgradeScripts($item, $current_version);
	
	if (DEBUG) {
		// print_r($upgrades);
		$tmp = "Upgrades:\n" . implode("\n", $upgrades) . "\n";
		setupLog($tmp);
	}
	
	// Phil 20051012
	$skip_modules = false;
	if (is_array($built_tables_for_new_modules) && sizeof($built_tables_for_new_modules)) {
		$skip_modules = $built_tables_for_new_modules;
		if (DEBUG) { 
			setupLog('Upgrade should skip modules:');
			$str = '[-- ';
			foreach ($skip_modules as $skk => $smv) {
				$str .= $smv . ' ';
			}
			$str .= ' --]';
			setupLog($str);
		}
	}
	
	foreach ($upgrades as $k => $upgrade) {
		// executeMysqlScript($item, $upgrade, $link);
		executeMysqlScript($item, $upgrade, $link, $skip_modules);
	}
		
}

/**
 * Looks for php upgrade script to run
 * @author Phil, 20050720
 */
function runPhpUpgradeScripts($item, $current_version, $link) {
	global $BCRM_DOCUMENT_ROOT;
	// An array of php upgrade scripts to run
	$upgrades = getPhpUpgradeScripts($item, $current_version);
	
	if (DEBUG) {
		//print '<div>runPhpUpgradeScripts: '; print_r($upgrades); print '</div>';
		$tmp = "PHP Upgrade scripts:\n" . implode("\n", $upgrades) . "\n";
		setupLog($tmp);
	}
	
	if (sizeof($upgrades)) {
		
		// The parent class for all php upgrades
		include_once($BCRM_DOCUMENT_ROOT . '/setup/sql/php/setup_standard_php_upgrade_class.php');
		
		foreach ($upgrades as $k => $upgrade) {
			$class_name = substr($upgrade, 0, (strlen($upgrade) - strlen('.php')) );
			$class_name = str_replace('.', '', $class_name);
			$class_name = str_replace('_', '', $class_name);
			
			include_once($BCRM_DOCUMENT_ROOT . '/setup/sql/php/' . $upgrade);
			if (class_exists($class_name) && is_callable(array($class_name,'main')) ) { //method_exists($class_name, 'main')) {
				$args = array(
					'item' => $item, 
					'link' => $link
				);
				
				setupLog('Calling php upgrade class: ' . $class_name . '');
				
				$tmp = new $class_name($args);
				$tmp->main();
			
			} else {
				setupLog('Class does not exist ' . $class_name . '');
			}
		}

	}	
}

// Phil 20051012 Modified to keep track of modules added here 
// so that we dont execute upgrade scripts/statements for these module later
// $built_tables_for_new_modules
// Phil 20051014 Added param $test_only. When true, this function populates the $built_tables_for_new_modules 
// variable but does not execute any sql. Use this to determine which tables/modules NOT to upgrade.
function buildTablesForNewModules($item, $test_only = false) {
	global $BCRM_DOCUMENT_ROOT, $L;
	global $built_tables_for_new_modules;
	
	// Phil 20051014
	if (DEBUG) { 
		if ($test_only) { 
			setupLog('store list of modules not to upgrade (ie new modules we will add later)'); 
		} else {
			setupLog('create databases for any new modules');
		}
	}
	
	
	//I'm using 2 mechanisms here to double check that we dont try to run a sql file when it already has been
	$query = "SHOW TABLES";
	if ( ! ($result = mysql_query($query)) ) { 
		_checkMysqlError($link, $query);
		return $messages;
	} 
	$db_modules = array();
	while ($line = mysql_fetch_row($result)) {
		$db_modules[] = substr($line[0], 0, strpos($line[0], '__'));
	}
	$modules_with_tables = array_unique($db_modules);
	if (DEBUG) { 
		setupLog('read unique table prefixes from db; installed modules are:');
		if (is_array($modules_with_tables)) {
			foreach($modules_with_tables as $k => $val) {
				setupLog($val);
			}
		}
	}
	
	
	if ( ! mysql_select_db($item['mysql_dbname'])) {
		if (DEBUG) { setupLog('couldn\'t select db ' . $item['mysql_dbname']); }
		_checkMysqlError($link, 'select_db: ' . $item['mysql_dbname']);
		return false;
	}

	$query = "SELECT name FROM System__modules";
	if ( ! ($result = mysql_query($query)) ) { 
		_checkMysqlError($link, $query);
		return $messages;
	} 
	
	while ($line = mysql_fetch_row($result)) {
		$modules_in_system[] = $line[0];
	}
	if (DEBUG) { 
		setupLog('read System__modules table; installed modules are:'); 
		if (is_array($modules_in_system)) {
			foreach($modules_in_system as $k => $val) {
				setupLog($val);
			}
		}
	}
	
	
	$dirname = $BCRM_DOCUMENT_ROOT . '/modules/';
	$handle = opendir($dirname);
	while ($dir = readdir($handle)) { 
	
		if (($dir=='.') || ($dir=='..')) { 
			continue;
		}
		
		$upgrade = 'structure/db_structure_' . $dir . '.sql';
		
		//if (DEBUG) { setupLog('testing that db is installed for module: ' . $dir ); }
			
		if (is_array($modules_in_system) && !in_array($dir, $modules_in_system)) { 
			if (is_array($modules_with_tables) && !in_array($dir, $modules_with_tables) && !in_array(strtolower($dir), $modules_with_tables)) {   //strtolower for windows 
				if (file_exists($BCRM_DOCUMENT_ROOT . '/setup/sql/' . $upgrade)) { 
			
						if (DEBUG) { setupLog('creating database for new module: ' . $dir ); }
						$built_tables_for_new_modules[] = $dir; // Phil 20051012
						
						if ($test_only === false) { // Phil 20051014
						
							//echo '<p>' . $dir . ' would add db';
							executeMysqlScript($item, $upgrade, $link);
							
							//add perms
							$upgrade = 'perms/db_perms_' . $dir . '.sql';
							if (file_exists($BCRM_DOCUMENT_ROOT . '/setup/sql/' . $upgrade)) {
								if (DEBUG) { setupLog('adding perms for new module: ' . $dir ); }
								executeMysqlScript($item, $upgrade, $link);
							}
							
							//add default data if reqd
							$upgrade = 'default_data/db_default_data_' . $dir . '.sql';
							if (file_exists($BCRM_DOCUMENT_ROOT . '/setup/sql/' . $upgrade)) {
								if (DEBUG) { setupLog('adding default data for new module: ' . $dir ); }
								executeMysqlScript($item, $upgrade, $link);
							}
							
						} // Phil 20051014 - test_only===false
						
				} else {
					if (DEBUG) { setupLog('mod structure file needed but not found: ' . $dir ); }
				}
						
			} else {
				//if (DEBUG) { setupLog('mod already has tables: ' . $dir ); }
			}
		} else {
			//if (DEBUG) { setupLog('mod already entered in System__modules: ' . $dir ); }
		}	
	}
}


// parse the script file, executing MySQL queries. Call _checkMysqlError for each query.
//
// Phil 20051012 Added param $skip_modules. Defaults to false.
// If this is an array containing module names, this function will not execute queries for those modules, 
// or Data definition queries which relate to those modules.
//
function executeMysqlScript($item, $script, $link, $skip_modules = false) {
	global $BCRM_DOCUMENT_ROOT, $no_inserts, $skip_all_errors;
	
	if (DEBUG) { setupLog('execute script: ' . $script . ''); }
	
	if (!file_exists($BCRM_DOCUMENT_ROOT . '/setup/sql/' . $script)) {
		if (DEBUG) { setupLog('no sql script: ' . $script . ''); }
		return false;	
	}
	
	$lines = file($BCRM_DOCUMENT_ROOT . '/setup/sql/' . $script);
	
	if (DEBUG) { setupLog('-------------'); }
	if (DEBUG) { setupLog('lines read from file: ' . sizeof($lines) . ''); }
	
	$queries = array();
	$temp_query = '';
	if (is_array($lines)) {
		foreach ($lines as $k => $line) {
			// $line = str_replace('bcrm_', $item['mysql_prefix'], $line);  //replace database prefix with the chosen one
			$line = str_replace('bcrm_', $item['mysql_dbname'], $line);  //replace database prefix with the chosen one
			
			if (strpos($line, 'browsercrm')) {
				// print '<p>Replacing "browsercrm" with "' . $item['mysql_prefix'] . '" in: ' . $line . '</p>';
				$line = str_replace('`browsercrm`', '`'.$item['mysql_dbname'].'`', $line);  // create `browsercrm` changed
				$line = str_replace('USE browsercrm', 'USE '.$item['mysql_dbname'].'', $line);  // USE browsercrm changed
				$line = str_replace('CREATE DATABASE browsercrm', 'CREATE DATABASE '.$item['mysql_dbname'].'', $line);  // CREATE DATABASE browsercrm changed
				
				if (strpos($line, 'DATABASE') && @mysql_select_db($item['mysql_dbname'])) {
					if (DEBUG) { setupLog('Removing CREATE DATABASE line from script: ' . $line . ''); }
					$line = str_replace('CREATE DATABASE '.$item['mysql_dbname'].'', '', $line);  // USE browsercrm changed
					$line = str_replace('CREATE DATABASE `'.$item['mysql_dbname'].'`', '', $line);  // USE browsercrm changed
				}
			}
			
			
			$line = trim($line);
			if (DEBUG) { setupLog('line: ' . $line . ''); }
			if (strlen($line) > 0) {
				if (substr($line, 0, 1) == '#') {
					//ignore
					//echo 'ignored ' . $line . '<br>';
					$temp_query = '';
				} else {
					$temp_query .= $line . "\n";
					//if (substr($line, (strlen($line))) == ';') {   //last char of line is semicolon; assume end of query
					if ($line != rtrim($line, ';')) {   //last char of line is semicolon; assume end of query
						$temp_query = rtrim(trim($temp_query), ';');
						
						// Phil 20051012 Added code to 'skip' queries for certain modules
						// Requires param $skip_modules - an array of modules NOT to process queries for
						// This should ONLY be set/used when running upgrade scripts.
						$skip_query = false;
						if (is_array($skip_modules) && sizeof($skip_modules)) {
							// TODO
							foreach ($skip_modules as $smk => $smv) {
								if (
									strlen($smv) 
									&& (strpos($temp_query, "`$smv" . "__") || ( strpos($temp_query, 'SystemDataDefinition') && strpos($temp_query, "'$smv" . "__") ) ) 
								) {
									$skip_query = true;
									break;
								}
							}
						}
						
						if ($skip_query === false) { // Phil 20051012 added if else
							$queries[] = $temp_query;
						} else {
							if (DEBUG) { setupLog('Skipping query: ' . $temp_query . ''); }
						}
						$temp_query = '';
					}
				}
			}
		}
	}
	
	if (DEBUG) { setupLog('-------------'); }
	if (DEBUG) { setupLog('queries to execute: ' . sizeof($queries) . ''); }
	foreach ($queries as $k => $query) {
		//echo 'query: ' . $query . '<br>';
		
		if ($no_inserts && substr($query, 0, strlen('INSERT')) == 'INSERT') {
			// Dont insert any data (for blank install - importing data from somewhere else later)
			
		} else if (substr($query, 0, strlen('CREATE DATABASE')) == 'CREATE DATABASE') { //CREATE or USE; set current database; don't pass USE query 
			//execute
			if (DEBUG) { setupLog('query: ' . $query . ''); }
			if ( ! ($result = mysql_query($query)) ) { 
				_checkMysqlError($link, $query, $L['setupMysqlErrorCreateError'] . ' - ' . $script . ' ' . $k);
				if (DEBUG) { setupLog('execute mysql script returning false for query<br>: ' . $query . '<br>in script: ' . $script . ''); }
				return false;
			}
			
			//set current db
			$query = str_replace('CREATE DATABASE ', '', $query);
			$query = str_replace('`', '', $query);
			$query = trim($query);
			if ( ! mysql_select_db($query) ) {
				_checkMysqlError($link, 'CREATE DATABASE ' . $query, ''  . ' - ' . $script . ' ' . $k);
				if (DEBUG) { setupLog('execute mysql script returning false for query<br>: ' . $query . '<br>in script: ' . $script . ''); }
				return false;
			}
			
		} else if (substr($query, 0, strlen('USE ')) == 'USE ') {
			//just set current db
			$query = str_replace('USE ', '', $query);
			$query = str_replace('`', '', $query);
			if (DEBUG) { setupLog('query: USE ' . $query . ''); }
			if ( ! mysql_select_db($query) ) {
				_checkMysqlError($link, 'USE ' . $query, $L['setupMysqlErrorUseError'] . ' - ' . $script . ' ' . $k);
				if (DEBUG) { setupLog('execute mysql script returning false for query<br>: ' . $query . '<br>in script: ' . $script . ''); }
				return false;
			}
		
		} else if ( $skip_all_errors ) {
			if (DEBUG) { setupLog('query: ' . $query . ''); }
			if (strlen($query)) {
				if ( ! ($result = mysql_query($query)) ) { 
					_checkMysqlError($link, $query,  ' - ' . $script . ' ' . $k, false); // 4th param is false - no exit on error
					if (DEBUG) { setupLog('execute mysql script continuing after error:<br>: ' . $query . '<br>in script: ' . $script . ''); }
					// continue here (instead of returning false)
				}
			}
		} else if ( 
			(strpos(strtoupper($query), 'ALTER TABLE') !== false) && 
				( 
					(strpos(strtoupper($query), 'ADD INDEX') !== false) 
					|| (strpos(strtoupper($query), 'ADD PRIMARY KEY') !== false) 
					|| (strpos(strtoupper($query), 'DROP KEY') !== false) 
					|| (strpos(strtoupper($query), 'ADD KEY') !== false) 
					|| (strpos(strtoupper($query), 'ADD UNIQUE KEY') !== false) 
				) 
			) {
			// Phil 20051018 - Dont halt on error when adding an index 
			// Phil 20070301 - or primary key
			// Phil 20070824 - or drop key
			//execute query
			if (DEBUG) { setupLog('query: ' . $query . ''); }
			if (strlen($query)) {
				if ( ! ($result = mysql_query($query)) ) { 
					_checkMysqlError($link, $query,  ' - ' . $script . ' ' . $k, false); // 4th param is false - no exit on error
					if (DEBUG) { setupLog('execute mysql script continuing after error:<br>: ' . $query . '<br>in script: ' . $script . ''); }
					// continue here (instead of returning false)
				}
			}
		} else {
			//execute query
			if (DEBUG) { setupLog('query: ' . $query . ''); }
			
			if (strlen($query)) {
				$halt_on_error = true;
				if (strpos(strtoupper($query), 'DELETE FROM') !== false) {
					$halt_on_error = false; // Phil 20051202 Prevent Windows MySQL <= 4	Error: Can't change size of file (Errcode: 2)
				}
				
				if ( ! ($result = mysql_query($query)) ) { 
					_checkMysqlError($link, $query,  ' - ' . $script . ' ' . $k, $halt_on_error);
					if ($halt_on_error) {
						if (DEBUG) { setupLog('execute mysql script returning false for query<br>: ' . $query . '<br>in script: ' . $script . ''); }
						return false;
					}
				}
			}
			
		}
		
	}
	
	if (DEBUG) { setupLog('completed script: ' . $script . ''); }
	
}

// Phil 20051018 Added param $helt_on_error (default true).
// Enables us to continue script execution for errors from certain queries
// (eg ALTER TABLE .. ADD INDEX ...)
function _checkMysqlError($link, $query = '', $extra = '', $halt_on_error = true) {
	global $L;

	if (!$link || strlen(@mysql_error($link)) > 0) {
		
		$messages = array();
		$messages[] =  '<p>';
		$messages[] =  '' . $L['setupMysqlFatalError'] . ':<br>';
		$messages[] =  'Query: ' . $query . '<br>';
		$messages[] =  '<p>Error: ' . ($link ? mysql_error($link) : mysql_error()) . '';
		
		if (strlen($extra)) {
			$messages[] =  '<br>' . $extra . '';
		}
		
		$messages[] =  '</p>';
		
		if (DEBUG) { setupLog('_checkMysqlError: ' . $query . ''); }
		if (DEBUG) { setupLog('_checkMysqlError has messages'); }
		if (DEBUG) { setupLog('_checkMysqlError: ' . ($link ? mysql_error($link) : mysql_error()) . ''); }
		
		if ($halt_on_error) {
			displayMessage($messages);
			exit();
		}
		
	} else {
		if (DEBUG) { setupLog('_checkMysqlError: ' . $query . ''); }
	}
}

function writeBcrmDataDirectory() {
	
}

function testBcrmDataDirectory() {
	
}

// --- Functions used (mainly) by doInstall -----------

// returns file contents as a string, or false
function _readFile($filename){
	if (file_exists($filename) && is_readable($filename)) { 
		// print '<p>file exists and is readable : ' . $filename . '</p>';
		if ($tmpfile = fopen($filename, "r")) {
                $contents = fread($tmpfile, filesize($filename));
                fclose($tmpfile);
                return $contents;
        }
	}
	// print '<p>file does not exist, is not readable, or couldnt be opened : ' . $filename . '</p>';
    return false;
}


// item array needs to contain mysql_host, mysql_username, mysql_password1, mysql_prefix
// returns current version (float) or false
function getCurrentVersionFromDb($item, $link) {  //MCR require link
	global $L;
	
	if (DEBUG) { setupLog('Current version from db function'); }
	
	// First priority: attempt to get single db version (ie version 3.00+)
	//MCR - if single db is populated, return version from there
	$db = $item['mysql_dbname'];
	$table = 'System__version';
	if ( mysql_select_db($db) && tableExists($table)) { // single db
		
		$query = 'SELECT `version` FROM `' . $table . '` LIMIT 1';
		if ( ! ($result = mysql_query($query)) ) { 
			if (DEBUG) { setupLog('Selected single database, couldnt get version'); }
			_checkMysqlError($link, $query, $L['setupMysqlErrorGettingCurrentVersion']);
			return false;
		}
		
	} else {
	
		$db = $item['mysql_prefix'] . 'System';
		$table = 'version';
		if ( mysql_select_db($db) ) { // single db
			$query = 'SELECT `version` FROM `' . $table . '` LIMIT 1';
			if ( ! ($result = mysql_query($query)) ) { 
				if (DEBUG) { setupLog('Selected multi database, couldnt get version'); }
				_checkMysqlError($link, $query, $L['setupMysqlErrorGettingCurrentVersion']);
				return false;
			}	
		} else {
			return '4.69';
		}
		
	}
	
	
	$line = mysql_fetch_array($result, MYSQL_ASSOC);
	$current_version = $line['version'];   //MCR 20040922 'current($line)' gave error if no data
	mysql_free_result($result);
	$current_version = trim($current_version);
	if (empty($current_version)) {
		$current_version = '4.69';
	}
	
	$current_version = trim($current_version);
	
	if (strlen($current_version) > 5) {
		$current_version = substr($current_version, 0, 5);
	}
	return $current_version;
	
}

function getUpgradeVersion() {
	global $BCRM_DOCUMENT_ROOT, $DEBUG_TOOL_UPGRADE_VERSION;
	
	//this block was introduced for testing PHPlets, not used for production
	if ($DEBUG_TOOL_UPGRADE_VERSION) {
		if (DEBUG) { setupLog('Upgrade version (set by DEBUG_TOOL_UPGRADE_VERSION) ' . $DEBUG_TOOL_UPGRADE_VERSION . ''); }
		return $DEBUG_TOOL_UPGRADE_VERSION;
	}
	//
	
	// if (DEBUG) { setupLog('Get upgrade version'); }
	
	// parse the db_structure.sql file to get the version number
	$filename = $BCRM_DOCUMENT_ROOT . '/setup/sql/db_structure.sql';
	
	if (! ($contents = _readFile($filename)) ) {
		if (DEBUG) { setupLog('Get upgrade version - false'); }
		return false; // couldnt get the version number
	}
	// Looking for version number (x.xxx) in: # BrowserCRM database structure version x.xxx (up to 10 chars)
	$contents = stristr($contents, 'version');
	$version = version_floatVal(trim(substr($contents, 8, 10))); // floatVal ensures chars after the number are ignored
	// print '<p>upgrade version: ' . $version . '</p>';
	
	if (DEBUG) { setupLog('Get upgrade version = ' . $version . ''); }
	return $version;
	
}

function version_floatVal($strValue) {
	$floatValue = ereg_replace("(^[0-9]*)(\\.|,)([0-9]*)(.*)", "\\1.\\3", $strValue);
	if (!is_numeric($floatValue)) $floatValue = ereg_replace("(^[0-9]*)(.*)", "\\1", $strValue);
	if (!is_numeric($floatValue)) $floatValue = 0;
	return $floatValue;
}

// Determines current version of BrowserCRM and returns an array of 
// upgrade files in the order which they need to be run
function getUpgradeScripts($item, $existing_version) {
	global $BCRM_DOCUMENT_ROOT;
	
	if (DEBUG) {setupLog('getting upgrade scripts (from existing_version = ' . $existing_version .')');	}

	//for legacy compatability moving from 4.xx to 4.xxx versioning
	//explicit test for very early 4.x series?? 4.00.08?
		
	//check for 4 digit version or last digit '.'
	//4.06 was the last x.xx version, then came 4.061
	if (strlen($existing_version) < 5 ) {
		$existing_version .= '0'; //apend trailing zero		
	} else {
		if (substr($existing_version, 4, 1) == '.') { //if 5th char is '.'
			$existing_version = substr($existing_version, 0, 4) . '0';  //take first 4 chars plus add a zero
		}
	}
	if (DEBUG) {setupLog('getting upgrade scripts (existing_version = ' . $existing_version .')');	}
	
	
	$upgrade_version = getUpgradeVersion(); // the version of this upgrade
	
	if (DEBUG) {setupLog('getUpgradeVersion: ' . $upgrade_version . '');	}

	$dirname = $BCRM_DOCUMENT_ROOT . '/setup/sql';
	
	if (DEBUG) {setupLog('Dirname: ' . $dirname . '');	}

	$dir = opendir( $dirname );
	$files = array();
	
	//get all files in dir with FROM greater than or equal to existing_version && TO less than or equal to upgrade_version
	$versions = array();
	$upgrade_files = array();
	while ($name = readdir($dir)) {
		//echo '<p>' . $name;
		
		//special test here to avoid mistake files that were shipped with early 4.x versions and may be lying on a server
		if (($name != 'upgrade_4.080_to_4.090.sql') && ($name != 'upgrade_4.090_to_4.010.sql')) {
			if (substr($name, 0, 8) == 'upgrade_') {
				$parsed_name = explode('_', $name);
				//print_r($parsed_name);
				if ( ($parsed_name[1] >= $existing_version) && rtrim($parsed_name[3], '.sql') <= $upgrade_version) {
					$versions[] = $parsed_name[1];
					$upgrade_files[$parsed_name[1]] = $name;
				}
			}
		}
	}
	sort($versions); // print_r($versions);
	ksort($upgrade_files); 
	//print('<p>');  print_r($upgrade_files);
	
	return $upgrade_files;
}

/**
 *
 * @author Phil, 20050720
 */
// Determines current version of BrowserCRM and returns an array of 
// upgrade files in the order which they need to be run
function getPhpUpgradeScripts($item, $existing_version) {
	global $BCRM_DOCUMENT_ROOT;
	
	
	if (DEBUG) { setupLog('getting php upgrade scripts (from existing_version = ' . $existing_version .')'); }	
	
	if (substr($existing_version, 4, 1) == '.') { //if 5th char is '.'
		$existing_version = substr($existing_version, 0, 4) . '0';  //take first 4 chars plus add a zero
	}
	
	if ($existing_version < '4.00') {
		if (DEBUG) { setupLog('existing_version is less than 4.00 - not running php upgrade scripts.'); }	
		return array();
	}
	
	$upgrade_version = getUpgradeVersion(); // the version of this upgrade
	
	if (($upgrade_version === false) || empty($upgrade_version)) {
		if (DEBUG) { setupLog('Could not get upgrade version, setting default - 100'); }		
		$upgrade_version = '100'; // ie assume this is the latest version
	}
	
	if (DEBUG) { setupLog('getting php upgrade scripts (upgrade version = ' . $upgrade_version .')'); }

	$dirname = $BCRM_DOCUMENT_ROOT . '/setup/sql/php';
	
	if (DEBUG) { setupLog('PHP upgrade scripts directory: ' . $dirname . '');	}

	$upgrade_files = array();
	
	if (file_exists($dirname) && is_dir($dirname) && is_readable($dirname)) {
		$dir = opendir( $dirname );
		$files = array();
		
		//get all files in dir with FROM greater than or equal to existing_version && TO less than or equal to upgrade_version
		$versions = array();
		$upgrade_files = array();
		while ($name = readdir($dir)) {
			// print '<p>php upgrade dir filename: ' . $name . '</p>';
			
			if (substr($name, 0, 8) == 'upgrade_') {
				$parsed_name = explode('_', $name); // 0'upgrade', 1'from_version', 2'to', 3'to_version', 4'Modulename.sql'
				
				if ( ($parsed_name[1] >= $existing_version) && ($parsed_name[3] <= $upgrade_version) ) { // Phil 20051202
				// if ( ($parsed_name[1] >= $existing_version) && ($parsed_name[3] >= $upgrade_version) ) { // Phil 20051101
					$versions[] = $parsed_name[1];
					// $upgrade_files[$parsed_name[1]] = $name;
					$upgrade_files[] = $name; // Phil 20051202
					if (DEBUG) { setupLog('Including php upgrade script: ' . $name . '');	}
				} else {
					if (DEBUG) { setupLog('Excluding php upgrade script: ' . $name . '');	}	
				}
			}
		}
		sort($versions); // print_r($versions);
		ksort($upgrade_files); 
		// print '<p>upgrade_files: ';  print_r($upgrade_files); print '</p>';
	}
	
	return $upgrade_files;
}
// ----



// Displays a list of languages available for Setup
// ie for each <path>/lang/<language>/Setup.inc
function confirmLanguage() {
	global $PHP_SELF, $language, $L, $BCRM_DOCUMENT_ROOT, $step, $install_guide, $lic, $ver, $error;
	
	//save current $L as this function overwrites the correctly set $L variable
	$OLD_L = $L;
	$default_language = (isset($language) ? $language : 'en');
	
	$languages = array();
	$dirname = $BCRM_DOCUMENT_ROOT . '/lang'; // This is a guess based on default value
	$dir = opendir( $dirname );
	while ($name = readdir($dir)) {
		if ($name != '.' && $name != '..' && $name != 'custom' && is_dir($dirname . '/' . $name) && is_readable($dirname . '/' . $name . '/Setup.inc')) {
			$languages[$name] = $name; // Give language a default title (incase $L['LanguageName'] doesnt exist)
			// if (is_readable($dirname . '/' . $name . '/Setup.inc')) {
			
			if (isset($L['LanguageName'])) { // incase $L['LanguageName'] doesnt exist for this language
				unset($L['LanguageName']); 
			}
			
			@include($dirname . '/' . $name . '/_Global.inc');
			$languages[$name] = $L['LanguageName'] . ' (' . $languages[$name] . ')';
			// }
		}
	}
	//restore $L array
	$L = $OLD_L;
	
	// print_r($languages);

	$messages[] = '<form name="lang" action="' . $PHP_SELF. '" method="get">';
	
	$step++;
	$messages[] = '<input type="hidden" name="step" value="'.$step.'">';
	$messages[] = '<input type="hidden" name="lic" value="'.$lic.'">';
	$messages[] = '<input type="hidden" name="ver" value="'.$ver.'">';
	$messages[] = '<input type="hidden" name="error" value="'.$error.'">';
	
	$messages[] = '
	<table cellpadding="2" cellspacing="0" border="0" width="70%">
	';
	
	
	$messages[] = '
	<tr><th>' . $L['setupSelectLanguage'] .'</th><td>';
	
	//$messages[] = '<p><b>' . $L['setupSelectLanguage'] . ': ' . '</b>&nbsp;&nbsp;&nbsp;&nbsp;';
	$messages[] = '<select name="language">';
	foreach ($languages as $k => $val) {
		$messages[] = '<option value="'.$k.'"'.($k==$default_language ? ' selected' : '').'>'.$val.'</option>';
	}
	$messages[] = '</select>';
	//$messages[] = '<br>&nbsp;<br>';
	$messages[] = '<br>&nbsp;<br>';
	
	$messages[] = '</td></tr>';
	$messages[] = '<tr><th></th><td>';
	$messages[] = '<input type="submit" name="submit" value="' . $L['setupSubmitButton'] . ' &gt" style="width: 100px">';
	$messages[] = '</td></tr>';
	
	$messages[] = '</table>
	';
	
	$messages[] = '</p></form>';
	
	displayMessage($messages);
}

// JACK 20060110 added functions to make structural changes to error messages easier
function printWarnMsg($warnMsg, $fixMsg = NULL) {
	global $L, $explNum;
	if (!isset($explNum)) {
		$explNum = 0;
	}
	
	if (!is_array($warnMsg)) {
		return;
	}
	extract($warnMsg);
	// $type $msg $expl
	$content = '';
	$classes = array(0 => "eCorrect", 1 => "eNoticeTxt", 2 => "eErrorTxt");
	(!isset($type) ? $type = 0 : NULL );
	switch ($type) {
		case 1:
			$lbl = $L['setupNotice'];
			break;
		case 2:
			$lbl = $L['setupError'];
			break;
		case 0:
			$lbl = $L['setupCorrect'];
			break;
	}
	$fixJS = '';
	if (!is_null($fixMsg)) {
		$fixJS .= 'showHide(\'' . $fixMsg . '\', null, null, null);';
	}
	$content .= '<p class="' . $classes[$type] . '">' . '<b>' . $lbl . ':</b>' . ' ' . $msg;
	if (isset($expl)) {
		//MCR $content .= ' &nbsp; &nbsp; <a href="javascript: showHide(\'expl' . $explNum . '\', \'butt' . $explNum . '\', \'Hide \', \'\'); ' . $fixJS . '"><span id="butt' . $explNum . '"></span>' . $L['setupDetailsLink'] . '</a>';
		$content .= ' &nbsp; &nbsp; <a href="javascript: showHide(\'expl' . $explNum . '\', \'butt' . $explNum . '\', \'\', \'\'); ' . $fixJS . '"><span id="butt' . $explNum . '"></span>' . $L['setupDetailsLink'] . '</a>';
	}
	
	 $content .= '</p>';
	 
	 if (isset($expl)) {
	 	$content .= '<div id="expl' . $explNum . '" class="eDetails">';
		foreach ($expl as $v) {
			$content .= '<ul>' . $v . '</ul>';
		}
		$content .= '</div>';
		$explNum++;
	 }
	 
	 return $content;
}

function testServerDisallowWithCurl($url_good, $url_403_1, $url_403_2) {
	
	if (DEBUG) { setupLog('About to read with curl from ' . $url_good); }
	$curl = setupGetDataFromUrlWithCurl($url_good);
	if (DEBUG) { setupLog('Read: ' . $curl); }
	if ($curl == 'Hello World.') {
		//AND not able to read these (403 errors)
		$curl_bad_1 = setupGetDataFromUrlWithCurl($url_403_1);
		
		$curl_bad_2 = setupGetDataFromUrlWithCurl($url_403_2);
		
		if (DEBUG) { setupLog('Read curl_bad_1 ' . $curl_bad_1); }
		if (DEBUG) { setupLog('Read curl_bad_2 ' . $curl_bad_2); }
		
		//if (($curl_bad_1 != 'You should not be seeing this text. This page should be blocked.') && ($curl_bad_2 != 'You should not be seeing this text. This page should be blocked.')) {
		if ((strpos($curl_bad_1, 'You should not be seeing this text. This page should be blocked.') === false) && (strpos($curl_bad_2, 'You should not be seeing this text. This page should be blocked.') === false)) {
			return true;
		}
	} else {
		if (DEBUG) { setupLog('Read curl: <> Hello World.'); }
	}
	return false;
}

function testServerDisallowWithFopen($url_good, $url_403_1, $url_403_2) {
	
	if (DEBUG) { setupLog('calling setupGetDataFromUrlWithFopen'); }
				
	$read_file = setupGetDataFromUrlWithFopen($url_good);
	//echo 'read ' .$read_file;
	if (DEBUG) { setupLog('read file with fopen: ' . $read_file); }
	
	if ($read_file == 'Hello World.') {
		$read_file_bad_1 = setupGetDataFromUrlWithFopen($url_403_1);
		$read_file_bad_2 = setupGetDataFromUrlWithFopen($url_403_2);
		if (DEBUG) { setupLog('Read file_bad_1 ' . $read_file_bad_1); }
		if (DEBUG) { setupLog('Read file_bad_2 ' . $read_file_bad_2); }
		
		if ((strpos($read_file_bad_1, 'You should not be seeing this text. This page should be blocked.') === false) && (strpos($read_file_bad_2, 'You should not be seeing this text. This page should be blocked.') === false)) {
			return true;
		}
	} else {
		if (DEBUG) { setupLog('Read curl: <> Hello World.'); }
	}
	return false;
}


function testWebServer() {
	global $L, $BCRM_DOCUMENT_ROOT, $step, $install_guide, $error, $no_localhost_mysql, $config;
	
	$php_config_errors = 0;
	$php_config_warnings = 0;
	$restart_apache_message = 0;
	
	
	if (DEBUG) { setupLog('Confirm php settings'); }
	
	
	//$messages[] = '<p class="title2">' . $L['setupTestingWebServer'] . '' . '</p>';
	
	
	
	// Shoaib - 20061212 - Establish php version check before installation
	$temp_message = $L['setupPhpVersionTest'] . ' ' . phpversion(); 
	$current_version = phpversion();
	$debug_version = $current_version;
	
	
//if(version_compare($current_version, $debug_version, "eq") == 1) {
	// comment the line below for testing and uncomment the line above
if(version_compare($current_version, "4.1.2", "eq") == 1) {
		$warnMsg['type'] = 2;
		$warnMsg['msg'] = $temp_message;
		$warnMsg['expl'][] = $L['setupPhpVersionUpgrade'];
		//$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		$messages[] = printWarnMsg($warnMsg);
		//echo "Succesful";
		displayMessage($messages);
	} else {
		unset($warnMsg);
		//echo "Version check failed";
		//define('PHP_VERSION', $current_version);

$messages[] = '<span><img src="' . SKIN_PATH . '/1.png" border="0" style="vertical-align:middle"></span>
				<span class="head">' . $L['setupFilePermsCheck'] . ': ' . '</span>
				<div style="padding:4px;"></div>';
		
$messages[] = '<p>' . $L['setupYourInstallPathIs'] . ' ' . $BCRM_DOCUMENT_ROOT . '</p>';
	
	
	// JACK 20060110 - Matt wanted gone
	//$messages[] = '<p>' . $L['setupFileWriteTest'] . ' ' . $BCRM_DOCUMENT_ROOT . '... ';
	
	$file_write_test_error = 0;
	if (is_dir($BCRM_DOCUMENT_ROOT)) {
		$filename = $BCRM_DOCUMENT_ROOT . '/browsercrm_test.txt';
		if ( !$handle = @fopen($filename, "w") ) {
			$warnMsg['type'] = 2;
			$warnMsg['msg'] = $L['setupFileWriteTest'] . $L['setupFileWriteTestCannotWriteCreate'] . ' ' . $filename;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupError'] . '</b>: ' . $L['setupFileWriteTestCannotWriteCreate'] . ' ' . $filename . '</p>';
			$file_write_test_error = 1;
		} else {
			if (!fwrite($handle, 'test content')) {
			$warnMsg['type'] = 2;
			$warnMsg['msg'] = $L['setupFileWriteTest'] . $L['setupFileWriteTestCannotWrite'] . ' ' . $filename;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupError'] . '</b>: ' . $L['setupFileWriteTestCannotWrite'] . ' ' . $filename . '</p>';
				$file_write_test_error = 1;
			} else {
				fclose($handle);
			
				if ( unlink($filename) ) { 
					$warnMsg['msg'] = $L['setupFileWriteTest'] . ' ' . $L['setupFileWriteTestSuccessful'];
					//$messages[] = $L['setupFileWriteTestSuccessful'] . '</p>';
				} else {
					$warnMsg['type'] = 2;
					$warnMsg['msg'] = $L['setupFileWriteTest'] . $L['setupFileWriteTestCannotDelete'] . ' ' . $filename;
					//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupError'] . '</b>: ' . $L['setupFileWriteTestCannotDelete'] . ' ' . $filename . '</p>';
					$file_write_test_error = 1;
				}
			}
		}
	} else {
		$warnMsg['type'] = 2;
		$warnMsg['msg'] = $L['setupFileWriteTest'] . $L['setupDirectoryDoesNotExist'];
		//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupError'] . '</b>: ' . $L['setupDirectoryDoesNotExist'] . '</p>';
		$php_config_errors = 1;
	}
	
	if (($file_write_test_error == 1) || DEV_SHOW_MESSAGES) {
		$php_config_errors = 1;
		$warnMsg['expl'][] = $L['setupFileWriteTestChangePermissions'] . '<br>' . $BCRM_DOCUMENT_ROOT;
		//$messages[] = '<ul>' . $L['setupFileWriteTestChangePermissions'] . '<br>' . $BCRM_DOCUMENT_ROOT . '</ul>';
			
			
		switch (SERVER_OS) { 
			case 'Windows':
				break;
			case 'Trustix':
				$warnMsg['expl'][] = $L['setupFileWriteTestChangePermissionsLinux'];
				$warnMsg['expl'][] = $install_guide['root_dir_chmod_trustix'];
				//$messages[] = '<ul>' . $L['setupFileWriteTestChangePermissionsLinux'] . '</ul>';
				//$messages[] = '<ul>' . $install_guide['root_dir_chmod_trustix'] . '</ul>';
				break;
			case 'Red Hat':
			default:
				$warnMsg['expl'][] = $L['setupFileWriteTestChangePermissionsLinux'];
				$warnMsg['expl'][] = $install_guide['root_dir_chmod'];
				//$messages[] = '<ul>' . $L['setupFileWriteTestChangePermissionsLinux'] . '</ul>';
				//$messages[] = '<ul>' . $install_guide['root_dir_chmod'] . '</ul>';
			
		}
	}
	
	$messages[] = printWarnMsg($warnMsg);
	unset($warnMsg);
	
	
	if (WEB_SERVER != 'IIS') {
					
			$messages[] = '<p>&nbsp;</p>';
			//$messages[] = '<p class="head">' . $L['setupHTAccessCheck'] . ': ' . '</p>';
			$messages[] = '<span><img src="' . SKIN_PATH . '/2.png" border="0" style="vertical-align:middle"></span>
				<span class="head">' . $L['setupHTAccessCheck'] . ': ' . '</span>
				<div style="padding:4px;"></div>';

		
		
				
			//MCR 20040903
			//this htaccess check now triggers a warning not an error & die
			
			//keep auto prepend check for now - just for detecting pre 3.0 installations
			//check for old ./<path>/hub.inc
			
			$auto_prepend_file = ini_get('auto_prepend_file');
			//$auto_prepend_file = 'xz/hub.inc';
			if ($auto_prepend_file) {
				if (strpos($auto_prepend_file, 'hub.inc') > 0) { 
					//get message for upgrading from old version prior to 2.1
					$messages = getReconfigureTextFromOldVersions();
					displayMessage($messages);
				} else {
					//this will fire for bcrm version 3 to 3.06 which was configured with an htaccess file autoprepend
					
					//the previous .htaccess was not overwritten by 'cp' on Brian Fry, so let's remove it manually and copy in our own
					
					if (is_file('../.htaccess')) {
						//MCR 20060608; handle this manually if necessary?
						//unlink('../.htaccess');
						//writeBcrmHtAccessFile();
					}
					
					
				}
			} else {
				
				// echo 'ref: ' . $_SERVER["HTTP_REFERER"] . '<hr>';
				// print_r($_SERVER);
				// echo '<hr>stuff: ' . $_SERVER["PHP_SELF"] . '<hr>';
				
				//test that htaccess is functioning correctly, being read by apache so inc files are not served
				if (isset($_SERVER["HTTP_REFERER"]) && $_SERVER["HTTP_REFERER"]) {
					$url = $_SERVER["HTTP_REFERER"];
					
				} elseif (isset($_SERVER["HTTP_HOST"]) && $_SERVER["HTTP_HOST"] && isset($_SERVER["PHP_SELF"]) && $_SERVER["PHP_SELF"]) {
					//echo 'here';
					
					//this is powweb.com (FreeBSD) setup
					if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"]) {
						$url = 'https://';
					} else {
						$url = 'http://';
					}
					
					$url .= $_SERVER["HTTP_HOST"] . $_SERVER["PHP_SELF"];
				}
				
				$htaccess_confirmed = 0;
				
				if (!$url) {
					if (DEBUG) { setupLog('Unable to establish test url from $_SERVER variable.'); }
				} else {
					//echo '**' .$url . '**';
					$url = substr($url, 0, strpos($url, 'setup') + strlen('setup')) . '';
					$url_403_1 = $url . '/access_test/test.inc';
					$url_403_2 = $url . '/access_test/test.inc.php';
					$url_good = $url . '/access_test/test.php';
					
					$subdir_url_403_1 = $url . '/subdir_htaccess_test/test.inc';
					$subdir_url_403_2 = $url . '/subdir_htaccess_test/test.inc.php';
					$subdir_url_good = $url . '/subdir_htaccess_test/test.php';
					
					
					//echo $url_403_1 . '<br>';
					
					//this is just a reminder for us; happens when you force input a url rather than following the form sequence
					// if (!$_SERVER["HTTP_REFERER"]) {
						// echo '<p class="eInvalidSpan">Notify BrowserCRM Support: no referer</p>';	
					// }
					
					if (DEBUG)	{
						//print_r($_SERVER);
						/*
						echo $_SERVER["HTTP_REFERER"] . '<br>';
						echo $url . '<br>';
						echo setupGetDataFromUrlWithCurl($url) . '<br>';
						echo setupGetDataFromUrlWithFopen($url_403_1) . '<br>';
						echo setupGetDataFromUrlWithFopen($url_403_2) . '<br>';
						*/
					}
					
					if (function_exists('curl_exec')) {
						//should be able to read url
						/*
						if (DEBUG) { setupLog('About to read with curl from ' . $url); }
						$curl = setupGetDataFromUrlWithCurl($url);
						if (DEBUG) { setupLog('Read: ' . $curl); }
						if ($curl == 'You should not be seeing this text. This page should be blocked.') {
							//AND not able to read these (403 errors)
							$curl_bad_1 = setupGetDataFromUrlWithCurl($url_403_1);
							
							$curl_bad_2 = setupGetDataFromUrlWithCurl($url_403_2);
							
							if (DEBUG) { setupLog('Read curl_bad_1 ' . $curl_bad_1); }
							if (DEBUG) { setupLog('Read curl_bad_2 ' . $curl_bad_2); }
							
							//if (($curl_bad_1 != 'You should not be seeing this text. This page should be blocked.') && ($curl_bad_2 != 'You should not be seeing this text. This page should be blocked.')) {
							if ((strpos($curl_bad_1, 'You should not be seeing this text. This page should be blocked.') === false) && (strpos($curl_bad_2, 'You should not be seeing this text. This page should be blocked.') === false)) {
								$htaccess_confirmed = 1;
							}
						} else {
							if (DEBUG) { setupLog('Read curl: <> You should not be seeing this text. This page should be blocked.'); }
						}
						*/
						
						if (testServerDisallowWithCurl($url_good, $url_403_1, $url_403_2)) {
							$htaccess_confirmed = 1;
						} else {
							//test subdir
							if (testServerDisallowWithCurl($subdir_url_good, $subdir_url_403_1, $subdir_url_403_2)) {
								//if ok, it indicates htaccess is allowed so deploy htaccess
								deployHtAccess();
								
								//retest
								if (testServerDisallowWithCurl($url_good, $url_403_1, $url_403_2)) {
									$htaccess_confirmed = 1;
								}
							} else {
								//echo 'no';
							}
						}
						
					} else {
					
						if (DEBUG) { setupLog('No curl_exec function, trying fopen'); }
							
						
						//try fopen 
						if (ini_get('allow_url_fopen') == 1) {
							/*
							if (!($_SERVER['HTTPS'] && PHP_VERSION < '4.3.0')) {
								
								if (DEBUG) { setupLog('calling setupGetDataFromUrlWithFopen'); }
								
								$read_file = setupGetDataFromUrlWithFopen($url);
								//echo 'read ' .$read_file;
								if (DEBUG) { setupLog('read file with fopen: ' . $read_file); }
								
								if ($read_file == 'You should not be seeing this text. This page should be blocked.') {
									$read_file_bad_1 = setupGetDataFromUrlWithFopen($url_403_1);
									$read_file_bad_2 = setupGetDataFromUrlWithFopen($url_403_2);
									if (DEBUG) { setupLog('Read file_bad_1 ' . $read_file_bad_1); }
									if (DEBUG) { setupLog('Read file_bad_2 ' . $read_file_bad_2); }
									
									if ((strpos($read_file_bad_1, 'You should not be seeing this text. This page should be blocked.') === false) && (strpos($read_file_bad_2, 'You should not be seeing this text. This page should be blocked.') === false)) {
										$htaccess_confirmed = 1;
									}
								}
							} else {
								if (DEBUG) { setupLog('https && ver < 4.3.0 so no fopen '); }
								
								//can't fopen over https prior to 4.3.0
								//echo 'can\'t fopen over https in this version of PHP';
							}
							*/
							if (testServerDisallowWithFopen($url_good, $url_403_1, $url_403_2)) {
								$htaccess_confirmed = 1;
							} else {
								//test subdir
								if (testServerDisallowWithFopen($subdir_url_good, $subdir_url_403_1, $subdir_url_403_2)) {
									//if ok, it indicates htaccess is allowed so deploy htaccess
									deployHtAccess();
									
									//retest
									if (testServerDisallowWithFopen($url_good, $url_403_1, $url_403_2)) {
										$htaccess_confirmed = 1;
									}
								} else {
									//echo 'no';
								}
							}
							
							
						} else {
							if (DEBUG) { setupLog('allow_url_fopen is 0 (false)'); }
							
							//can't fopen a url
							//echo 'can\'t open urls';
						}
					
					}
				}
				
				if (!$htaccess_confirmed) {
				
					//$messages[] = '</ul><p>&nbsp;</p>';
					$warnMsg['type'] = 1;
					$warnMsg['msg'] = $L['setupNoWorkingHtAccess1'];
					//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $L['setupNoWorkingHtAccess1'] . '.</p>';
					$warnMsg['expl'][] = $L['setupNoWorkingHtAccess2'];
					
					//<a href="javascript:openWin(\'' . $base_dir . '/setup/php_log.php\');">' . $L['setupPhpInfo'] . '</a>
					$warnMsg['expl'][] = '<a href="javascript:openWin(\'access_test/test.inc.php\');">' . $L['setupNoWorkingHtAccessClickLink'] . '</a>';
					$warnMsg['expl'][] = '<a href="javascript:openWin(\'access_test/test.inc\');">' . $L['setupNoWorkingHtAccessClickLink'] . '</a>';
					/*
					$install_guide['htaccess_test_link'] = '<a href="">';
					$install_guide['htaccess_test_link2'] = '<a href="access_test/test.inc">';
		
					$warnMsg['expl'][] = $install_guide['htaccess_test_link'] . $L['setupNoWorkingHtAccessClickLink'] . '</a>';
					$warnMsg['expl'][] = $install_guide['htaccess_test_link2'] . $L['setupNoWorkingHtAccessClickLink'] . '</a>';
					*/
					
					$warnMsg['expl'][] = $L['setupNoWorkingHtAccess3a'] . ((WEB_SERVER == 'Apache') ? ' ' . $L['setupNoWorkingHtAccess3b'] : '') . '.';
					$warnMsg['expl'][] = $L['setupNoWorkingHtAccess3c'];
					
					//$messages[] = '<ul>' . $L['setupNoWorkingHtAccess2'] . '</ul>';
					//$messages[] = '<ul>' . $install_guide['htaccess_test_link'] . $L['setupNoWorkingHtAccessClickLink'] . '</a></ul>';
					//$messages[] = '<ul>' . $install_guide['htaccess_test_link2'] . $L['setupNoWorkingHtAccessClickLink'] . '</a></ul>';
					//$messages[] = '<ul>' . $L['setupNoWorkingHtAccess3a'] . ((WEB_SERVER == 'Apache') ? ' ' . $L['setupNoWorkingHtAccess3b'] : '') . '.</ul>';
					//$messages[] = '<ul>' . $L['setupNoWorkingHtAccess3c'] . '</ul>';
					//$messages[] = '</ul>'; //<p>&nbsp;</p>';
					
					if (WEB_SERVER == 'Apache') {
						//$messages[] = '<p>' . $L['setupRecommendApacheConfig'] . '</p>';
						
						if (SERVER_OS == 'Red Hat') {
							$warnMsg['expl'][] = $L['setupApacheConfig'];
							$warnMsg['expl'][] = $install_guide['apache_vi_conf_file'];
							//$messages[] = '<ul>' . $L['setupApacheConfig'] . '</ul>';
							//$messages[] = '<ul>' . $install_guide['apache_vi_conf_file'] . '</ul>';
							//$messages[] = '<ul>&nbsp;</ul>';
						}
						$warnMsg['expl'][] = $L['setupDeployHtaccessRename'] . ' default.htaccess';
						$warnMsg['expl'][] = $L['setupDeployHtaccessTo'] . ' .htaccess';
						$warnMsg['expl'][] = $L['setupDeployHtaccessExplanation'];
						
						$warnMsg['expl'][] = $L['setupApacheAllowOverride'];
						$warnMsg['expl'][] = $install_guide['apache_allow_override'];
						
						$restart_apache_message = 1;
					} else {
						$warnMsg['expl'][] = $L['setupOtherWebServerConfigHtaccess'] . '<br>' . $install_guide['file_type_block_list'];
						//$messages[] = '<ul>' . $L['setupOtherWebServerConfigHtaccess'] . '<br>' . $install_guide['file_type_block_list'] . '</ul>';
						
					}
					
					$php_config_warnings = 1;
				} else {
					$warnMsg['msg'] = $L['setupWebServerBlockVerified'];
				}
				
			}
			
	}
	
	$messages[] = printWarnMsg($warnMsg);
	unset($warnMsg);
	
	
	
	
	
	$messages[] = '<p>&nbsp;</p>';
	//$messages[] = '<p class="head">' . $L['setupPhpCheckLibraries'] . ': ' . '</p>';
	$messages[] = '<span><img src="' . SKIN_PATH . '/3.png" border="0" style="vertical-align:middle"></span>
				<span class="head">' . $L['setupPhpCheckLibraries'] . ': ' . '</span>
				<div style="padding:4px;"></div>';

	
	//check for modules mysql
	// 200611 - Removed: imap, pspell
	if ((!function_exists('mysql_connect')) || DEV_SHOW_MESSAGES) {
		$warnMsg['type'] = 2;
		$warnMsg['msg'] = $L['setupFunctionPhpMySqlError'];
		//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupError'] . '</b>: ' . $L['setupFunctionPhpMySqlError'] . '</p>';	
		
		//update switch for Apache module option
		switch (SERVER_OS) { 
			case 'Windows':
				$warnMsg['expl'][] = $L['setupFunctionPhpWindows'];
				//$messages[] = '<ul>' . $L['setupFunctionPhpWindows'] . '</ul>';
				break;
			//case 'Trustix':
				//todo
				//break;
			case 'Red Hat':
				$warnMsg['expl'][] = $L['setupFunctionPhpMySqlHowToFix1'];
				$warnMsg['expl'][] = $L['setupRedHatUp2dateCommand'] . ' "' . $install_guide['php-mysql_install'] . '"';
				//$messages[] = '<ul>' . $L['setupFunctionPhpMySqlHowToFix1'] . '</ul>';
				//$messages[] = '<ul>' . $L['setupRedHatUp2dateCommand'] . ' "' . $install_guide['php-mysql_install'] . '"</ul>';   //TODO what about mod_php4-mysql option
				//break;
			default:
				$warnMsg['expl'][] = $L['setupDownloadFromRpmfind'];
				$warnMsg['expl'][] = $install_guide['php-mysql_install_wget'];
				//$messages[] = '<ul>' . $L['setupDownloadFromRpmfind'] . '</ul>';
				//$messages[] = '<ul>' . $install_guide['php-mysql_install_wget'] . '</ul>';
				$restart_apache_message = 1;
		}
		$php_config_errors = 1;
		
		
	//} else {  //MCR 20060106 broke this else to an explicit <if> block to enable debugging of messaging with DEV_SHOW_MESSAGES
	} else { // JACK 20060110 else required for new warnMSG function
		$warnMsg['msg'] = $L['setupFunctionPhpMySqlConfirmed'];
	}
	
	$messages[] = printWarnMsg($warnMsg);
	unset($warnMsg);
	
	
	if ((function_exists('mysql_connect'))) {
	
		// TODO JACK 20060110 - Not Needed?
		// $messages[] = '<p>' . $L['setupCorrect'] . ': ' . $L['setupFunctionPhpMySqlConfirmed'] . '</p>';
		//print_r($config);
		
		/*
		//sample MySQL messages
		//server not running
		Warning: Can't connect to local MySQL server through socket '/var/lib/mysql/mysql.sock' (2) in /home/www/browsercrm/setup/index.php on line 1504
		
		Warning: MySQL Connection Failed: Can't connect to local MySQL server through socket '/var/lib/mysql/mysql.sock' (2) in /home/www/browsercrm/setup/index.php on line 1504
		
		
		//server running, wrong params
		Warning: Access denied for user: 'xsx@localhost' (Using password: YES) in /home/www/browsercrm/setup/index.php on line 1490
		
		Warning: MySQL Connection Failed: Access denied for user: 'xsx@localhost' (Using password: YES) in /home/www/browsercrm/setup/index.php on line 1490
		
		
		//other
		 Could not connect: Client does not support authentication protocol requested by server; consider upgrading MySQL client
		 
		*/
		if (IS_UPGRADE) {
			$test_host = $config['database']['host'];
		} else {
			$test_host = 'localhost';
		}
		//first test is specifically for client/server incompatibility between 3.23 client and 4.1.x server, try to connect to server to see if is running
		@mysql_connect($test_host, 'root', 'xcdfs9lk'); //junk to make an invalid login, dont use root here
		$mysql_error_message = mysql_error();
		
		if (strpos($mysql_error_message, 'does not support authentication protocol requested by server') || DEV_SHOW_MESSAGES) {  //then wrong client vs server
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $L['setupMysqlError'];
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $L['setupMysqlError'] . '</p>';
			$warnMsg['expl'][] = $mysql_error_message;
			$warnMsg['expl'][] = $L['setupMysqlWrongClientForServer'];
			//$messages[] = '<p class="eInvalidSpan">"' . $mysql_error_message . '"</p>';
			//$messages[] = '<ul>' . $L['setupMysqlWrongClientForServer'] . '</ul>';  //TODO add lang key
			$php_config_warnings = 1;
			
		} else {
		
			//deliberately attempt to connect with false login to see if server is running
			@mysql_connect($test_host, 'xsxjd8i', 'xcdfs9lk'); //junk to make an invalid login
			$mysql_error_message = strtolower(mysql_error());
			
			
			//block to test that mysql is running
			if ((strpos($mysql_error_message, 'access denied') === false) || DEV_SHOW_MESSAGES) {  //then probably no mysql server
				$no_localhost_mysql = 1;  //flag to pass
				
				$warnMsg['type'] = 1;
				$warnMsg['msg'] = $L['setupMysqlError'];
				//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $L['setupMysqlError'] . '</p>';	
				
				//update switch for Apache module option
				if (SERVER_OS == 'Windows') {
					$warnMsg['expl'][] = $L['setupFunctionPhpWindows'];
					//$messages[] = '<ul>' . $L['setupFunctionPhpWindows'] . '</ul>';
				} else {
					
					switch (SERVER_OS) { 
						//case 'Trustix':
							//todo
							//break;
						case 'Red Hat':
							//break;
						default:
							$warnMsg['expl'][] = $L['setupMysqlHowToFix1'];
							//$messages[] = '<ul>' . $L['setupMysqlHowToFix1'] . '</ul>';
							
							if (SERVER_OS == 'Red Hat') {
								$warnMsg['expl'][] = $L['setupRedHatUp2dateCommand'] . '<br>' . $install_guide['mysql_install'];
								//$messages[] = '<ul>' . $L['setupRedHatUp2dateCommand'] . '<br>' . $install_guide['mysql_install'] . '</ul>';   //TODO what about mod_php4-mysql option
							}
							/*MCR 20060428
							$warnMsg['expl'][] = $L['setupMysqlHowToFix2'] . '<br>' . $install_guide['mysql_rpm_q'];
							$warnMsg['expl'][] = $L['setupDownloadFromRpmfind'];
							$warnMsg['expl'][] = $install_guide['mysql_install_wget'];
							$warnMsg['expl'][] = $install_guide['mysql-server_install_wget'];
							$warnMsg['expl'][] = $L['setupMysqlHowToFix3'] . ' "' . $install_guide['mysql-server_start'];
							$warnMsg['expl'][] = $L['setupMysqlHowToFix4'] . ' "' . $install_guide['mysql-server_start_on_boot'] . '"';
							*/
							
							//$messages[] = '<ul>' . $L['setupMysqlHowToFix2'] . '<br>' . $install_guide['mysql_rpm_q'] . '</ul>';
							
							//$messages[] = '<ul>' . $L['setupDownloadFromRpmfind'] . '</ul>';
							//$messages[] = '<ul>' . $install_guide['mysql_install_wget'] . '</ul>';
							//$messages[] = '<ul>' . $install_guide['mysql-server_install_wget'] . '</ul>';
							
							//$messages[] = '<ul>' . $L['setupMysqlHowToFix3'] . ' "' . $install_guide['mysql-server_start'] . '"</ul>';
							
							//$messages[] = '<ul>' . $L['setupMysqlHowToFix4'] . ' "' . $install_guide['mysql-server_start_on_boot'] . '"</ul>';
							
							$restart_apache_message = 1;
					}
				}
				//may be connecting to a separate db machine //$php_config_errors = 1; 
				$php_config_warnings = 1;
				
			} else {
				$warnMsg['msg'] = $L['setupMySqlInstalled'];
				//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $L['setupMySqlInstalled'] . '</p>';
			}
		}
	}
	
	$messages[] = printWarnMsg($warnMsg);
	unset($warnMsg);
	
	// Phil 20061114 - not necessary
	/*
	if ((!function_exists('imap_open')) || DEV_SHOW_MESSAGES) {
		$warnMsg['type'] = 1;
		$warnMsg['msg'] = $L['setupFunctionImapError'];
		//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $L['setupFunctionImapError'] . '</p>';;	
		
		switch (SERVER_OS) { 
			case 'Windows':
				$warnMsg['expl'][] = $L['setupFunctionPhpWindows'];
				//$messages[] = '<ul>' . $L['setupFunctionPhpWindows'] . '</ul>';
				break;
			//case 'Trustix':
				//todo
				//break;
			case 'Red Hat':
				$warnMsg['expl'][] = $L['setupFunctionImapHowToFix1'];
				$warnMsg['expl'][] = $L['setupRedHatUp2dateCommand'] . ' "' . $install_guide['php-imap_install'] . '"';
				//$messages[] = '<ul>' . $L['setupFunctionImapHowToFix1'] . '</ul>';
				//$messages[] = '<ul>' . $L['setupRedHatUp2dateCommand'] . ' "' . $install_guide['php-imap_install'] . '"</ul>';
				//break;
			default:
				$warnMsg['expl'][] = $L['setupDownloadFromRpmfind'];
				$warnMsg['expl'][] = $install_guide['php-imap_install_wget'];
				//$messages[] = '<ul>' . $L['setupDownloadFromRpmfind'] . '</ul>';
				//$messages[] = '<ul>' . $install_guide['php-imap_install_wget'] . '</ul>';
				$restart_apache_message = 1;
		}
		$php_config_warnings = 1;
	} else {
		$warnMsg['msg'] = $L['setupFunctionImapConfirmed'];
		//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $L['setupFunctionImapConfirmed'] . '</p>';
	}
	*/
	
	// $messages[] = printWarnMsg($warnMsg);
	// unset($warnMsg);
	
	// if ($php_config_errors && (sizeof($messages) > 0)) {
		// displayMessage($messages);
	// }
	
	//PHP params check
	//MCR 20060523
	// (since Invender's request) we were incorrectly skipping this test block
	// it is necessary to at least verify the error_reporting setting
	if (1) {
	//if (isset($_GET['check_php_config']) && $_GET['check_php_config']) {
		
		$messages[] = '<p>&nbsp;</p>';
		//$messages[] = '<p class="head">' . $L['setupPhpCheckParams'] . ': ' . '</p>';
		$messages[] = '<span><img src="' . SKIN_PATH . '/4.png" border="0" style="vertical-align:middle"></span>
				<span class="head">' . $L['setupPhpCheckParams'] . ': ' . '</span>
				<div style="padding:4px;"></div>';

		
		//warnings only
		
		//memory_limit
		$temp_message = $L['setupPhpValue'] . ' memory_limit = ' . ini_get('memory_limit');
		$memory_limit = ini_get('memory_limit');
		//memory limit can be blank (= no limit set), -1 (= no limit), or be in format 32M or 32000000
		if ($memory_limit && ($memory_limit != -1) && ((strpos($memory_limit, 'M') && intval(str_replace('M', '', $memory_limit)) < 32) || ( (strpos($memory_limit, 'M') === false) && $memory_limit < 32000000))) { 
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message . ' (' .$L['setupPhpValue'] . ' memory_limit < 32M)';
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . ' (' .$L['setupPhpValue'] . ' memory_limit < 32M)' . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueMemoryLimitHowToFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueMemoryLimitHowToFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message . ' ( >= 32M )';
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . ' ( >= 32M )</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		//file_upload
		$temp_message = $L['setupPhpValue'] . ' file_uploads = ' . ini_get('file_uploads');
		$file_uploads = ini_get('file_uploads');
		//memory limit can be blank (= no limit set), -1 (= no limit), or be in format 16M or 16000000
		if (($file_uploads != 1) || DEV_SHOW_MESSAGES) { 
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message . ' (' .$L['setupPhpValue'] . ' file_uploads <> 1)';
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . ' (' .$L['setupPhpValue'] . ' file_uploads <> 1)' . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueFileUploadsHowToFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueFileUploadsHowToFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message . ' ( =1 )';
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . ' ( =1 )</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		
		//max_execution_time
		$temp_message = $L['setupPhpValue'] . ' max_execution_time = ' . ini_get('max_execution_time');
		$max_execution_time = ini_get('max_execution_time');
	
		// Shoaib 20061219 - execution_time = 0 means unlimited i.e > 300!	
		if ($max_execution_time  != 0){
		if (($max_execution_time < 300) || DEV_SHOW_MESSAGES) { 
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message . ' (' .$L['setupPhpValue'] . ' max_execution_time < 300)';
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . ' (' .$L['setupPhpValue'] . ' max_execution_time < 300)' . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueMaxExecutionTimeHowToFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueMaxExecutionTimeHowToFix'] . '</ul>';  //TODO
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		} 
		}
		else {
			$warnMsg['msg'] = $temp_message . ' ( >= 300 )';
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . ' ( >= 300 )</p>';
		}
		
		if (isset($warnMsg)) {
			$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		}
		unset($warnMsg);
		
		
		
		//upload_max_filesize
		$temp_message = $L['setupPhpValue'] . ' upload_max_filesize = ' . ini_get('upload_max_filesize');
		$upload_max_filesize = ini_get('upload_max_filesize');
		if (($upload_max_filesize && ($upload_max_filesize != -1) && ((strpos($upload_max_filesize, 'M') && intval(str_replace('M', '', $upload_max_filesize)) < 8) || ( (strpos($upload_max_filesize, 'M') === false) && $upload_max_filesize < 8000000))) || DEV_SHOW_MESSAGES) { 
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message . ' (' .$L['setupPhpValue'] . ' upload_max_filesize < 8M)';
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . ' (' .$L['setupPhpValue'] . ' upload_max_filesize < 8M)' . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueUploadMaxFilesizeHowToFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueUploadMaxFilesizeHowToFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message . ' (>= 8M)';
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . ' (>= 8M)</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		
		// error reporting
		$temp_message = $L['setupPhpValue'] . ' error_reporting = ' . ini_get('error_reporting'); 
		if (((ini_get('error_reporting') & E_NOTICE) == E_NOTICE) || DEV_SHOW_MESSAGES) {
			$warnMsg['type'] = 1; //2070529 downgrade to Notice
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueErrorReportingHowToFix'];
			$php_config_warnings = 1;
			//$php_config_errors = 1;   //don't use this - allow setup to proceed
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . '</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		// $error = 'safe_mode_ioncube' may be set by ../index.php for an ioncubed version where run-time loading is being attempted
		// this is the flag to _require_ installation of the loaders	
		$temp_message = $L['setupPhpValue'] . ' safe_mode = ' . ini_get('safe_mode'); 
		if ((ini_get('safe_mode') == '1') || DEV_SHOW_MESSAGES) {
			
			// MCR 20060428
			// need better testing and resolution options for this to be meaningful
			// if ($error == 'safe_mode_ioncube') {
				// $warnMsg['type'] = 2;
			// } else {
				// $warnMsg['type'] = 1;
			// }
			$warnMsg['type'] = 1;
			
			$warnMsg['msg'] = $temp_message;
			//$messages[] = printWarn(($error == 'safe_mode_ioncube' ? '1' : '0'), $temp_message);
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setup' . ($error == 'safe_mode_ioncube' ? 'Error' : 'Notice')  ] . '</b>: ' . $temp_message . '</p>';
			//$messages[] = '<ul>' . $L['setupPhpValueSafeModeFix'] . '</ul>';
			$warnMsg['expl'][] = $L['setupPhpValueSafeModeFix'];
			
			if (!extension_loaded('ionCube Loader')) {
				$warnMsg['expl'][] = $L['setupSafeModeWithIoncube'];
				$warnMsg['expl'][] = $L['setupIoncubeInstallationHelp'];
				//$messages[] = '<ul>' . $L['setupSafeModeWithIoncube'] . '</ul>';
				//$messages[] = '<ul><a href="ioncube-install-assistant.php">' . $L['setupIoncubeInstallationHelp'] . '</a></ul>';
			}
			
			if ($error == 'safe_mode_ioncube') {
				//$php_config_errors = 1;  //require fix before install
				$php_config_warnings = 1; 
			} else {
				$php_config_warnings = 1;
			}
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . '</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		//MCR 20050805; it may be better to make this an 'Error' which must be fixed before installation
		//magic_quotes_gpc
		$temp_message = $L['setupPhpValue'] . ' magic_quotes_gpc = ' . ini_get('magic_quotes_gpc'); 
		if ((!(ini_get('magic_quotes_gpc') == '1')) || DEV_SHOW_MESSAGES) {
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueMagicQuotesGpcFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueMagicQuotesGpcFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		} else {
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . '</p>';
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		//Shoaib 20070118;  checking for magic_quotes_sybase 0
		$temp_message = $L['setupPhpValue'] . ' magic_quotes_sybase = ' . ini_get('magic_quotes_gpc'); 
		if ((!(ini_get('magic_quotes_sybase') == '1')) || DEV_SHOW_MESSAGES) {

			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . '</p>';
			
		} else {
			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueMagicQuotesSyBaseFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueMagicQuotesGpcFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
		//Shoaib 20070118;  checking for magic_quotes_runtime 0
		$temp_message = $L['setupPhpValue'] . ' magic_quotes_runtime = ' . ini_get('magic_quotes_runtime'); 
		if ((!(ini_get('magic_quotes_runtime') == '1')) || DEV_SHOW_MESSAGES) {
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p>' . $L['setupCorrect'] . ': ' . $temp_message . '</p>';+
			
		} else {

			$warnMsg['type'] = 1;
			$warnMsg['msg'] = $temp_message;
			//$messages[] = '<p class="eInvalidSpan"><b>' . $L['setupNotice'] . '</b>: ' . $temp_message . '</p>';
			$warnMsg['expl'][] = $L['setupPhpValueMagicQuotesRuntimeFix'];
			//$messages[] = '<ul>' . $L['setupPhpValueMagicQuotesGpcFix'] . '</ul>';
			$php_config_warnings = 1;
			$php_params_config_warnings = 1;
		}
		
		$messages[] = printWarnMsg($warnMsg, 'phpParamFixSHW');
		unset($warnMsg);
		
		
	
	
	
		// php_params_check	
		if ($php_params_config_warnings) {
			
			$messages[] = '<div class="eDetails" id="phpParamFixSHW"><div class="phpParamsBox">';
			$messages[] = '<ul><b>' . $L['setupPhpValuesHowToFix1'] . ':</b></ul>';
			
			switch (WEB_SERVER) { 
				case 'IIS':
					$messages[] = '<ul>- ' . $L['setupPhpValuesHowToFixPhpIni'] . '</ul>';
					break;
				case 'Apache': 
					//break;
				default:
					$messages[] = '<ul>- ' . $L['setupPhpValuesHowToFix2'] . '</ul>';
					$messages[] = '<ul>- ' . $L['setupPhpValuesHowToFix3'] . '</ul>';
					$messages[] = '<ul>- ' . $L['setupPhpValuesHowToFixPhpIni'] . '</ul>';
					$restart_apache_message = 1;
			}
			$messages[] = '<br><p align="center">' . '<a href="javascript:openWin(\'phpinfo_viewer.php\');">' . $L['setupPhpInfoSectionTitle'] . '</a>' . '</p>';
		
			$messages[] = '</div></div>';
			
			$restart_apache_message = 1;  //if they have fixed via apache conf (or php.ini?), not for htaccess fix
		}
	
	}
	
	//within the app, eg from About page
	if (isset($_GET['report_only']) && $_GET['report_only']) {
		displayMessage($messages);
		exit();
	}
	
	$messages[] = '<p>&nbsp;</p>';
	
	
	if ($php_config_errors) {
		$messages[] = '<p>&nbsp;</p><div class="eButtTxt" align="center"><div>';
		//$messages[] = '<p class="continue"><STRIKE>' . $L['setupNextStep'] . '</strike></p>';
		$messages[] = '<p class="eErrorTxt"><b>' . $L['setupErrorsDetail1'] . '</b></p>';
		if ((WEB_SERVER == 'Apache') && ($restart_apache_message == 1)) {
			$messages[] = '<p>' . $L['setupApacheRestart'] . ((SERVER_OS != 'Windows') ? ' (' . $install_guide['apache_restart'] . ') ' : '') . '.</p>';
		}
		$messages[] = '<p>' . $L['setupErrorsDetail2'] . '</p>';
		//$messages[] = '<p><div align="left" class="eInvalidSpan">* * * * * * *</div></p>';
		$messages[] = '</div>';
		$messages[] = '</div></div>';
	
	} else {
		$step++;
		
		if (IS_UPGRADE) {   //skip Db selection step
			$step++;
		}
		
		$messages[] = '<p>&nbsp;</p><div class="eButtTxt" align="center"><div>';
		$messages[] = getReloadLink($step);
		$messages[] = '</div></div>';
	
		if ($php_config_warnings) {
			$messages[] = '<p>&nbsp;</p><div class="eButtTxt" align="center"><div>';
			//$messages[] = '<p><div align="left" class="eInvalidSpan">* * * * * * *</div></p>';
			$messages[] = '<p>' . $L['setupNoticesDetail1'] . '</p>';
			$messages[] = '<p>' . $L['setupNoticesDetail2'] . '</p>';
			if ((WEB_SERVER == 'Apache') && ($restart_apache_message == 1)) {
				$messages[] = '<p>' . $L['setupApacheRestart'] . ((SERVER_OS != 'Windows') ? ' (' . $install_guide['apache_restart'] . ') ' : '') . '.</p>';
			}
			$messages[] = '<p>' . $L['setupNoticesDetail3'] . '</p>';
			//$messages[] = '<p><div align="left" class="eInvalidSpan">* * * * * * *</div></p>';
			$messages[] = '</div></div>';
			
		} else {
			if (!isset($_GET['check_php_config']) || !$_GET['check_php_config']) {
				header('Location: ./index.php?step=' . $step . getQueryString());
				exit();
			}
		}
	
		
	}
	
	displayMessage($messages);
	
	}
}

function selectDatabaseOption() {
	global $L, $BCRM_DOCUMENT_ROOT, $step, $install_guide, $error;
	
	if (DEBUG) { setupLog('selectDatabaseOption'); }
	
	
	
	$step++;
	$messages[] = '<p class="head">' . $L['setupMysqlDatabaseSelection'] . '</p>';
	
	$messages[] = '<p>' . $L['setupMysqlDbExplanation'] . '</p>';
	$messages[] = '<p>&nbsp;</p>';
	$messages[] = '<p>&nbsp;</p>';
	
	/*
	$messages[] = '&nbsp;<br>';
	$messages[] = getReloadLink($step, 'setupNextStepDbExists', '&existing_db=1');
	$messages[] = '&nbsp;<br>';
	$messages[] = getReloadLink($step, 'setupNextStepNewDb');
	*/
	
	
	$messages[] = '<div class="eButtTxt" align="center"><div>';
	$messages[] = getReloadLink($step, 'setupNextStepDbExists', '&existing_db=1');
	$messages[] = $L['setupMysqlDbExplanation2'];
	$messages[] = '</div></div>';
	
	$messages[] = '<p>&nbsp;</p><div class="eButtTxt" align="center"><div>';
	$messages[] = getReloadLink($step, 'setupNextStepNewDb');
	$messages[] = $L['setupMysqlDbExplanation3'];
	$messages[] = '</div></div>';
	
	displayMessage($messages);
	
}


function getReconfigureTextFromOldVersions() {
	global $L, $install_guide;
	
	if (DEBUG) { setupLog('Reconfigure text'); }
	
	$messages = array();
	
	//Matt: can be English only. Phil: using install_guide here so we can overwrite when not Apache
	$messages[] = '<p><b>' . $install_guide['auto_prepend_error'] . '</b></p>';
	$messages[] = '<p>' . $install_guide['htaccess_apache_conf'] . '</p>';
	$messages[] = '<p>Your Apache config file may be at /etc/httpd/conf/httpd.conf (for RedHat) and can opened in vi using the command</p>';
	$messages[] = '<ul>' . $install_guide['apache_vi_conf_file'] . '</ul>';
	$messages[] = '<p>' . $install_guide['remove_apache_conf_lines'] . '</p>';
	$messages[] = '<ul>
					' . $install_guide['detailed_apache_setup'] . '
					</ul>';
	$messages[] = '<p>' . $install_guide['keep_virtual_host_settings'] . '</p>';
	
	$messages[] = '<p class="eInvalidSpan">All of the above can be removed. You will most likely need to add the following block _after_ any other AllowOverride lines.</p>';
	$messages[] = '<ul>' . $install_guide['apache_allow_override'] . '</ul>';
				
	$messages[] = '<p>Once you have made the changes to the config file, restart Apache with</p>';
	$messages[] = '<ul>' . $install_guide['apache_restart'] . '</ul>';
	$messages[] = '<p>&nbsp;</p>';
	$messages[] = '<p>' . $install_guide['refresh_reload'] . '</p>';
	
	return $messages;
}



// Phil, 20040824
// Uses the current connection.
// Returns number of rows (should be one) or false
function tableExists($table_name) {
	
	$result = @mysql_query('SHOW TABLES LIKE "' . $table_name . '"');
	
	if ($result) {
		return @mysql_num_rows($result);
	}
	
	return false;
}

function setupLog($message) {
	$log_file = dirname(__FILE__) . '/log.txt';
	
	//print '<p>Log file: ' . $log_file . '</p>';
	//echo '<p>' . $message . '</p>';
	
	// error_log('<p>' . $message . '</p>' . "\n", 3, $log_file); // html
	
	//MCR 20040908; need @ for where this page first loads in an installation without write permissions
	@error_log('[' . date("Y-m-d H:i:s") . '] ' . $message . "\n", 3, $log_file); // text
}


/**
 * CURL function to retrieve data from a URL. 
 * Phil - 20040626 optional timeout and show_errors parameters added
 * (timeout may need to be increaded in some cases and showing errors 
 * prevents any header calls because the errors are printed here)
 */
function setupGetDataFromUrlWithCurl($url, $timeout = 10, $show_errors = false) { 
		
	if (!function_exists('curl_exec')) {
		return false;
	}
					
	$ch = curl_init();
	$agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)";
	curl_setopt($ch, CURLOPT_USERAGENT, $agent);

	curl_setopt ($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); // so it will return data into a variable instead of printing out
	curl_setopt($ch,CURLOPT_TIMEOUT,$timeout); // give it a time in seconds to reply
	curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false); //dont validate SSL cert
	$result = curl_exec($ch);

	if (curl_error($ch)) {
		// setupLog("Curl reading $url error %s: %s", curl_errno($ch), curl_error($ch));
		if (DEBUG) { setupLog("Curl reading $url error %s: %s", curl_errno($ch), curl_error($ch)); }	
		//printf("Curl error %s: %s", curl_errno($ch), curl_error($ch));
		//print(' <a href="' . $url . '" target="_blank">This is the url</a><br>');
	}

	curl_close($ch);
	//echo $url . '<br>';	die('cURL says: ' . $result); //mcr
	return $result;
	
}

function setupGetDataFromUrlWithFopen($url) {
	
	//fopen version ; needs php > 4.3.0 for fopen over ssl
	
	if (DEBUG) { setupLog('fopen: ' . $url); }
				
	$handle = @fopen($url, "rb");
	$contents = '';
	//while (!feof($handle)) {
		$contents .= @fread($handle, 8192);
	//	}
	@fclose($handle);
	
	if (DEBUG) { setupLog($contents); }
	
	return $contents;
	
}

function getNewspage($so = false) {
	global $ver, $config, $BCRM_DOCUMENT_ROOT, $step, $error;
	
	$http_referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
	$http_host = (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '');
	$login_lang = ( (isset($config['login']['lang']) && $config['login']['lang']) ? $config['login']['lang'] : '');
	
	$news_content = '';
	$string = 'nt=setup' . ($step ? '-' . $step : '') . ($error ? '-' . $error : '') . '&v=' . $ver . '&nm=' . $http_host . '&rfr=' . $http_referer;
	if ($so) { $string .= '&qt=so'; }
	
	if ($so && $BCRM_DOCUMENT_ROOT && @file_exists($BCRM_DOCUMENT_ROOT . '/' . 'licence/txt/licence.txt')) {
		return '';
	}
	
	$r = base64_encode($string);
	$get = 'lang=' . $login_lang . '&r=' . $r;
	
	$pointer = 'http://news5.browsercrm.com/?' . $get;
	
	if (function_exists('curl_exec')) {
		$news_content = setupGetDataFromUrlWithCurl($pointer . '&iframe=no', 3); //timeout 3 secs;
	} else {
		$fp = @fopen($pointer, 'r');
		$news_content = @fread($fp, 8192);
	}
	return $news_content;
}

?>