#
# STRUCTURE FOR TABLE: Jobs__item
#

CREATE TABLE `Jobs__item` (
  `id` int(11) NOT NULL auto_increment,
  `created` int(11) NOT NULL default '0',
  `creator_id` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  `legacy_id` varchar(64) NOT NULL default '',
  `contact_id` varchar(255) NOT NULL default '',
  `owner_group_id` int(11) NOT NULL default '0',
  `view_group_id` int(11) NOT NULL default '0',
  `edit_group_id` int(11) NOT NULL default '0',
  `admin_group_id` int(11) NOT NULL default '0',
  `type` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  `completion_date` date NOT NULL default '0000-00-00',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `public_description` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `title` (`title`),
  KEY `legacy_id` (`legacy_id`) 
) TYPE=MyISAM;



#
# STRUCTURE FOR TABLE: Jobs__item_seen
#

CREATE TABLE `Jobs__item_seen` (
  `item_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `seen` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`item_id`,`user_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Jobs__status_dropdown
#

CREATE TABLE `Jobs__status_dropdown` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `priority` (`priority`),
  KEY `active` (`active`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Jobs__type_dropdown
#

CREATE TABLE `Jobs__type_dropdown` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `priority` (`priority`),
  KEY `active` (`active`)
) TYPE=MyISAM;


#
# DATA FIELDS FOR MODULE: Jobs
#

INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'id', '', '', '', 0, 'integer', '', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 500, 500, 1, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'title', '', '__Title', '', 0, 'text', '', '', '', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 440, 440, 0, 1, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'legacy_id', '', '__LabelLegacyId', '', 0, 'text', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 880, 880, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'created', '', '__LabelCreated', '', 0, 'date_time', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 960, 960, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'creator_id', '', '__Creator', '', 0, 'dropdown', '__USERS__', '', NULL, 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 965, 965, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'last_update', '', '__LastUpdated', '', 0, 'date_time', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 955, 955, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'active', '', '', '', 0, 'checkbox', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 900, 900, 1, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'contact_id', '', '__Contact', '', 0, 'contact', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 400, 400, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'owner_group_id', '', '__OwnerGroup', '', 0, 'dropdown', '__GROUPS__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 996, 996, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'view_group_id', '', '__ViewGroup', '', 0, 'dropdown', '__GROUPS__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 994, 994, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'edit_group_id', '', '__EditGroup', '', 0, 'dropdown', '__GROUPS__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 995, 995, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'admin_group_id', '', '__AdminGroup', '', 0, 'dropdown', '__GROUPS__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 997, 997, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'type', NULL, '__jobsTypeLabel', '', 0, 'dropdown', '__table(Jobs.type_dropdown)__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 480, 480, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'status', NULL, '__jobsStatusLabel', '', 0, 'dropdown', '__table(Jobs.status_dropdown)__', '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 485, 485, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'completion_date', NULL, '__jobsCompletionDateLabel', '', 0, 'date', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 490, 490, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'description', NULL, '__jobsDescriptionLabel', '', 30, 'long_text', NULL, '', NULL, 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 450, 450, 0, 0, 0, 4, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Jobs__item', 0, 'public_description', NULL, '__jobsPublicDescriptionLabel', '', 30, 'long_text', NULL, '', NULL, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 460, 460, 0, 0, 0, 0, 0);

#
# DATA OPTIONS FOR MODULE: Jobs
#


INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'desktop', 'include', 'title,contact_id,type,status,owner_group_id,completion_date', 1, 0, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'contact_view', 'include', 'title,content', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'edit', '', '', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'list', 'exclude', 'view_group_id,edit_group_id,admin_group_id,public_description,legacy_id', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'mass_list', 'include', 'title,content', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'multi_edit', 'include', 'type,status,completion_date,description,title', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'search', 'include', 'contact_id,type,status,title', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'view', 'exclude', 'public_description', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'public_edit', 'exclude', 'description,legacy_id', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'public_list', 'exclude', 'view_group_id,edit_group_id,admin_group_id,description,legacy_id', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'public_view', 'exclude', 'description,legacy_id', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'search_results', 'include', 'contact_id,type,status,description,title', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Jobs__item', 'mass_edit', 'include', 'contact_id,type,status,completion_date,description,title', 1, 1, 1, 0, 1);

