#
# STRUCTURE FOR TABLE: Tasks__item
#

CREATE TABLE `Tasks__item` (
  `id` int(11) NOT NULL auto_increment,
  `created` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `creator_id` int(11) NOT NULL default '0',
  `contact_id` int(11) NOT NULL default '0',
  `task_datetime` int(11) NOT NULL default '0',
  `priority_id` int(11) NOT NULL default '0',
  `label` varchar(64) NOT NULL default '',
  `content` text NOT NULL,
  `type_id` int(11) default NULL,
  `alert_in_advance` int(11) NOT NULL default '0',
  `alert_end` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  `legacy_id` varchar(64) NOT NULL default '',
  `is_closed` tinyint(1) NOT NULL default '0',
  `date_closed` int(11) NOT NULL default '0',
  `view_group_id` int(11) NOT NULL default '0',
  `edit_group_id` int(11) NOT NULL default '0',
  `owner_group_id` int(11) NOT NULL default '0',
  `admin_group_id` int(11) NOT NULL default '0',
  `alert_on` int(11) NOT NULL default '0',
  `assigned_to_group_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `contact_id` (`contact_id`),
  KEY `active` (`active`),
  KEY `legacy_id` (`legacy_id`), 
  KEY `date_time` (`task_datetime`),
  KEY `tasks_type_id` (`type_id`),
  KEY `creator_id` (`creator_id`),
  KEY `priority_id` (`priority_id`),
  KEY `view_group_id` (`view_group_id`),
  KEY `edit_group_id` (`edit_group_id`),
  KEY `owner_group_id` (`owner_group_id`),
  KEY `admin_group_id` (`admin_group_id`),
  KEY `last_update` (`last_update`)
) TYPE=MyISAM;



#
# STRUCTURE FOR TABLE: Tasks__item_seen
#

CREATE TABLE `Tasks__item_seen` (
  `item_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `seen` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`item_id`,`user_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Tasks__priority_dropdown
#

CREATE TABLE `Tasks__priority_dropdown` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `priority` (`priority`),
  KEY `active` (`active`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Tasks__type_dropdown
#

CREATE TABLE `Tasks__type_dropdown` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` enum('1','0') NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `active` (`active`),
  KEY `priority` (`priority`)
) TYPE=MyISAM;


#
# DATA FIELDS FOR MODULE: Tasks
#

INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'id', '', '', '', 0, 'integer', '', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 400, 400, 1, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'created', '', '__LabelCreated', '', 0, 'date_time', '', '', '', 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 960, 960, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'creator_id', '', '__Creator', '', 0, 'dropdown', '__USERS__', '', '', 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 965, 965, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'contact_id', '', '__Contact', '', 0, 'contact', '', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 790, 790, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'task_datetime', '', '__tasksDateAndTime', '', 0, 'date_time', '', '', '', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 490, 490, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'priority_id', '', '__tasksTaskPriority', '', 0, 'dropdown', '__table(Tasks.priority_dropdown)__', 'tasks_priority_dropdown', '1', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 494, 494, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'label', '', '__tasksTaskTitle', '', 0, 'text', '', '', '', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 410, 410, 0, 1, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'content', '', '__tasksDescription', '', 0, 'long_text', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 501, 414, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'type_id', '', '__tasksTaskType', '__tasksTaskTypeShort', 0, 'dropdown', '__table(Tasks.type_dropdown)__', 'tasks_type_dropdown', '3', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 412, 412, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'alert_in_advance', '', '__tasksAlertInAdvance', '', 0, 'dropdown', '', '', '', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 505, 505, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'alert_end', '', '__tasksAlertEnd', '', 0, 'dropdown', '', '', '', 0, 0, 0, 6, 0, 1, 0, 0, 0, 0, 0, 0, 510, 510, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'active', '', '', '', 0, 'integer', '', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 514, 514, 1, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'alert_on', '', '__tasksAlertOn', '', 0, 'checkbox', '', '', '1', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 511, 511, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'view_group_id', '__PermissionsGroup1Explanation', '__ViewGroup', '', 0, 'dropdown', '__GROUPS__', '', '0', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 994, 994, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'edit_group_id', '', '__EditGroup', '', 0, 'dropdown', '__GROUPS__', '', '0', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 995, 995, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'owner_group_id', '', '__Owner', '', 0, 'dropdown', '__GROUPS__', '', '0', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 996, 996, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'admin_group_id', '', '__AdminGroup', '', 0, 'dropdown', '__GROUPS__', '', '0', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 997, 997, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'is_closed', '', '__Closed', '__tasksStatus', 0, 'checkbox', '', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 515, 515, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'assigned_to_group_id', '', '__AssignedTo', '', 0, 'dropdown', '__GROUPS__', '', '', 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 500, 500, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'last_update', '', '__LastUpdated', '', 0, 'date_time', '', '', '', 0, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 0, 955, 955, 0, 0, 0, 0, 0);
INSERT INTO `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) VALUES ('Tasks__item', 0, 'legacy_id', '', '__LabelLegacyId', '', 0, 'text', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 880, 880, 0, 0, 0, 0, 0);



#
# DATA OPTIONS FOR MODULE: Tasks
#

INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'list', 'include', 'created,creator_id,contact_id,task_datetime,priority_id,label,type_id,is_closed,assigned_to_group_id,Contact__item_custom.franchise,Company__item_custom.alias,Person__item_custom.weddinganniversary,Company__item.employees', 0, 0, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'edit', 'exclude', '', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'view', '', '', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'multi_edit', 'include', 'task_datetime,type_id,label,content,priority_id,content,alert_in_advance,alert_end', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'contact_view', 'include', 'label,content', 0, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'mass_list', 'include', 'id,label,content', 1, 1, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'desktop', 'include', 'label,contact_id,type_id,task_datetime,assigned_to_group_id,', 1, 0, 1, 0, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'export', 'include', 'creator_id,contact_id,task_datetime,priority_id,label,content,type_id,is_closed', 0, 1, 1, 1, 1);
INSERT INTO `SystemDataDefinition__data_options` (`field_table`, `type`, `method`, `option_values`, `exclude_hidden`, `exclude_calculated`, `dropdown_values`, `no_trim`, `active`) VALUES ('Tasks__item', 'search_results', 'include', 'contact_id,label', 0, 1, 1, 0, 1);
