############################################
#
# BrowserCRM database upgrade
#
############################################

USE `browsercrm`;

# Blank entry to ensure the upgrade process is initialised

#reset all user menus

UPDATE `System__dashboard_dropdown` set active = -1 where active = 0;
UPDATE `System__dashboard_dropdown` set active = 0 where active = 1;


# INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('SystemBookmarks', 50, 1, 0);
# INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Contact', 100, 1, 0);

INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Person', 110, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Company', 120, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Calendar', 150, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Tasks', 200, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Opportunities', 250, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Mail', 300, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Memo', 350, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Documents', 400, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Jobs', 450, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('KnowledgeBase', 500, 1, 0);
INSERT INTO `System__dashboard_dropdown` (`name`, `priority`, `active`, `user_id`) VALUES ('Note', 600, 1, 0);

# new type dropdown values

INSERT INTO `Contact__type_dropdown` (`id`, `name`, `priority`, `active`) VALUES ('', '__contactLabelLostProspect', 400, 1);
INSERT INTO `Contact__type_dropdown` (`id`, `name`, `priority`, `active`) VALUES ('', '__contactLabelLostCustomer', 410, 1);

#reset ghost data
UPDATE Contact__item SET url1_content = '' where url1_content = 'http://';
UPDATE Contact__item SET url2_content = '' where url2_content = 'http://';

#remove employee field def
UPDATE `SystemDataDefinition__fields` set `field_table`='oldContact__item' WHERE `field_table`='Contact__item' AND `field_key`='Company__item.employees';


# change priority

update `Contact__relationship_dropdown` set `priority`='170' where `id`='1' AND `name`='__contactRelationshipValueCompetitor';

# change labelling

UPDATE `SystemDataDefinition__fields` set `label`='__companyContactPerson' WHERE `field_table`='Contact__item' AND `field_key`='Company__item.contact_person';
UPDATE `SystemDataDefinition__fields` set `label`='__companyLabelStockCode' WHERE `field_table`='Contact__item' AND `field_key`='Company__item.stock_code';
UPDATE `SystemDataDefinition__fields` set `label`='__companyLabelEmployees' WHERE `field_table`='Contact__item' AND `field_key`='Company__item.employees';
UPDATE `SystemDataDefinition__fields` set `label`='__companyFieldCompany' WHERE `field_table`='Contact__item' AND `field_key`='contact_company';

UPDATE `SystemDataDefinition__fields` set `label`='__personContactName' WHERE `field_table`='Contact__item' AND `field_key`='Person__item.display_name';
UPDATE `SystemDataDefinition__fields` set `label`='__personRoleLabel' WHERE `field_table`='Contact__item' AND `field_key`='Person__item.role';

#change default value
UPDATE `SystemDataDefinition__fields` set `default_value`= '' WHERE `field_table`='Contact__item' AND `field_key`='url1_content';
UPDATE `SystemDataDefinition__fields` set `default_value`= '' WHERE `field_table`='Contact__item' AND `field_key`='url2_content';



# Field priorities

update `SystemDataDefinition__fields` set `label`='__companyLabelName' where `field_table`='Company__item' AND `field_key`='contact_id';

#remove employee field def
UPDATE `SystemDataDefinition__fields` set `field_table`='oldCompany__item' WHERE `field_table`='Company__item' AND `field_key`='employees';

#insert new foreign field defs
insert into `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('Company__item','2','Contact__item.acc_relationship','','Classification','','0','dropdown','__table(Contact.relationship_dropdown)__','',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','610','610','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('Company__item','2','Contact__item.acc_type_id','','Type','','0','dropdown','__table(Contact.type_dropdown)__','',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','600','600','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('Company__item','2','Contact__item.acc_industry','','Industry','','0','dropdown','__table(Contact.industry_dropdown)__','',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','620','620','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('Company__item','2','Contact__item.phone1_content','','Phone 1','','0','text',NULL,'',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','510','510','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('Company__item','2','Contact__item.url1_content','','URL 1','','0','url',NULL,'',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','520','520','0','0','0','0','0');

#change priorities
UPDATE `SystemDataDefinition__fields` set `field_priority`= 550,`field_priority`= 550 WHERE `field_table`='Company__item' AND `field_key`='contact_person';
UPDATE `SystemDataDefinition__fields` set `field_priority`= 650,`field_priority`= 650 WHERE `field_table`='Company__item' AND `field_key`='employee_band';

# Field priorities

update `SystemDataDefinition__fields` set `label`='__personContactName' where `field_table`='Person__item' AND `field_key`='contact_id';


insert into `SystemDataDefinition__fields` (`field_id`, `field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('','Person__item','2','Contact__item.acc_type_id','','__contactFieldType','','0','dropdown','__table(Contact.type_dropdown)__','',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','556','556','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_id`, `field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('','Person__item','2','Contact__item.phone1_content','','__contactAddressPhone','','0','text',NULL,'',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','554','554','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_id`, `field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('','Person__item','2','Contact__item.email1_content','','__contactAddressEmail','','0','email',NULL,'',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','552','500','0','0','0','0','0');
insert into `SystemDataDefinition__fields` (`field_id`, `field_table`, `field_is_custom`, `field_key`, `explanation`, `label`, `list_label`, `list_detail_length`, `type`, `dropdown_values`, `config_key`, `default_value`, `min`, `max`, `maxlength`, `rows`, `width`, `notnull`, `read_only`, `disable_filter`, `csv`, `calculated`, `foreign`, `multi_edit_width`, `field_priority`, `priority_edit`, `hidden`, `display_name`, `display_with_nbsp`, `append_only`, `hide_empty`) values('','Person__item','2','Contact__item.contact_company','','__companyFieldCompany','','0','contact',NULL,'',NULL,'0','0','0','6','0','0','0','0','0','0','1','0','532','500','0','0','0','0','0');


#add exclusions to Person__item list 'data' option

update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'first_name') where `option_values` NOT LIKE '%first_name%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'job_title') where `option_values` NOT LIKE '%job_title%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'salutation') where `option_values` NOT LIKE '%salutation%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'dob') where `option_values` NOT LIKE '%dob%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'ageband') where `option_values` NOT LIKE '%ageband%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'gender') where `option_values` NOT LIKE '%gender%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'spouse') where `option_values` NOT LIKE '%spouse%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'spouse_dob') where `option_values` NOT LIKE '%spouse_dob%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'spouse_phone') where `option_values` NOT LIKE '%spouse_phone%' AND field_table = 'Person__item' AND `type` = 'list';

update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'assistant') where `option_values` NOT LIKE '%assistant%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'assistant_phone') where `option_values` NOT LIKE '%assistant_phone%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'created') where `option_values` NOT LIKE '%created%' AND field_table = 'Person__item' AND `type` = 'list';
update `SystemDataDefinition__data_options` set `option_values` = CONCAT(option_values, ',', 'creator_id') where `option_values` NOT LIKE '%creator_id%' AND field_table = 'Person__item' AND `type` = 'list';

# Field priorities

update `SystemDataDefinition__fields` set `field_priority`='340' where `field_table`='Mail__item' AND `field_key`='action_required';
update `SystemDataDefinition__fields` set `field_priority`='345' where `field_table`='Mail__item' AND `field_key`='checked_out';
update `SystemDataDefinition__fields` set `field_priority`='350' where `field_table`='Mail__item' AND `field_key`='attachments';



# Field priorities

update `SystemDataDefinition__fields` set `type`='long_text' where `field_table`='TemplateNewModule__item' AND `field_key`='content';


UPDATE `System__version` SET `version` = '5.001' LIMIT 1;
