<?php
/**
 * A process-multi menu class
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package WebMAT
 */
 
includeWebMAT('list.inc');

class WebMATStandardProcessMulti extends  WebMATList {
	
	function WebMATStandardProcessMulti($module, $data_option, $post, $get, $table_name = false) {
		parent::WebMATList($module, $data_option, $post, $get, $table_name);
		$this->setClassVariables($module);
	}
	
	function setClassVariables($module) {
		if ($this->form_values['item']['_select_checkbox']) {
			$this->ids_session = md5($module . time());
			$_SESSION[$this->ids_session] = $this->form_values['item']['_select_checkbox'];
		} else {
			$this->ids_session = $this->form_values['ids_session'];
		}
		
		$this->ids = $_SESSION[$this->ids_session];
		
		if (!$this->method = $this->form_values['item']['_process_multi']) {
			$this->method = $this->form_values['item']['method'];
		}
		
		if (!$this->ids) {
			bcrm_unset($_SESSION, $this->ids);
			$this->redirectTo($_SERVER["HTTP_REFERER"]);
			exit();
		}
	}
	
	/**
	 * returns the WebMat type
	 */
	function getWebmatType() {
		return 'process_multi';
	}
	
	
	function setFilters() {
		$this->filters = false;
	}
	
	/**
	 * Checks if for the comfim oprions and sets $_SESSION['return_page']
	 */
	function run() {
		if (!$this->form_values['yes'] && !$this->form_values['no']) {
			// $_SESSION['return_page'] = $_SERVER["HTTP_REFERER"];
			$this->setRefererAsReturnPage();
		}
	}
	
	function main() {
		global $L;
		if ($this->form_values['yes']) {
			switch ($this->method) {
				case 'mass_edit':
					$this->redirectMassEdit();
				break;
				case 'mass_delete':
					$this->redirectMassDelete();
				break;
				default:
					$this->doComfirmOther();
				break;
			}
		}
		if ($this->form_values['no']) {
			$this->redirectBack();
		}
		
		switch ($this->method) {
			case 'mass_edit':
				//$this->showComfirm($L['optionEditItems'], 'mass_edit');
				$this->redirectMassEdit();
			break;
			case 'mass_delete':
				$this->showComfirm($L['optionDeleteItems'], 'mass_delete');
			break;
			case 'multi_edit':
				$this->redirectMultiEdit();
				exit();
			break;
			case 'mass_create': // Phil 20060831
				$this->massCreateSelect();
				exit();
			break;
			case 'select_ids':
				$this->redirectIds();
				exit();
			break;
			case 'select_contacts':
				$this->selectContacts();
				exit();
			break;
			case 'mailmerge':
				$this->mailmergeContacts();
				exit();
			break;
			case 'quickexport': //Syed
				$this->redirectQuickExport();
				exit();
			case 'export':
				$this->redirectExport();
				exit();
			default:
				$this->doOther();
			break;
		}
	}
	
	function doOther() {
		$this->redirectBack();
	}
	
	function doComfirmOther() {
		$this->redirectBack();
	}
	
	function redirectTo($return_page) {
		header('location: ' . $return_page);
		exit();
	}
	
	function redirectBack() {
		$this->redirectTo($_SESSION['return_page']);
		exit();
	}
	
	function redirectMassEdit() {
		$link_href = str_replace('%ids%', $this->ids_session, $this->getFileSetHref('mass_edit'));
		$this->redirectTo($link_href);
	}
	
	function redirectMassDelete() {
		$link_href = str_replace('%ids%', $this->ids_session, $this->getFileSetHref('mass_delete'));
		$this->redirectTo($link_href);
		exit();
	}
	
	function redirectMultiEdit() {
		$link_href = $this->getFileSetHref('multi_edit') . '?method=session&values=' . 
			$this->ids_session;
		$this->redirectTo($link_href);
		exit();
	}
	
	/**
	 * If there are contacts to use, this function displays the mass create select form.
	 * Otherwise the browser is redirected back (to the referring page).
	 * This function exits the application.
	 * @author Phil
	 * 20060831
	 */
	function massCreateSelect() {
		// print '<div>massCreateSelect</div>';
		$session_ids = $this->setContactsIds(); // populates SESSION variable, return is false or session_ids (key for SESSION[session_ids])
		if ($session_ids && is_array($_SESSION[$session_ids]) && count($_SESSION[$session_ids])) {
			// print '<div>contact session id: ' . $session_ids . ' count: ' . count($_SESSION[$session_ids]) . '</div>'; print_r($_SESSION[$session_ids]); print '<hr>'; exit();
			// exit();
			$this->displayMassCreateSelectMenu($session_ids);
		}
		$this->redirectTo($_SERVER["HTTP_REFERER"]);
		exit();
	}
	
	function displayMassCreateSelectMenu($session_ids) {
		$mass_create_menu = getWebMATObject(
			'WebMATMenu',
			'Contact', 
			array(
				'piece_identifier' => 'masscreateselect'
			)
		);
		$mass_create_menu->setContactSessionId($session_ids);
		$mass_create_menu->main(true);
		exit();
	}
	
	function redirectIds() {
		$link_href = '';
		if ($str_pos = strpos($_SESSION['return_page'], '?')) {
			$link_href .= substr($_SESSION['return_page'], 0, $str_pos);
		} else {
			$link_href .= $_SESSION['return_page'];
		}
		if ($this->form_values['item']['contact_id']) {
			$contact_id = '&contact_id=' . $this->form_values['item']['contact_id'];
		} else {
			$contact_id = '';
		}
		$link_href .= '?ids_session=' . $this->ids_session . $contact_id;
		$this->redirectTo($link_href);
		exit();
	}
	
	/**
	 * If there are contacts to use, this function redirect the browser to the email-merge form.
	 * Otherwise the browser is redirected back (to the referring page).
	 * This function exits the application.
	 * @author Phil
	 * 20050506
	 */
	function mailmergeContacts() {
		$session_ids = $this->setContactsIds(); // populates SESSION variable, return is false or session_ids (key for SESSION[session_ids])
		
		if ($session_ids) {
			$link_href = $this->getMailmergeRedirectLink($session_ids);
			$this->redirectTo($link_href);
			exit();
		}
		$this->redirectTo($_SERVER["HTTP_REFERER"]);
		exit();
	}
	
	function redirectQuickExport() {
		$link_href = str_replace('%ids%', $this->ids_session, $this->getFileSetHref('quickexport'));
		$this->redirectTo($link_href);
		exit();
	}

	function redirectExport() {
		$link_href = str_replace('%ids%', $this->ids_session, $this->getFileSetHref('export'));
		$link_href = str_replace('%table%', $this->getTableName(), $link_href);
		$this->redirectTo($link_href);
		exit();
	}
	
	/**
	 * If there are contacts to redirect to, this function will attempt to do so.
	 * Otherwise the browser is redirected back (to the referring page).
	 * This function exits the application.
	 * @author Phil
	 * 20050506
	 */
	function selectContacts() {
		
		$session_ids = $this->setContactsIds(); // populates SESSION variable, return is false or session_ids (key for SESSION[session_ids])
		
		if ($session_ids) {
			$link_href = $this->getContactRedirectLink($session_ids);
			$this->redirectTo($link_href);
			exit();
		}
		$this->redirectTo($_SERVER["HTTP_REFERER"]);
		exit();
	}
	
	/**
	 * @author Phil
	 * 20050506
	 */
	function getContactRedirectLink($session_ids) {
		global $SERVICES;
		$SERVICES->getService('Config');
		$link_href = str_replace('?parent_id=%contact_id%', '', $SERVICES->config->getModuleHref('Contact', 'list', 0, 'item'));
		// Phil 20051125
		$link_href = str_replace('?contact_company=%contact_id%', '', $link_href);
		
		$link_href .= '?ids_session=' . $this->ids_session;
		// print '<p>' . $link_href . '</p>';
		return $link_href;
	}
	
	/**
	 * @author Phil
	 * 20050506
	 */
	function getMailmergeRedirectLink($session_ids) {
		global $SERVICES;
		$SERVICES->getService('Config');
		$link_href = $SERVICES->config->getModuleHref('Mail', 'mailmerge', 0, 'item');
		$link_href .= '?ids_session=' . $this->ids_session;
		return $link_href;
	}
	
	/**
	 * Grabs contact items from the selected items in the current database table
	 * These are stored on the server in a session.
	 * @return mixed $return_value Either $ids_session the session variable name, or boolean false (no contacts)
	 * @author Phil Calder
	 */
	function setContactsIds() {
		
		if (is_object($this->db_functions)) {
			$contact_fields = explode(',', $this->form_values['item']['contact_fields']);
			if (count($contact_fields)) {
				
				$dtf = array('id' => array('where' => 'id IN (' . implode(',', $this->ids) . ')'));
				$this->db_functions->setDesignTimeFilters($dtf);
				$items = $this->db_functions->getItems();
				$contacts = array();
				foreach ($items as $k => $item) {
					foreach ($contact_fields as $v) {
						if ($item[$v]) {
							$contacts[$item[$v]] = $item[$v];
						}
					}
				}
				
				if (is_array($contacts) && count($contacts)) {
					$_SESSION[$this->ids_session] = $contacts;
					return $this->ids_session;
				}
				
			}
			
			return false;

		}
	}
	
	function showComfirm($message, $method) {
		$message = $message . ' (' . count($this->ids) . ')';
		$this->language_overwrite['description'] = $message;
		$this->method = $method;
		
		//$ids = implode(',', $this->ids);
		//$this->db_functions->setDesignTimeFilters( array('id' => array('where' => '0')) );
		
		// $content = '';
		// $content .= $this->output->getBeginTable();
		// $content .= $this->getTitleContent();
		// $content .= $this->getDescriptionContent();
		// $content .= $this->getConfirmContent();
		// //MCR quickpage($content);//parent::main(true));
		// $content .= $this->output->getEndTable();
		
		// Phil 20060130 WIP
		
		$content = '';
		$content .= $this->output->getBeginTable('mainTbl', false);
		
		$content .= $this->output->getBeginDataCell(false);
		$content .= $this->getTitleContent();
		$content .= $this->output->getEndDataCell();
		
		$content .= $this->output->getBeginDataCell(false);
		$content .= $this->getDescriptionContent();
		$content .= $this->output->getEndDataCell();
		
		$content .= $this->output->getBeginDataCell(false);
		$content .= $this->getConfirmContent();
		$content .= $this->output->getEndDataCell();
		
		$content .= $this->getPagingRow();
		
		$content .= $this->output->getEndTable(false);
		
		
		$this->output->addToBody($content);
		$this->output->display();
		
		exit();
	}
	
	/**
	 * returns the title row array
	 * 
	 * Changed to remove some links
	 * 
	 * @param string $contact_id the contact id if required
	 * @return string a string containing the menu items
	 */
	function getTitleRowLinks() {
		$title_links = parent::getTitleRowLinks();
		$title_links['bookmark'] = 'off';
		bcrm_unset($title_links, 'new');
		return $title_links;
	}
	
	//Removing links etc.
	/**
	 * returns a checkbox used for selecting rows
	 * 
	 * Chnaged to disable the select checkbox
	 * 
	 * @param string $id the item id
	 * @return array the checkbox
	 */
	function getItemCheckbox($id = false) {
		return false;
	}
	
	/**
	 * Adds the edit and delete links to the display row
	 * 
	 * changed to remove the item links
	 * 
	 * @param array $table_row 
	 * @param string $id  as item id
	 * @return array a blank arrak
	 */
	function getItemLinks($table_row, $item){
		if (is_array($table_row)) {
			return $table_row;
		}
		return array();
	}
	
	/**
	 * returns the second menu row
	 * 
	 * changed to remove the extra links
	 * 
	 * @return array a blank arrak
	 */
	function getExtraItemLinks($id, $item = array()) {
		return array();
	}
	
	/*
	 * returns the filter row
	 * 
	 * changed to remove the filter row
	 * 
	 * @param string $filter the filter info
	 * @return bol
	 */
	// function getFilterRow($filter) {
		// return false;
	// }
	
	/**
	 * Calculates a calculated value
	 * 
	 * Overridden, to ingore calculated fields
	 * 
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues($dd_item, $item) {}
	
	
	/**
	 * Gets the header row from the output class
	 * 
	 * changed to remove the header row
	 * 
	 * @param array $table_lables
	 * @param array $sort
	 * @return string the header row
	 */
	function getSubTableHeader($table_labels, $sort) {}
	
	
	/**
	 * Returns the title row
	 *
	 * List page titles consist of title text and title row links (no  'new' links)
	 * 
	 * @return string the title row
	 * @author Phil Calder
	 */
	function getTitleContent() {
		return $this->output->getTitleRow(
			$this->getTitleText(), 
			$this->getTitleRowLinks()
		);
	}
	
	/**
	 * Gets the submit buttons and form (Yes - No)
	 *
	 * @return string with the paging row
	 */
	function getConfirmContent() {
		global $L, $SERVICES;
		$php_self = $SERVICES->getGlobal('php_self');
		
		$comfirm = $this->output->getBeginForm($php_self . '?ids_session=' . $this->ids_session);
		$comfirm .=  $this->output->getHtmlField(
			array(
				'field_key'=>'method', 
				'type'=>'hidden', 
				'value' => $this->method
			)
		);
		
		// $comfirm .=  $this->output->getTextRow(
			// $this->output->getHtmlSubmit($L['Yes'], 'yes') . 
			// $this->output->getHtmlSubmit($L['No'], 'no')//, 
			// //3, 
			// //'style="text-align:center;"'
		// );
		// Phil 20060223
		$comfirm .=  '<div style="text-align:center">' . $this->output->getHtmlSubmit($L['Yes'], 'yes') . ' &nbsp ' . $this->output->getHtmlSubmit($L['No'], 'no') . '</div>';
		$comfirm .= $this->output->getEndForm(); 
		
		return $comfirm;
	}
	
}
?>